Package: iCheck
Type: Package
Title: QC Pipeline and Data Analysis Tools for High-Dimensional
        Illumina mRNA Expression Data
Version: 1.40.0
Date: 2016-11-17
Authors@R: c(person("Weiliang", "Qiu", role=c("aut", "cre"),
                     email = "stwxq@channing.harvard.edu"),
             person("Brandon", "Guo", role=c("aut", "ctb"),
                     email = "brandowonder@gmail.com"),
             person("Christopher", "Anderson", role = c("aut", "ctb"),
                     email = "christopheranderson84@gmail.com"),
             person("Barbara", "Klanderman", role = c("aut", "ctb"),
                     email = "BKLANDERMAN@partners.org"),
             person("Vincent", "Carey", role = c("aut", "ctb"),
                     email = "stvjc@channing.harvard.edu"),
             person("Benjamin", "Raby", role = c("aut", "ctb"),
                     email = "rebar@channing.harvard.edu")
            )
Author: Weiliang Qiu [aut, cre],
        Brandon Guo [aut, ctb],
        Christopher Anderson [aut, ctb],
        Barbara Klanderman [aut, ctb],
        Vincent Carey [aut, ctb],
        Benjamin Raby [aut, ctb]
Maintainer: Weiliang Qiu <stwxq@channing.harvard.edu>
Depends: R (>= 3.2.0), Biobase, lumi, gplots
Imports: stats, graphics, preprocessCore, grDevices, randomForest,
        affy, limma, parallel, GeneSelectMMD, rgl, MASS, lmtest,
        scatterplot3d, utils
Suggests:
biocViews: GeneExpression, DifferentialExpression, Microarray,
        Preprocessing, DNAMethylation, OneChannel, TwoChannel,
        QualityControl
Description: QC pipeline and data analysis tools for high-dimensional
        Illumina mRNA expression data.
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2025-10-30 04:32:10 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/iCheck
git_branch: RELEASE_3_22
git_last_commit: 109cb15
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29

======
icheck
======

"Because syntax checking should happen on file writes, not VCS commits"

quick (or not so quick) and dirty tool to run syntax checking and doc tests
on python code in a separate screen window

Features
---------
* Syntax check files
* Doc test files
* Call a command on syntax failures
* terminal bell
* filter files by hashbang and globs
* color output with tty detection
* multiple output formats (oneline, short and long)
* Supports python2 and python3

This program was mainly written to assist me in developing python code and 
letting me know a couple of seconds before i try and run my program that there 
are basic syntax mistakes in the code.

to achieve this inotify is used to wait for files to be written to and then if 
all pre conditions are fine (globs and hashbangs) then a syntax check is 
executed. on an error a message is printed and it moves on to the next file

By using the 'bell' facility the window running check does not have to be 
visible to the programmer and instead a message will be printed in the message 
line on error indicating attention may be required, allowing screen to be used 
as the windowing component of a flexible IDE setup

Examples
---------
To check a directory for file changes and run syntax checks on file save try 
the following command

    $ icheck -b ~/code/icheck/icheck/

This will 'ring the bell' in the terminal on file changes that are 
syntactically incorrect. in screen this causes a 'bell in window x' message to 
be displayed at the bottom of the screen for all files in the directory

To limit ourselves to just scanning .py files (sounds like a good idea!) we can 
add a filter based on filename with the '-g' flag

    $ icheck -b -g '\*.py' ~/code/icheck/icheck/

Optionally we can filter based on the hash-bang at the beginning of the file 
with '-s' this defaults to looking for the string 'python' however this can be 
changed by specifying it after the '-s' flag. This is applied in an 'AND' 
fashion with the '-g' flag so that the file extension AND the shebang need to 
match. if only one detection method is desired then only use one flag or 
optionally use neither detection and specify exactly which files you want to 
watch (ie specifying files on the cmdline rather than the directory they are 
contained in)
    
    
Limitations
------------
* At this point in time file watching is not recursive, creating directories 
  does not cause them to be watched. It is assumed that the project layout that 
  you are watching is mostly static for the time being. to watch 
  sub-directories try the command below

    $ icheck ~/code/icheck/icheck ~/code/icheck/icheck/\*/

# gene-wise linear model for log2 differences
# By default, formula = ~1
# The intercept is what we are interested in.
# The non-nominal covariates should be mean-centered
# to get correct effect size for the intercept.

lmFitPaired<-function(
  esDiff,
  formula=~1,
  pos.var.interest = 0,
  pvalAdjMethod="fdr", 
  alpha=0.05, 
  probeID.var="ProbeID", 
  gene.var="Symbol", 
  chr.var="Chromosome",
  verbose = TRUE)
{
  tt<-inputChecking(
    pvalAdjMethod=pvalAdjMethod, 
    es=esDiff, 
    probeID.var=probeID.var,
    gene.var=gene.var, 
    chr.var=chr.var)

  diffDat<-tt$dat
  pDat<-tt$pDat
  fDat<-tt$fDat
  probeIDs=tt$probeIDs
  geneSymbols=tt$geneSymbols
  chr=tt$chr

  # some times designMat will lose some subjects
  # because these subjects containing missing values
  # Hence, we need to know which rows dropped
  pDat2<-pDat
  rownames(pDat2)<-1:nrow(pDat2)

  if(is.null(formula))
  {
    designMat<-matrix(rep(1, ncol(diffDat)), ncol=1)
    rownames(designMat)<-1:nrow(designMat)
    colnames(designMat)<-"(Intercept)"
  } else {
    flist = as.list(formula)
    if (length(flist) > 1)
    {
      if(flist[[2]]!=1)
      { # get design matrix
        designMat<-model.matrix(formula, data=pDat2)
      } else {
        designMat<-matrix(rep(1, ncol(diffDat)), ncol=1)
        rownames(designMat)<-1:nrow(designMat)
        colnames(designMat)<-"(Intercept)"
      }
    } else {
      cat("Examples of formula are ~1 or ~cov1+cov2\n")
      stop("formula not correct.\n")
    }
  }

  rn<-as.numeric(rownames(designMat))
  # remove possible dropped subjects from expression data
  diffDat<-diffDat[,rn,drop=FALSE]
  rownames(designMat)<-colnames(diffDat)

  if(verbose)
  {
    cat("Running lmFit for paired data ...\n")
  }
  fit = lmFit(diffDat, designMat)

  if(verbose)
  { cat("Running eBayes...\n") }
  ebFit = eBayes(fit)

  ####
  # prepare output
  ####
  if(verbose)
  { cat("Preparing output...\n") }

  # unsorted pvalue matrix
  pvalMat.unsorted<-ebFit$p.value
  if(is.null(dim(pvalMat.unsorted)))
  {
    pvalMat.unsorted<-matrix(pvalMat.unsorted, ncol=1)
    colnames(pvalMat.unsorted)<-"(Intercept)"
  }  
  rownames(pvalMat.unsorted)<-featureNames(esDiff)

  # unsorted moderate t-test statistic matrix
  statMat.unsorted <- ebFit$t
  if(is.null(dim(statMat.unsorted)))
  {
    statMat.unsorted<-matrix(statMat.unsorted, ncol=1)
    colnames(statMat.unsorted)<-"(Intercept)"
  }  

  rownames(statMat.unsorted)<-featureNames(esDiff)

  # check if the covariate of interest is a factor
  # or interaction term with more than 2 levels
  tmp<-checkCovariate(
    formula=formula, 
    cn.designMat=colnames(designMat), 
    pos.var.interest=pos.var.interest,
    formulaType="right")

  var.interest<-tmp$var.interest
  colDesignMat<-tmp$colDesignMat

  if(is.null(dim(pvalMat.unsorted)))
  {
    pvalMat.unsorted<-matrix(pvalMat.unsorted, ncol=1)
    statMat.unsorted<-matrix(statMat.unsorted, ncol=1)
  }  
  pval<-pvalMat.unsorted[, colDesignMat, drop=FALSE]
  stats<-statMat.unsorted[, colDesignMat, drop=FALSE]

  len<-length(colDesignMat)
  if(len>1)
  {
    # take the minimum p-value and its test statistic 
    pval<-apply(pval, 1, min, na.rm=TRUE)
    stats<-apply(stats, 1, function(x) { 
      absx<-abs(x)
      pos<-which(absx == max(absx, na.rm=TRUE))
      return(x[pos[1]])
    })
    if(verbose)
    {
      cat("\n************************\n")
      cat("Warning: the covariate of interest ", var.interest, " is a factor\n")
      cat("or interaction term with more than 2 levels!\n") 
      cat("Only the smallest p-value will be output!\n")
      cat("Better to run the function lkhWrapper!\n")
      cat("************************\n")
    }
  }

  res<-outputFunc(
    pval=pval, 
    stats=stats, 
    pvalAdjMethod=pvalAdjMethod,
    probeIDs=probeIDs, 
    geneSymbols=geneSymbols, 
    chr=chr, 
    pvalMat.unsorted=pvalMat.unsorted,
    statMat.unsorted=statMat.unsorted, 
    dat=diffDat, 
    alpha=alpha,
    formula = formula,
    var.interest = var.interest,
    verbose=verbose)

  res$ebFit=ebFit 

  invisible(res)
}

# es is a LumiBatch object
LumiBatch2Table<-function(
  es, 
  probeID.var="ProbeID",
  gene.var="Symbol",
  chr.var="Chromosome",
  sep=",", 
  quote=FALSE,
  filePrefix="test", 
  fileExt="csv")
{
  dat<-exprs(es)
  pDat<-pData(es)
  fDat<-fData(es)
  detect<-lumi::detection(es)
  
  idMat<-fDat[,c(probeID.var, gene.var, chr.var)]
  
  dat<-cbind(idMat, dat)
  colnames(dat)[1]="probeID"
  
  
  fileName.dat<-paste(filePrefix, "_exprs.", fileExt, sep="")
  write.table(dat, file=fileName.dat, sep=sep, row.names=FALSE, col.names=TRUE, quote=quote)
  
  if( !is.null(detect))
  {
    detect<-cbind(idMat, detect)
    colnames(detect)[1]="probeID"
    fileName.detect<-paste(filePrefix, "_detection.", fileExt, sep="")
    write.table(detect, file=fileName.detect, sep=sep, row.names=FALSE, col.names=TRUE, quote=quote)
  }
  
  fileName.pdat<-paste(filePrefix, "_pDat.", fileExt, sep="")
  write.table(pDat, file=fileName.pdat, sep=sep, row.names=FALSE, col.names=TRUE, quote=quote)
  
  # some times fDat=NULL
  if(!is.null(fDat))
  {
    fileName.fdat<-paste(filePrefix, "_fDat.", fileExt, sep="")
    write.table(fDat, file=fileName.fdat, sep=sep, row.names=FALSE, col.names=TRUE, quote=quote)
  }
}

### R code from vignette source 'iCheck.Rnw'

###################################################
### code chunk number 1: iCheck.Rnw:53-126
###################################################
  library(iCheck)

  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  # generate sample probe data 
  set.seed(1234567)
  es.sim = genSimData.BayesNormal(nCpGs = 110, 
    nCases = 20, nControls = 20,
    mu.n = -2, mu.c = 2,
    d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
    outlierFlag = FALSE, 
    eps = 1.0e-3, applier = lapply) 
  print(es.sim)

  # create replicates
  dat=exprs(es.sim)
  dat[,1]=dat[,2]
  dat[,3]=dat[,4]
  

  exprs(es.sim)=dat
  es.sim$arrayID=as.character(es.sim$arrayID)
  es.sim$arrayID[1]=es.sim$arrayID[2]
  es.sim$arrayID[3]=es.sim$arrayID[4]
  es.sim$arrayID[5:8]="Hela"

  # since simulated data set does not have 'Pass_Fail',
  #  'Tissue_Descr', 'Batch_Run_Date', 'Chip_Barcode',
  #  'Chip_Address', 'Hybridization_Name', 'Subject_ID', 'gender'
  # we generate them now to illustrate the R functions in the package 

  es.sim$Hybridization_Name = paste(es.sim$arrayID, 1:ncol(es.sim), sep="_")
  # assume the first 4 arrays are genetic control samples
  es.sim$Subject_ID = es.sim$arrayID

  es.sim$Pass_Fail = rep("pass", ncol(es.sim))

  # produce genetic control GC samples
  es.sim$Tissue_Descr=rep("CD4", ncol(es.sim))
  # assume the first 4 arrays are genetic control samples
  es.sim$Tissue_Descr[5:8]="Human Hela Cell"

  es.sim$Batch_Run_Date = 1:ncol(es.sim)
  es.sim$Chip_Barcode = 1:ncol(es.sim)
  es.sim$Chip_Address = 1:ncol(es.sim)

  es.sim$gender=rep(1, ncol(es.sim))
  set.seed(12345)
  pos=sample(x=1:ncol(es.sim), size=ceiling(ncol(es.sim)/2), replace=FALSE) 
  es.sim$gender[pos]=0


  # generate sample probe data 
  es.raw = es.sim[-c(1:10),]
  print(es.raw)
  
  # generate QC probe data 
  es.QC = es.sim[c(1:10),]

  # since simulated data set does not have 'Reporter_Group_Name'
  #  we created it now to illustrate the usage of 'plotQCCurves'.
  fDat=fData(es.QC)
  fDat$Reporter_Group_Name=rep("biotin", 10)
  fDat$Reporter_Group_Name[3:4]="cy3_hyb"
  fDat$Reporter_Group_Name[5:6]="housekeeping"
  fDat$Reporter_Group_Name[7:8]="low_stringency_hyb"
  fData(es.QC)=fDat

  print(es.QC)
  


###################################################
### code chunk number 2: iCheck.Rnw:137-138
###################################################
print(table(es.raw$Pass_Fail, useNA="ifany"))


###################################################
### code chunk number 3: iCheck.Rnw:143-149
###################################################
pos<-which(es.raw$Pass_Fail != "pass")
if(length(pos))
{
  es.raw<-es.raw[, -pos]
  es.QC<-es.QC[, -pos]
}


###################################################
### code chunk number 4: iCheck.Rnw:162-185
###################################################

     plotQCCurves(
         esQC=es.QC,
         probes = c("biotin"), #"cy3_hyb", "housekeeping"),
           #"low_stringency_hyb"),
         labelVariable = "subjID",
         hybName = "Hybridization_Name",
         reporterGroupName = "Reporter_Group_Name",
         requireLog2 = FALSE,
         projectName = "test",
         plotOutPutFlag = FALSE,
         cex = 1,
         ylim = NULL,
         xlab = "",
         ylab = "log2(intensity)",
         lwd = 3,
         mar = c(10, 4, 4, 2) + 0.1,
         las = 2,
         cex.axis = 1,
         sortFlag = TRUE,
         varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat = c("%m/%d/%Y", NA, NA)
       )  


###################################################
### code chunk number 5: iCheck.Rnw:225-245
###################################################

     R2PlotFunc(
         es=es.raw,
         hybName = "Hybridization_Name",
         arrayType = "GC",
         GCid = c("128115", "Hela", "Brain"),
         probs = seq(0, 1, 0.25),
         col = gplots::greenred(75),
         labelVariable = "subjID",
         outFileName = "test_R2_raw.pdf",
         title = "Raw Data R^2 Plot",
         requireLog2 = FALSE,
         plotOutPutFlag = FALSE,
         las = 2,
         keysize = 1,
         margins = c(10, 10),
         sortFlag = TRUE,
         varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat=c("%m/%d/%Y", NA, NA)
       )  


###################################################
### code chunk number 6: iCheck.Rnw:254-268
###################################################
print(table(es.raw$Tissue_Descr, useNA="ifany"))

# for different data sets, the label for GC arrays might
# be different.
pos.del<-which(es.raw$Tissue_Descr == "Human Hela Cell")
cat("No. of GC arrays=", length(pos.del), "\n")

if(length(pos.del))
{
  es.raw<-es.raw[,-pos.del]
  es.QC<-es.QC[,-pos.del]
  print(dims(es.raw))
  print(dims(es.QC))
}


###################################################
### code chunk number 7: iCheck.Rnw:276-296
###################################################

     R2PlotFunc(
         es=es.raw,
         arrayType = c("replicates"),
         GCid = c("128115", "Hela", "Brain"),
         probs = seq(0, 1, 0.25),
         col = gplots::greenred(75),
         labelVariable = "subjID",
         outFileName = "test_R2_raw.pdf",
         title = "Raw Data R^2 Plot",
         requireLog2 = FALSE,
         plotOutPutFlag = FALSE,
         las = 2,
         keysize = 1,
         margins = c(10, 10),
         sortFlag = TRUE,
         varSort=c("Subject_ID", "Hybridization_Name", "Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat=c(NA, NA, "%m/%d/%Y", NA, NA)
       )  



###################################################
### code chunk number 8: iCheck.Rnw:312-321
###################################################
    densityPlots(
      es = es.raw, 
      requireLog2 = FALSE,
      myxlab = "expression level", 
      datExtrFunc = exprs, 
      fileFlag = FALSE, 
      fileFormat = "ps", 
      fileName = "densityPlots_sim.ps")



###################################################
### code chunk number 9: iCheck.Rnw:347-364
###################################################
     quantilePlot(
         dat=exprs(es.raw),
         fileName,
         probs = c(0, 0.05, 0.25, 0.5, 0.75, 0.95, 1),
         plotOutPutFlag = FALSE,
         requireLog2 = FALSE,
         sortFlag = TRUE,
         cex = 1,
         ylim = NULL,
         xlab = "",
         ylab = "log2(intensity)",
         lwd = 3,
         main = "Trajectory plot of quantiles\n(sample arrays)",
         mar = c(15, 4, 4, 2) + 0.1,
         las = 2,
         cex.axis = 1
         )


###################################################
### code chunk number 10: iCheck.Rnw:374-392
###################################################
# note we need to take log2 transformation
# if requireLog2 = TRUE.
requireLog2 = FALSE
if(requireLog2)
{  
  minVec<-apply(log2(exprs(es.raw)), 1, min, na.rm=TRUE)
  # suppose the cutoff is 0.5
  print(sum(minVec< 0.5))
  pos.del<-which(minVec<0.5)

  cat("Number of gene probes with outlying expression levels>>",
  length(pos.del), "\n")
  if(length(pos.del))
  {
    es.raw<-es.raw[-pos.del,]
  }
}



###################################################
### code chunk number 11: iCheck.Rnw:407-432
###################################################

     plotSamplep95p05(
         es=es.raw,
         labelVariable = "memSubj",
         requireLog2 = FALSE,
         projectName = "test",
         plotOutPutFlag = FALSE,
         cex = 1,
         ylim = NULL,
         xlab = "",
         ylab = "",
         lwd = 1.5,
         mar = c(10, 4, 4, 2) + 0.1,
         las = 2,
         cex.axis=1.5,
         title = "Trajectory of p95/p05",
         cex.legend = 1.5,
         cex.lab = 1.5,
         legendPosition = "topright",
         cut1 = 10,
         cut2 = 6,
         sortFlag = TRUE,
         varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat = c("%m/%d/%Y", NA, NA),
         verbose = FALSE)


###################################################
### code chunk number 12: iCheck.Rnw:441-454
###################################################
p95<-quantile(exprs(es.raw), prob=0.95)
p05<-quantile(exprs(es.raw), prob=0.05)

r<-p95/p05
pos.del<-which(r<6)
print(pos.del)

if(length(pos.del))
{
  es.raw<-es.raw[,-pos.del]
  es.QC<-es.QC[,-pos.del]
}



###################################################
### code chunk number 13: iCheck.Rnw:471-480
###################################################

     pcaObj<-getPCAFunc(es=es.raw,
                labelVariable = "subjID",
                requireLog2 = FALSE,
                corFlag = FALSE
              
               
     )



###################################################
### code chunk number 14: iCheck.Rnw:487-508
###################################################

     pca2DPlot(pcaObj=pcaObj,
               plot.dim = c(1,2),
               labelVariable = "memSubj",
               outFileName = "test_pca_raw.pdf",
               title = "Scatter plot of pcas (memSubj)",
               plotOutPutFlag = FALSE,
               mar = c(5, 4, 4, 2) + 0.1,
               lwd = 1.5,
               equalRange = TRUE,
               xlab = NULL,
               ylab = NULL,
               xlim = NULL,
               ylim = NULL,
               cex.legend = 1.5,
               cex = 1.5,
               cex.lab = 1.5,
               cex.axis = 1.5,
               legendPosition = "topright"
             
               )


###################################################
### code chunk number 15: iCheck.Rnw:517-519
###################################################
tt <- es.raw
es.q<-lumiN(tt, method="quantile")


###################################################
### code chunk number 16: iCheck.Rnw:532-560
###################################################
     pcaObj<-getPCAFunc(es=es.q,
                labelVariable = "subjID",
                requireLog2 = FALSE,
                corFlag = FALSE
                
     )


     pca2DPlot(pcaObj=pcaObj,
               plot.dim = c(1,2),
               labelVariable = "memSubj",
               outFileName = "test_pca_raw.pdf",
               title = "Scatter plot of pcas (memSubj)\n(log2 transformed and quantile normalized)",
               plotOutPutFlag = FALSE,
               mar = c(5, 4, 4, 2) + 0.1,
               lwd = 1.5,
               equalRange = TRUE,
               xlab = NULL,
               ylab = NULL,
               xlim = NULL,
               ylim = NULL,
               cex.legend = 1.5,
               cex = 1.5,
               cex.lab = 1.5,
               cex.axis = 1.5,
               legendPosition = "topright"
               )



###################################################
### code chunk number 17: iCheck.Rnw:588-600
###################################################

res.limma=lmFitWrapper(
  es=es.q, 
  formula=~as.factor(memSubj), 
  pos.var.interest = 1,
  pvalAdjMethod="fdr", 
  alpha=0.05, 
  probeID.var="probe", 
  gene.var="gene", 
  chr.var="chr", 
  verbose=TRUE)



###################################################
### code chunk number 18: iCheck.Rnw:610-626
###################################################

res.glm=glmWrapper(
  es=es.q,
  formula = xi~as.factor(memSubj), 
  pos.var.interest = 1,
  family=gaussian,
  logit=FALSE, 
  pvalAdjMethod="fdr", 
  alpha = 0.05, 
  probeID.var = "probe", 
  gene.var = "gene", 
  chr.var = "chr", 
  applier=lapply,
  verbose=TRUE 
  )



###################################################
### code chunk number 19: iCheck.Rnw:634-650
###################################################

res.lkh=lkhrWrapper(
  es=es.q,
  formulaReduced = xi~as.factor(memSubj), 
  formulaFull = xi~as.factor(memSubj)+gender, 
  family=gaussian,
  logit=FALSE, 
  pvalAdjMethod="fdr", 
  alpha = 0.05, 
  probeID.var = "probe", 
  gene.var = "gene", 
  chr.var = "chr", 
  applier=lapply,
  verbose=TRUE 
  )



###################################################
### code chunk number 20: iCheck.Rnw:665-681
###################################################

    boxPlots(
      resFrame = res.limma$frame, 
      es = es.sim, 
      col.resFrame = c("probeIDs", "stats", "pval", "p.adj"), 
      var.pheno = "memSubj", 
      var.probe = "probe", 
      var.gene = "gene", 
      var.chr = "chr", 
      nTop = 20, 
      myylab = "expression level", 
      datExtrFunc = exprs, 
      fileFlag = FALSE, 
      fileFormat = "ps", 
      fileName = "boxPlots_sim.ps")



###################################################
### code chunk number 21: iCheck.Rnw:690-707
###################################################

    # regard memSubj as continuos for illustration purpose
    scatterPlots(
      resFrame = res.limma$frame, 
      es = es.sim, 
      col.resFrame = c("probeIDs", "stats", "pval", "p.adj"), 
      var.pheno = "memSubj", 
      var.probe = "probe", 
      var.gene = "gene", 
      var.chr = "chr", 
      nTop = 20, 
      myylab = "expression level", 
      datExtrFunc = exprs, 
      fileFlag = FALSE, 
      fileFormat = "ps", 
      fileName = "scatterPlots_sim.ps")



###################################################
### code chunk number 22: sessionInfo
###################################################
toLatex(sessionInfo())

###########
# modified on Nov. 17, 2016
#  (1) revised 'scatterPlots', 'boxPlots' so that
#      the user can choose not output 'p.adj' in the subtitle
#  (2) add input options 'outcomeFlag' and 'fitLineFlag' to 'scatterPlots'
#
# modified on March 31, 2016
#  (1) added functions 'scatterPlots', 'boxPlots', 'densityPlots'
#
############
# modified on Aug 20, 2015
#  (1) deleted un-used functions: pcaPlotFunc
#
# modified on Feb 14, 2014
#  (1) fixed a bug in  'getPCAFunc': 
#       forgot updating 'es' after deleting probes with missing values
#  
# modified on Jan 11, 2014
#  (1) revised 'getPCAFunc': set 'corFlag = FALSE'
#
# modified on Sept 29, 2013
#  (1) revised 'getPCAFunc': added line
#      dat=na.omit(dat)
#    right before the calling of the function prcompt

# modified on July 21, 2010
#  (1) added argument 'labelVariable' to the functions 'plotQCCurves'
#       and 'plotCurves'
# created on July 3, 2010
#  (1) read in data
#
###########

# plot trajectories of QC probe expression levels across arrays
# for specific QC probes: biotin, cy3_hyb, housekeeping, 
# low_stringency_hyb, etc. 
plotQCCurves<-function(esQC, 
    probes=c("biotin", "cy3_hyb", "housekeeping",
    "low_stringency_hyb", "signal", "p95p05"), 
    labelVariable="subjID",
    hybName = "Hybridization_Name",
    reporterGroupName = "Reporter_Group_Name",
    requireLog2=TRUE, 
    projectName="test", 
    plotOutPutFlag=FALSE, 
    cex=1, 
    ylim=NULL, 
    xlab="", 
    ylab="intensity", 
    lwd=3, 
    mar=c(10, 4, 4, 2) + 0.1,
    las=2,
    cex.axis=1,
    sortFlag = TRUE,
    varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
    timeFormat=c("%m/%d/%Y", NA, NA),
    ...)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }
  cat("probes>>\n"); print(probes); cat("\n");

  if(sortFlag)
  { esQC<-sortExpressionSet(esQC, varSort, timeFormat) }

  datQC<-getDatColnames(esQC, hybName = hybName, labelVariable = labelVariable, 
    requireLog2=requireLog2)
  qcNames<-as.character(fData(esQC)[, c(reporterGroupName)])
  
  nProbes<-length(probes) 
  for(k in 1:nProbes)
  {
    cat("\n********** k=", k, " *******\n")     
    cat("QC probe=", probes[k], "\n")
    probe.k=match.arg(probes[k], choices=c("biotin", 
      "cy3_hyb", "housekeeping",
      "low_stringency_hyb", "signal", "p95p05"))

    if(probe.k == "signal")
    {
      probs<-c(0.05, 0.25, 0.5, 0.75, 0.95)
      qMat<-apply(datQC, 2, quantile, na.rm=TRUE, prob=probs)

      #if(plotOutPutFlag)
      #{
         outFileName<-paste(projectName, "_", probe.k, "_traj_plot.pdf", sep="")
      #  postscript(outFileName, horizontal=TRUE, paper="letter")
      #} 
      curveNames<-paste("Signal P", round(probs*100,2),sep="")
      plotCurves(qMat, curveNames=curveNames, 
        fileName=outFileName,
        plotOutPutFlag=plotOutPutFlag,
        requireLog2=FALSE, cex=cex,
        ylim=ylim, xlab=xlab, ylab=ylab,
        main=probe.k, lwd=lwd, mar=mar, cex.axis=cex.axis, ...)
      #if(plotOutPutFlag)
      #{
      #  dev.off()
      #}
    } else if (probe.k == "p95p05") {
      qMat<-apply(datQC, 2, quantile, na.rm=TRUE, prob=c(0.05, 0.95))
      ratio<-qMat[2,]/qMat[1,]
      p<-length(ratio)
      if(plotOutPutFlag)
      {
        outFileName<-paste(projectName, "_", probe.k, "_traj_plot.pdf", sep="")
        #postscript(outFileName, horizontal=TRUE, paper="letter")
        pdf(outFileName, width=756, height=576, paper="letter")
      } 
      if(requireLog2)
      { 
        ylab2="log2(p95/p05)"
      } else {
        ylab2="p95/p05"
      }
      par(mar=mar)
      plot(x=1:p, y=ratio, type="l",
        xlab=xlab, ylab=ylab2,
        main="p95/p05", cex=cex,
        ylim=ylim, col=1, lty=1, lwd=lwd, axes=FALSE,
        cex.axis=cex.axis,...)
      box()
      axis(side=2, cex.axis=1, ...)
      axis(side=1, at=1:p, labels=colnames(datQC), las=las, 
        cex.axis=cex.axis, ...)
      par(mar=c(5, 4, 4, 2) + 0.1)
      
      if(plotOutPutFlag)
      {
        dev.off()
      }
    } else {
      pos<-which(qcNames==probe.k)
      len.pos<-length(pos)
      if(len.pos)
      {
        esQC2<-esQC[pos,]
        curveNames<-paste(probe.k, 1:len.pos, sep=" ")
        #if(plotOutPutFlag)
        #{
          outFileName<-paste(projectName, "_", probe.k, "_traj_plot.pdf", sep="")
        #  postscript(outFileName, horizontal=TRUE, paper="letter")
        #} 
        
        datQC2<-getDatColnames(esQC2, hybName = hybName, labelVariable = labelVariable, 
          requireLog2=requireLog2)

        plotCurves(dat=datQC2, curveNames=curveNames,
          fileName = outFileName,
          plotOutPutFlag = plotOutPutFlag,
          requireLog2=FALSE, cex=cex,
          ylim=ylim, xlab=xlab, ylab=ylab, 
          main=probe.k, lwd=lwd, mar=mar, cex.axis=cex.axis, ...)
        #if(plotOutPutFlag)
        #{
        #  dev.off()
        #}
      } else {
        cat("Error! no QC probe", probe.k, " in QC data!\n")
        stop("QC probe not in QC data!\n")
      }
    }
  }
}


# plot trajectories of ratio of 95th percentile to 5th percentile
# of sample probe expression levels across arrays
plotSamplep95p05<-function(es,
    labelVariable="subjID",
    hybName = "Hybridization_Name",
    requireLog2=FALSE,
    projectName="test",
    plotOutPutFlag=FALSE,
    cex=1,
    ylim=NULL,
    xlab="",
    ylab="",
    lwd=1.5,
    mar=c(10, 4, 4, 2) + 0.1,
    las=2,
    cex.axis=1.5,
    title="Trajectory of p95/p05",
    cex.legend=1.5,
    cex.lab=1.5,
    legendPosition="topright",
    cut1=10,
    cut2=6,
    sortFlag = TRUE,
    varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
    timeFormat=c("%m/%d/%Y", NA, NA),
    verbose=FALSE,
    ...)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  if(sortFlag)
  { es<-sortExpressionSet(es, varSort, timeFormat) }

  dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable,
    requireLog2=requireLog2)

  arrayNames.u<-unique(colnames(dat))

  labels<-as.numeric(as.factor(colnames(dat)))
  labels.u<-unique(labels)
  nClusters<-length(labels.u)


  qMat<-apply(dat, 2, quantile, na.rm=TRUE, prob=c(0.05, 0.95))
  ratio<-qMat[2,]/qMat[1,]
  if(verbose)
  {
    cat("sum(ratio<10)>>\n"); print(sum(ratio<10)); cat("\n");
    cat("which(ratio<10)>>\n"); print(which(ratio<10)); cat("\n");
  }

  tmpos<-which(ratio<cut1)
  if(length(tmpos))
  {
    labels2<-labels[tmpos]
    if(verbose)
    { cat("labels for arrays with ratio <", cut1, ">>\n")
      print(table(labels2, useNA="ifany"))
      cat("\n")

      cat("p95 for these arrays>>\n")
      print(qMat[2,tmpos])
      cat("\n")
  
      cat("p05 for these arrays>>\n")
      print(qMat[1,tmpos])
      cat("\n")
  
  
      cat("p95/p05 for these arrays>>\n")
      print(ratio[tmpos])
      cat("\n")
    }
  }

  tmpos<-which(ratio<cut2)
  if(length(tmpos))
  {
    labels2<-labels[tmpos]
    if(verbose)
    {
      cat("labels for arrays with ratio <", cut2, ">>\n")
      print(table(labels2, useNA="ifany"))
      cat("\n")
  
      cat("p95 for these arrays>>\n")
      print(qMat[2,tmpos])
      cat("\n")
  
      cat("p05 for these arrays>>\n")
      print(qMat[1,tmpos])
      cat("\n")
  
  
      cat("p95/p05 for these arrays>>\n")
      print(ratio[tmpos])
      cat("\n")
    }  
  }


  p<-length(ratio)
  if(requireLog2 && is.null(ylab))
  {
    ylab2="log2(p95/p05)"
  } else {
    ylab2="p95/p05"
  }
  if(plotOutPutFlag)
  {
    outFileName<-paste(projectName, "_Samplep95p05_traj_plot.pdf", sep="")
    pdf(outFileName, width=756, height=576, paper="letter")
  }
  par(mar=mar)
  mycols <- grDevices::rainbow(nClusters)
  plot(x=1:p, y=ratio, type="l",
    xlab=xlab, ylab=ylab2,
    main=title, cex=cex,
    ylim=ylim, col=1, pch=labels, lty=1, lwd=lwd, axes=FALSE,
    ...)
  if(labelVariable!="subjID")
  {
    points(x=1:p, y=ratio,
      col=mycols[labels], pch=labels, lwd=lwd,
      ...)
  }
  box()
  axis(side=2, cex.axis=1, ...)
  axis(side=1, at=1:p, labels=colnames(dat), las=las, cex.axis=cex.axis, ...)
  abline(h=cut1, col=1)
  abline(h=cut2, col=1)
  if(labelVariable!="subjID")
  {
    legend(x=legendPosition, legend=arrayNames.u,
      col=unique(mycols[labels]), pch=labels.u,
      cex=cex.legend, bty="o")
  }

  par(mar=c(5, 4, 4, 2) + 0.1)
  if(plotOutPutFlag)
  {
    dev.off()
  }
  res<-list(qMat=qMat, ratio=ratio)
  invisible(res)
}



# plot trajectories of probe expression levels across arrays
plotCurves<-function(dat, curveNames, fileName, 
    plotOutPutFlag=FALSE,
    requireLog2=FALSE, cex=1,
    ylim=NULL, xlab="", ylab="intensity", lwd=3,
    main="Trajectory plot", mar=c(10, 4, 4, 2) + 0.1, las=2, 
    cex.axis=1, ...)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  if(requireLog2)
  {
    dat<-log2(dat)
  } 
  if(is.null(ylim))
  { 
    ylim<-range(c(dat), na.rm=TRUE) 
    len.interval<-ylim[2]-ylim[1] 
    ylim[2]<-ylim[2]+len.interval/5
  }
  arrayNames<-colnames(dat)

  n<-nrow(dat)
  p<-ncol(dat)

  if(plotOutPutFlag)
  {
    #postscript(fileName, horizontal=TRUE, paper="letter")
    pdf(fileName, width=756, height=576, paper="letter")
  } 
  mycols <- grDevices::rainbow(n)
  par(mar=mar)
  plot(x=1:p, y=dat[1,], type="l",
    xlab=xlab, ylab=ylab,
    main=main, cex=cex,
    ylim=ylim, col=mycols[1], lty=1, lwd=lwd, axes=FALSE, las=las,
    ...)
  box()
  axis(side=2, cex.axis=1, ...)
  axis(side=1, at=1:p, labels=arrayNames, las=2, cex.axis=cex.axis, ...)
  if(n>1)
  {
    for(i in 2:n)
    {
      lines(x=1:p, y=dat[i,], col=mycols[i], lty=i, lwd=lwd)
    }
  }
  legend("topright", legend=curveNames,
    col=mycols, lty=1:n, cex=cex)
  par(mar=c(5, 4, 4, 2) + 0.1)
  if(plotOutPutFlag)
  {
    dev.off()
  } 
 
}

# plot trajectories of probe expression levels across arrays
quantilePlot<-function(dat, fileName, 
    probs=c(0, 0.05, 0.25, 0.5, 0.75, 0.95, 1),
    plotOutPutFlag=FALSE,
    requireLog2=FALSE, 
    sortFlag=TRUE,
    cex=1,
    ylim=NULL, xlab="", ylab="intensity", lwd=3,
    main="Trajectory plot of quantiles", mar=c(15, 4, 4, 2) + 0.1, las=2, 
    cex.axis=1)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  if(requireLog2)
  {
    dat<-log2(dat)
  } 
  if(sortFlag)
  {
    # sort columns by MAD
    cat("***** Arrays were sorted by MAD (median absolute deviation)!\n")
    tt.mad<-apply(dat, 2, mad, na.rm=TRUE)
    ttmat<-cbind(tt.mad, 1:length(tt.mad))
    ttmat2<-ttmat[order(ttmat[,1]),]
    dat<-dat[, ttmat2[,2]]
  }
  qMat<-apply(dat, 2, quantile, probs=probs, na.rm=TRUE)
  if(is.null(ylim))
  { 
    ylim<-range(c(qMat), na.rm=TRUE) 
    #len.interval<-ylim[2]-ylim[1] 
    #ylim[2]<-ylim[2]+len.interval/5
  }
  arrayNames<-colnames(dat)
  curveNames<-paste(probs*100, "%", sep="")

  n<-nrow(qMat) # number of quantiles
  p<-ncol(qMat) # number of arrays

  if(plotOutPutFlag)
  {
    #postscript(fileName, horizontal=TRUE, paper="letter")
    pdf(fileName, width=756, height=576, paper="letter")
  } 
  par(mar=mar)
  #mycols <- grDevices::rainbow(n)
  mycols <- 1:n
  plot(x=1:p, y=qMat[1,], type="l",
    xlab=xlab, ylab=ylab,
    main=main, cex=cex,
    ylim=ylim, col=mycols[1], lty=1, lwd=lwd, axes=FALSE, las=las,
    )
  box()
  axis(side=2, cex.axis=1)
  axis(side=1, at=1:p, labels=arrayNames, las=2, cex.axis=cex.axis)
  if(n>1)
  {
    for(i in 2:n)
    {
      lines(x=1:p, y=qMat[i,], col=mycols[i], lty=i, lwd=lwd)
    }
  }
  legend("topright", legend=curveNames,
    col=mycols, lty=1:n, cex=cex)
  par(mar=c(5, 4, 4, 2) + 0.1)
  if(plotOutPutFlag)
  {
    dev.off()
  } 
  invisible(qMat) 
}

# es is an ExpressionSet object
# labelVariable -- the name of a phenotype data variable use to
#                label the arrays in the dendrogram.
getPCAFunc<-function(es, 
  labelVariable="subjID",
  hybName = "Hybridization_Name",
  requireLog2=TRUE,
  corFlag = FALSE
)
{
  dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable,
    requireLog2=requireLog2)

  aa<-apply(dat, 2, function(x) sum(is.na(x)==TRUE))
  pos.NA.arrays<-which(aa==nrow(dat))
  len.NA.arrays=length(pos.NA.arrays)
  if(len.NA.arrays)
  {

    if(len.NA.arrays==ncol(dat))
    {
      stop("The expression levels of all arrays are all missing!\n")
    }
    cat("The expression levels of the following arrays are all missing>>\n")
    print(sampleNames(es)[pos.NA.arrays])
    cat("These arrays will be excluded!\n")

    es<-es[,-pos.NA.arrays] 
    dat<-dat[,-pos.NA.arrays]
  }
  
  aa<-apply(dat, 1, function(x) sum(is.na(x)==TRUE))
  pos.NA.probes <-which(aa==ncol(dat))
  len.NA.probes<-length(pos.NA.probes)
  if(len.NA.probes)
  {

    if(len.NA.probes==nrow(dat))
    {
      stop("The expression levels of all probes are all missing!\n")
    }
    cat("The expression levels of the following probes are all missing>>\n")
    print(featureNames(es)[pos.NA.probes])
    cat("These probes will be excluded!\n")

    es<-es[-pos.NA.probes, ] 
    dat<-dat[-pos.NA.probes,]
  }
 
  # remove probes with missing values
  dat2=na.omit(dat)
  pos=match(rownames(dat2), rownames(dat))
  nNA=nrow(dat)-nrow(dat)
  if(nNA)
  {
    cat("\nWarning: ", nNA, " number of probes containing missing valuse and were deleted\n")
  } 
  
  es2=es[pos,]
  nn<-min(dim(dat2))
  pcs<-prcomp(t(dat2), scale. =corFlag)
  
  res<-list(es.s=es2, pcs=pcs, requireLog2=requireLog2)
  invisible(res)
}

pca2DPlot<-function(pcaObj,
  plot.dim = c(1,2),
  labelVariable="subjID",
  hybName = "Hybridization_Name",
  outFileName="test_pca_raw.pdf",
  title="Scatter plot of pcas",
  plotOutPutFlag=FALSE,
  mar=c(5, 4, 4, 2) + 0.1,
  lwd=1.5,
  equalRange=TRUE,
  xlab=NULL,
  ylab=NULL,
  xlim=NULL,
  ylim=NULL,
  cex.legend=1.5,
  cex=1.5,
  cex.lab=1.5,
  cex.axis=1.5,
  legendPosition="topright",
  ...
)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  if(length(plot.dim)!=2 || any(plot.dim<1))
  {
    stop("plot.dim must have exactly 2 positive-integer-value elements!")
  }
  es<-pcaObj$es.s
  if(any(plot.dim > min(dim(es))))
  {
    stop("all elements of plot.dim must be smaller than min(dim(es))!")
  }
  pcs<-pcaObj$pcs
  requireLog2<- pcaObj$requireLog2

  pcaMat<-pcs$x
  aa<-pcaMat[, plot.dim, drop=FALSE]
  egvals<-pcs$sdev^2
  R2vec<-egvals/sum(egvals)

  if(is.null(xlim))
  {
    xlim <- range(aa[,1], na.rm=TRUE)
  }
  if(is.null(ylim))
  {
    ylim <- range(aa[,2], na.rm=TRUE)
  }

  if(equalRange)
  {
    t1<-min(xlim[1], ylim[1])
    t2<-max(xlim[2], ylim[2])
    xlim<-c(t1, t2)
    ylim<-c(t1, t2)
  }


  if(is.null(xlab))
  {
    xlab<-paste("pc", plot.dim[1], " (R2=", round(R2vec[plot.dim[1]],2), ")", sep="")
  }
  if(is.null(ylab))
  {
    ylab<-paste("pc", plot.dim[2], " (R2=", round(R2vec[plot.dim[2]],2), ")", sep="")
  }

  if(labelVariable=="subjID")
  {
    # pca plot
    if(plotOutPutFlag)
    {
      #postscript(outFileName, horizontal=TRUE, paper="letter")
      pdf(outFileName, width=756, height=576, paper="letter")
    }

    par(mar=mar)

    if(is.na(title))
    {
      main=labelVariable
    } else {
      main=title
    }
    plot(x=as.numeric(as.character(aa[,1])),
      y=as.numeric(as.character(aa[,2])),
      xlab=xlab, ylab=ylab,type="p",
      xlim=xlim, ylim=ylim, col=1, pch=1, lwd=lwd,
      cex=cex, cex.lab=cex.lab, cex.axis=cex.axis, ...)
    title(main=main)

    par(mar=c(5, 4, 4, 2) + 0.1)

    if(plotOutPutFlag)
    {
      dev.off()
    }

  } else {
    dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable,
      requireLog2=requireLog2)

    arrayNames.u<-unique(colnames(dat))

    labels<-as.numeric(as.factor(colnames(dat)))
    labels.u<-unique(labels)
    nClusters<-length(labels.u)

    # pca plot
    if(plotOutPutFlag)
    {
      #postscript(outFileName, horizontal=TRUE, paper="letter")
      pdf(outFileName, width=756, height=576, paper="letter")
    }

    par(mar=mar)

    if(is.na(title))
    {
      main=labelVariable
    } else {
      main=title
    }
    mycols <- grDevices::rainbow(nClusters)
    plot(
      x=aa[labels==labels.u[1],1],
      y=aa[labels==labels.u[1],2],
      xlab=xlab, ylab=ylab,type="p",
      xlim=xlim, ylim=ylim, col=mycols[1], pch=labels.u[1], lwd=lwd,
      cex=cex, cex.lab=cex.lab, cex.axis=cex.axis, ...)
    title(main=main)
    if(nClusters>1)
    {
      for(i in 2:nClusters)
      {
        points(x=aa[labels==labels.u[i],1], y=aa[labels==labels.u[i],2],
          col=mycols[i], pch=labels.u[i], lwd=lwd, ...)
      }
    }
    legend(x=legendPosition, legend=arrayNames.u,
      col=mycols, pch=labels.u,
      cex=cex.legend, bty="o")

    par(mar=c(5, 4, 4, 2) + 0.1)

    if(plotOutPutFlag)
    {
      dev.off()
    }
  }
  invisible(pcaMat)
}

pca3DPlot<-function(pcaObj,
  plot.dim=c(1,2,3), 
  labelVariable="subjID",
  hybName = "Hybridization_Name",
  outFileName="test_pca_raw.pdf",
  title="Scatter plot of pcas",
  plotOutPutFlag=FALSE,
  mar=c(5, 4, 4, 2) + 0.1,
  lwd=1.5,
  equalRange=TRUE,
  xlab=NULL,
  ylab=NULL,
  zlab=NULL,
  xlim=NULL,
  ylim=NULL,
  zlim=NULL,
  cex.legend=1.5,
  cex=1.5,
  cex.lab=1.5,
  cex.axis=1.5,
  legendPosition="topright",
  ...
)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  if(length(plot.dim)!=3 || any(plot.dim<1))
  {
    stop("plot.dim must have exactly 3 positive-integer-value elements!")
  }
  es<-pcaObj$es.s
  if(any(plot.dim > min(dim(es))))
  {
    stop("all elements of plot.dim must be smaller than min(dim(es))!")
  }
  pcs<-pcaObj$pcs
  requireLog2<- pcaObj$requireLog2

  #pcaMat<-pls::scores(pcs)
  pcaMat<-pcs$x
  aa<-pcaMat[, plot.dim, drop=FALSE]
  #R2vec<-pcs@R2[plot.dim]
  aa<-pcaMat[, plot.dim, drop=FALSE]
  egvals<-pcs$sdev^2
  R2vec<-egvals/sum(egvals)
  
  #R2vec<-pcs@R2[plot.dim]

  if(is.null(xlab))
  {
    xlab<-paste("pc", plot.dim[1], " (R2=", round(R2vec[plot.dim[1]],2), ")", sep="")
  }
  if(is.null(ylab))
  {
    ylab<-paste("pc", plot.dim[2], " (R2=", round(R2vec[plot.dim[2]],2), ")", sep="")
  }
  if(is.null(zlab))
  {
    zlab<-paste("pc", plot.dim[3], " (R2=", round(R2vec[plot.dim[3]],2), ")", sep="")
  }

  if(is.null(xlim))
  {
    xlim <- range(aa[,1], na.rm=TRUE)
  }
  if(is.null(ylim))
  {
    ylim <- range(aa[,2], na.rm=TRUE)
  }
  if(is.null(zlim))
  {
    zlim <- range(aa[,3], na.rm=TRUE)
  }


  if(equalRange)
  {
    t1<-min(c(xlim[1], ylim[1], zlim[1]))
    t2<-max(c(xlim[2], ylim[2], zlim[2]))
    xlim<-c(t1, t2)
    ylim<-c(t1, t2)
    zlim<-c(t1, t2)
  }


  if(labelVariable=="subjID")
  {
    # pca plot
    if(plotOutPutFlag)
    {
      #postscript(outFileName, horizontal=TRUE, paper="letter")
      pdf(outFileName, width=756, height=576, paper="letter")
    }

    par(mar=mar)

    if(is.na(title))
    {
      main=labelVariable
    } else {
      main=title
    }
    scatterplot3d(
      x=as.numeric(as.character(aa[,1])),
      y=as.numeric(as.character(aa[,2])),
      z=as.numeric(as.character(aa[,3])),
      xlab=xlab, ylab=ylab,zlab=zlab,
      xlim=xlim, ylim=ylim, zlim=zlim, 
      color=1, pch=1, lwd=lwd,
      cex.symbols=cex, cex.lab=cex.lab, cex.axis=cex.axis, ...)
    title(main=main)

    par(mar=c(5, 4, 4, 2) + 0.1)

    if(plotOutPutFlag)
    {
      dev.off()
    }

  } else {
    dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable,
      requireLog2=requireLog2)

    arrayNames.u<-unique(colnames(dat))

    labels<-as.numeric(as.factor(colnames(dat)))
    mycols<-labels
    labels.u<-unique(labels)
    nClusters<-length(labels.u)

    # pca plot
    if(plotOutPutFlag)
    {
      #postscript(outFileName, horizontal=TRUE, paper="letter")
      pdf(outFileName, width=756, height=576, paper="letter")
    }

    par(mar=mar)

    if(is.na(title))
    {
      main=labelVariable
    } else {
      main=title
    }
    #mycols <- grDevices::rainbow(nClusters)
    #mycols<-as.numeric(as.factor(colnames(dat)))
    
    scatterplot3d(
      x=aa[,1],
      y=aa[,2],
      z=aa[,3],
      xlab=xlab, ylab=ylab,zlab=zlab, type="p",
      xlim=xlim, ylim=ylim, zlim=zlim,
      color=labels, pch=labels, lwd=lwd,
      cex.symbols=cex, cex.lab=cex.lab, cex.axis=cex.axis, ...)
    title(main=main)
    legend(x=legendPosition, legend=arrayNames.u,
      col=labels.u, pch=labels.u,
      cex=cex.legend, bty="o")

    par(mar=c(5, 4, 4, 2) + 0.1)

    if(plotOutPutFlag)
    {
      dev.off()
    }
  }
  invisible(pcaMat)
}

###########################################################

# get GC samples
separateGCnonGC<-function(es, GCid=c("128115", "Hela", "Brain"))
{
  res<-extractIDs3(pDat=pData(es), mySet=GCid)
  pos.GC<-res$pos
  if(length(pos.GC))
  {
    esGC<-es[, pos.GC]
    es<-es[,-pos.GC]
  } else {
    cat("No GC samples!\n")
    esGC<-NULL
  }

  res<-list(esGC=esGC, esNonGC=es)
  invisible(res)
}




upperTriangle <- function(x, diag=FALSE)
  {
    x[upper.tri(x, diag=diag)]
  }

# es is an ExpressionSet objectthe object for sample probe profiles
# labelVariable -- the name of a phenotype data variable use to
#                label the arrays in the boxplots
# 
# arrayType
R2PlotFunc<-function(es, 
  hybName = "Hybridization_Name",
  arrayType=c("all", "replicates", "GC"),
  GCid = c("128115", "Hela", "Brain"),
  probs = seq(0, 1, 0.25),
  col=gplots::greenred(75),
  labelVariable="subjID",
  outFileName="test_R2_raw.pdf",  
  title="Raw Data R^2 Plot",
  requireLog2=FALSE, 
  plotOutPutFlag=FALSE,
  las=2,
  keysize=1.0,
  margins=c(10,10),
  sortFlag = TRUE,
  varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
  timeFormat=c("%m/%d/%Y", NA, NA),
  ...
)
{
  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }


  arrayType=match.arg(arrayType, choices=c("all", "replicates", "GC"))

  dat<-exprs(es)
  pDat<-pData(es)

  R2vec.within.rep<-NULL
  if(arrayType=="all")
  {
    if(sortFlag)
    { es<-sortExpressionSet(es, varSort, timeFormat) }
    dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable, 
      requireLog2=requireLog2)
    R2Mat<-cor(x=dat, use="complete.obs")^2
  } else if(arrayType=="replicates") {
    # some Subject_ID are NA
    subjIDs.all<-sapply(as.character(pDat[, c(hybName)]), function(x) {
        x<-as.character(x)
        tt<-unlist(strsplit(x, split="_"))
        return(tt[1])
      }
    )
    tt<-table(subjIDs.all, useNA="ifany")
    pos<-which(tt>1)
    subj.r<-names(tt)[pos]
    
    len<-length(subj.r)
    
    pos.rep<-NULL
    for(i in 1:len)
    {
      pos.rep.i<-which(subjIDs.all==subj.r[i])
      pos.rep<-c(pos.rep, pos.rep.i)  
    }
 
    n.rep<-length(pos.rep)
    if(n.rep)
    { 
      es<-es[,pos.rep]
      if(sortFlag)
      { es<-sortExpressionSet(es, varSort, timeFormat) }
      pDat<-pData(es)
      dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable, 
        requireLog2=requireLog2)
      R2Mat<-cor(x=dat, use="complete.obs")^2
 
      # column names
      cn<-as.character(pDat[, c(hybName)])
      # get subject IDs
      subjIDs<-sapply(cn, function(x) {
          x<-as.character(x)
          bb<-unlist(strsplit(x, split="_"))
          return(bb[1])
        }
      )
      # number of unique subjects
      subj.u<-unique(subjIDs)
      n.subj<-length(subj.u)
      for(k in 1:n.subj)
      {
        pos.k<-which(subjIDs==subj.u[k])
        R2Mat.k<-R2Mat[pos.k, pos.k]
        R2vec.k<-c(upperTriangle(R2Mat.k, diag=FALSE))
        R2vec.within.rep<-c(R2vec.within.rep, R2vec.k)
      }
    } else {
      stop("No replicates!\n")
    }
  } else { # GC- genetic control
    es<-extractSamples(es=es, GCflag=TRUE, GCIDsymbols=GCid, hybName=hybName, verbose=FALSE) 
    if(sortFlag)
    { es<-sortExpressionSet(es, varSort, timeFormat) }

    dat<-getDatColnames(es, hybName = hybName, labelVariable = labelVariable, 
      requireLog2=requireLog2)
    R2Mat<-cor(x=dat, use="complete.obs")^2
  }
  rm(dat)
  rm(pDat)

  R2vec<-c(upperTriangle(R2Mat, diag=FALSE))
  qVec<-quantile(R2vec, probs=probs, na.rm=TRUE)
  cat("quantile of R^2>>\n"); print(qVec); cat("\n");
  if(!is.null(R2vec.within.rep))
  { qVec.within.rep<-quantile(R2vec.within.rep, probs=probs, na.rm=TRUE)
    cat("quantile of within-replicate R^2>>\n"); print(qVec.within.rep); cat("\n");
  }

  # draw heatmap
  ##################
  if(plotOutPutFlag)
  {
    pdf(outFileName, width=756, height=576, paper="letter")
    #postscript(outFileName, horizontal=TRUE, paper="letter")
  } 

  gplots::heatmap.2(R2Mat, col=col, Rowv=NULL, Colv=NULL, 
    dendrogram ="none", key=TRUE, keysize=keysize, margins=margins,
    symkey=FALSE, density.info="none", trace="none", main=title, ...)
  
  if(plotOutPutFlag)
  {
    dev.off()
  }

  res<-list(R2Mat=R2Mat, R2vec=R2vec, R2vec.within.rep=R2vec.within.rep)
  invisible(res)
}

getDatColnames<-function(es, hybName="Hybridization_Name", labelVariable = "subjID", requireLog2=FALSE)
{
  dat<-exprs(es)
  pDat<-pData(es)
  if(labelVariable == "subjID")
  {
    colnames(dat)<-as.character(pDat[,c(hybName)])
  } else {
    cn<-colnames(pDat)
    pos<-which(cn == labelVariable)
    if(length(pos))
    {
      colnames(dat)<-as.character(pDat[,labelVariable])
    } else {
      stop("labelVariable is not in the phenotype data!\n")
    }
  }

  if(requireLog2)
  {
    dat<-log2(dat)
  } 

  invisible(dat)

}

####################################
# draw scatter plot for top 20 results
# resFrame is the sorted data frame returned by wrapper functions
#  like lmFitWrapper
scatterPlots=function(
  resFrame, 
  es, 
  col.resFrame=c("probeIDs", "stats", "pval", "p.adj"),
  var.pheno="bmi",
  outcomeFlag = FALSE,
  fitLineFlag = TRUE,
  var.probe="TargetID",
  var.gene="Symbol",
  var.chr="Chr",
  nTop=20,
  myylab="expression level",
  datExtrFunc=exprs,
  fileFlag=FALSE,
  fileFormat="ps",
  fileName="scatterPlots.ps")
{

  fDat=fData(es)
  probeAll=as.character(fDat[, c(var.probe)])
  geneAll=as.character(fDat[, c(var.gene)])
  chrAll=as.character(fDat[, c(var.chr)])

  pDat=pData(es)
  #pheno=as.numeric(as.character(pDat[, c(var.pheno)]))
  pheno=pDat[, c(var.pheno)]

  ####
  frame=resFrame
  frame2=frame[1:nTop,]

  cpg.sel=as.character(frame2[, c(col.resFrame[1])])
  pos=match(cpg.sel, probeAll)
  if(sum(is.na(pos)==TRUE))
  {
    stop("some top probes are not in 'es'!")
  }

  gene.sel=geneAll[pos]
  chr.sel=chrAll[pos]

  dat=datExtrFunc(es)
  dat2=dat[pos,,drop=FALSE]
 
  stats=frame2[, c(col.resFrame[2])]
  pval=frame2[, c(col.resFrame[3])]
  if(length(col.resFrame)==4)
  {
    p.adj=frame[, c(col.resFrame[4])]
  }
 
  if(fileFlag)
  {
    if(fileFormat=="ps")
    {
      postscript(file=fileName, horizontal=TRUE, paper="letter")
    } else if(fileFormat=="pdf"){
      pdf(file=fileName)
    } else if(fileFormat=="jpeg"){
      jpeg(filename=fileName)
    } else {
      png(filename=fileName)
    }
  }

  if(length(col.resFrame)==4)
  {
    for(i in 1:nTop)
    {
      yi=dat2[i,]
      if(outcomeFlag) # i.e. 'pheno' is the outcome variable (y-axis)
      {
        myx=yi
        myy=pheno
        xlab=myylab
        ylab=var.pheno
      } else {
        myx=pheno
        myy=yi
        xlab=var.pheno
        ylab=myylab
      }
      plot(x=myx, y=myy, 
        xlab=xlab, ylab=ylab,
        type="p",
        main=paste("scatterplot of ", var.pheno, 
          "\n", cpg.sel[i], "(", gene.sel[i],
          ", chr=", chr.sel[i], ")", sep=""),
  
        sub=paste("stat=", round(stats[i],2),
           ", pval=", sprintf("%.1e", pval[i]),
           ", p.adj=", sprintf("%.1e", p.adj[i]),sep=""))
      if(fitLineFlag)
      {
        res.lm=lm(myy~myx)
        coef=res.lm$coefficients
        abline(a=res.lm$coefficients[1], b=res.lm$coefficients[2], col=2)
      }
    }
  } else {
    for(i in 1:nTop)
    {
      yi=dat2[i,]
      if(outcomeFlag) # i.e. 'pheno' is the outcome variable (y-axis)
      {
        myx=yi
        myy=pheno
        xlab=myylab
        ylab=var.pheno
      } else {
        myx=pheno
        myy=yi
        xlab=var.pheno
        ylab=myylab
      }

      plot(x=myx, y=myy, 
        xlab=xlab, ylab=ylab,
        type="p",
        main=paste("scatterplot of ", var.pheno, 
          "\n", cpg.sel[i], "(", gene.sel[i],
          ", chr=", chr.sel[i], ")", sep=""),
  
        sub=paste("stat=", round(stats[i],2),
           ", pval=", sprintf("%.1e", pval[i]),
           sep=""))
      if(fitLineFlag)
      {
        res.lm=lm(myy~myx)
        coef=res.lm$coefficients
        abline(a=res.lm$coefficients[1], b=res.lm$coefficients[2], col=2)
      }
    }

  }
  if(fileFlag)
  {
    dev.off()
  }

  invisible(0)
}

# draw parallel boxplots for top 20 results
# resFrame is the sorted data frame returned by wrapper functions
#  like lmFitWrapper
boxPlots=function(
  resFrame, 
  es, 
  col.resFrame = c("probeIDs", "stats", "pval", "p.adj"), 
  var.pheno = "sex", 
  var.probe = "TargetID", 
  var.gene = "Symbol", 
  var.chr = "Chr", 
  nTop = 20, 
  myylab = "expression level", 
  datExtrFunc = exprs, 
  fileFlag = FALSE, 
  fileFormat = "ps", 
  fileName = "boxPlots.ps")
{

  fDat=fData(es)
  probeAll=as.character(fDat[, c(var.probe)])
  geneAll=as.character(fDat[, c(var.gene)])
  chrAll=as.character(fDat[, c(var.chr)])

  pDat=pData(es)
  #pheno=as.numeric(as.character(pDat[, c(var.pheno)]))
  pheno=pDat[, c(var.pheno)]

  ####
  frame=resFrame
  frame2=frame[1:nTop,]

  cpg.sel=as.character(frame2[, c(col.resFrame[1])])
  pos=match(cpg.sel, probeAll)
  if(sum(is.na(pos)==TRUE))
  {
    stop("some top probes are not in 'es'!")
  }

  gene.sel=geneAll[pos]
  chr.sel=chrAll[pos]

  # rows are probes and columns are arrays
  dat=datExtrFunc(es)
  dat2=dat[pos,,drop=FALSE]
 
  stats=frame2[, c(col.resFrame[2])]
  pval=frame2[, c(col.resFrame[3])]
  if(length(col.resFrame)==4)
  {
    p.adj=frame[, c(col.resFrame[4])]
  }
 
  if(fileFlag)
  {
    if(fileFormat=="ps")
    {
      postscript(file=fileName, horizontal=TRUE, paper="letter")
    } else if(fileFormat=="pdf"){
      pdf(file=fileName)
    } else if(fileFormat=="jpeg"){
      jpeg(filename=fileName)
    } else {
      png(filename=fileName)
    }
  }

  if(length(col.resFrame)==4)
  {
    for(i in 1:nTop)
    {
      yi=dat2[i,]
      ttdati=data.frame(yi=yi, pheno=pheno)
      boxplot(yi~pheno,dat=ttdati,
        xlab="", ylab=myylab,
        main=paste("boxplot of ", var.pheno, 
          "\n", cpg.sel[i], "(", gene.sel[i],
          ", chr=", chr.sel[i], ")", sep=""),
        sub=paste("stat=", round(stats[i],2),
           ", pval=", sprintf("%.1e", pval[i]),
           ", p.adj=", sprintf("%.1e", p.adj[i]),sep=""))
  
      stripchart(yi~pheno, dat=ttdati,
              vertical = TRUE, method = "jitter", 
              pch = 21, col = "maroon", bg = "bisque", 
              add = TRUE) 
    }
  } else {
    for(i in 1:nTop)
    {
      yi=dat2[i,]
      ttdati=data.frame(yi=yi, pheno=pheno)
      boxplot(yi~pheno,dat=ttdati,
        xlab="", ylab=myylab,
        main=paste("boxplot of ", var.pheno, 
          "\n", cpg.sel[i], "(", gene.sel[i],
          ", chr=", chr.sel[i], ")", sep=""),
        sub=paste("stat=", round(stats[i],2),
           ", pval=", sprintf("%.1e", pval[i]),
           sep=""))
  
      stripchart(yi~pheno, dat=ttdati,
              vertical = TRUE, method = "jitter", 
              pch = 21, col = "maroon", bg = "bisque", 
              add = TRUE) 
    }

  }
  if(fileFlag)
  {
    dev.off()
  }

  invisible(0)
}

# draw estimated density plots for all arrays
densityPlots=function(
  es, 
  requireLog2 = TRUE,
  myxlab = "expression level", 
  mymain = "density plots",
  datExtrFunc = exprs, 
  fileFlag = FALSE, 
  fileFormat = "ps", 
  fileName = "densityPlots.ps")
{

  nArray=ncol(es)
  dat=datExtrFunc(es)
  if(requireLog2)
  {
    dat=log2(dat)
  }

  dLst=list()
  x=NULL
  y=NULL
  for(i in 1:nArray)
  {
    dLst[[i]]=density(na.omit(dat[,i]))
    x=c(x, dLst[[i]]$x)
    y=c(y, dLst[[i]]$y)
  }
  
  myxlim=range(x, na.rm=TRUE)
  myylim=range(y, na.rm=TRUE)

  if(fileFlag)
  {
    if(fileFormat=="ps")
    {
      postscript(file=fileName, horizontal=TRUE, paper="letter")
    } else if(fileFormat=="pdf"){
      pdf(file=fileName)
    } else if(fileFormat=="jpeg"){
      jpeg(filename=fileName)
    } else {
      png(filename=fileName)
    }
  }

  plot(x=dLst[[1]]$x, y=dLst[[1]]$y, 
    xlim=myxlim, ylim=myylim,
    xlab=myxlab, ylab="Density", type="l",
    main=mymain)
  
  
  for(i in 2:nArray)
  {
    lines(x=dLst[[i]]$x, y=dLst[[i]]$y, 
      xlim=myxlim, ylim=myylim,
      xlab="beta value", ylab="Density")
  }
  
  if(fileFlag)
  {
    dev.off()
  }

  invisible(dLst)
}

inputChecking<-function(pvalAdjMethod, es, probeID.var,
  gene.var, chr.var)
{
  pvalAdjMethod=match.arg(pvalAdjMethod, choices=c("holm", "hochberg", 
    "hommel", "bonferroni", "BH", "BY", "fdr", "none"))

  # extract feature data
  fDat<-fData(es)
  cn<-colnames(fDat)

  # get probe IDs, gene symbos and chromosome numbers
  pos1<-which(cn == probeID.var)
  if(length(pos1))
  { 
    probeIDs<-fDat[, pos1]
  } else {
    stop(paste("no variable", probeID.var, "in feature data", sep=" "))
  }

  pos1<-which(cn == gene.var)
  if(length(pos1))
  { 
    geneSymbols<-fDat[, pos1]
  } else {
    stop(paste("no variable", gene.var, "in feature data", sep=" "))
  }

  pos1<-which(cn == chr.var)
  if(length(pos1))
  { 
    chr<-fDat[, pos1]
  } else {
    stop(paste("no variable", chr.var, "in feature data", sep=" "))
  }


  # extract expression data
  dat<-exprs(es)

  # extract phenotype data
  pDat<-pData(es)

  res<-list(dat=dat, pDat=pDat, fDat=fDat,
    probeIDs = probeIDs, geneSymbols = geneSymbols, chr=chr)

}

getCovInterest<-function(formula, pos.var.interest, formulaType)
{
  if(pos.var.interest==0)
  {
    var.interest<-"(Intercept)"
  } else {
    fla<-as.character(formula)
    if(formulaType=="both")
    {
      # fla[1] = "~"
      # fla[2] = response variable
      # fla[3] = right-hand-side of "~" in formula
      fla3<-fla[3]
    } else {
      # fla[1] = "~"
      # fla[2] = right-hand-side of "~" in formula
      fla3<-fla[2]
    }

    tt<-strsplit(fla3, split="\\+")
    tt2<-as.character(sapply(tt, function(x) { limma::trimWhiteSpace(x)}))
    var.interest<-tt2[pos.var.interest]
  }
  return(var.interest)
}

# Check if the covariate of interest is a
# factor or interaction term with more than 2 levels.
# Return the columns in designMat containing all levels
#  of the covariate of interest.
#
checkCovariate<-function(
  formula, 
  cn.designMat, 
  pos.var.interest,
  formulaType="both")
{
  formulaType<-match.arg(formulaType, choices=c("both", "right"))

  var.interest<-getCovInterest(formula=formula, 
    pos.var.interest=pos.var.interest, formulaType=formulaType)

  if(pos.var.interest==0)
  { # the covariate of interest is the intercept
    # the intercept is the 1-st column of designMat
    colDesignMat<-1
    res<-list(var.interest=var.interest, colDesignMat=colDesignMat)
    return(res)
  } 

  cn<-cn.designMat

  # check if var.interest is an interaction term
  ttpos<-grep(pattern="\\*", x=var.interest, ignore.case =TRUE)
  ttpos2<-grep(pattern="\\:", x=var.interest, ignore.case =TRUE)
  if(length(ttpos) || length(ttpos2))
  { # var.interest is an interaction term
    if(length(ttpos))
    {
      tt3<-strsplit(var.interest, split="\\*")
    } else {
      tt3<-strsplit(var.interest, split="\\:")
    }
    # tt4 contains all covariates in the interaction term 
    tt4<-as.character(sapply(tt3, function(x) { limma::trimWhiteSpace(x)}))

    # check which columns of designMat contains all elements of tt4
    tt7<-unlist(sapply(cn, function(x) {
        tt5<-as.numeric(sapply(tt4, function(y) {
          tt6<-grep(pattern=y, x=x, fixed=TRUE)
          if(length(tt6))
          { 
            return(1) 
          } else {
            return(0) 
          }
        }))
        if(sum(tt5, na.rm=TRUE)==length(tt4))
        { # this column of designMat contains one level of var.interest  
          return(1)
        } else {
          # this column of designMat does not contain the leve of var.interest 
          return(0) 
        }
      }
    ))
    # return columns in designMat containing 
    # the all levels  of the covariate of the interest
    colDesignMat<-which(tt7==1)
    res<-list(var.interest=var.interest, colDesignMat=colDesignMat)
    return(res)
  } else {
    # not an interaction term
    # but might be a factor
    ttpos2<-grep(pattern=var.interest, x=cn, fixed=TRUE)
    ttlen<-length(ttpos2)

    if(ttlen==1)
    {
      # the covariate of interest is not a factor with
      # more than 2 levels
      # return columns in designMat containing 
      # the all levels  of the covariate of the interest
      colDesignMat<-ttpos2
      res<-list(var.interest=var.interest, colDesignMat=colDesignMat)
      return(res)
    } else {
      # each element of 'cn2' contains string var.interest 
      set<-1:length(cn)
      set2<-set[ttpos2]
      cn2<-cn[ttpos2]

      # check if cn2 contains interaction terms
      tt8<-as.numeric(unlist(sapply(cn2, function(x) {
          tt7<-grep(pattern="\\:", x=x, ignore.case=TRUE)
          if(length(tt7))
          {
            return(0) # not we want
          } else {
            return(1) # what we want
          }
        }
      )))
      # columns in designMat contains var.interest 
      ttpos3<-which(tt8 > 0)

      # return columns in designMat containing 
      # the all levels  of the covariate of the interest
      colDesignMat<-set2[ttpos3]
      res<-list(var.interest=var.interest, colDesignMat=colDesignMat)
      return(res)
    }
  }
}


getDesignMat.glm<-function(xi, pDat, formula)
{
  pDat.tmp<-pDat
  pDat.tmp$xi = xi
  designMat <- model.matrix(formula, pDat.tmp)
  invisible(designMat)
}

logit<-function(x)
{
  return(log(x)/(log(1-x)))
}


# put the variable interested in the first place of formula after ~
glmFitOneProbe<-function(
  xi, 
  pDat, 
  formula=xi~ratio, 
  logit=FALSE, 
  family=gaussian,
  verbose=FALSE)
{
  pDat.tmp<-pDat
  if(logit)
  {
    pDat.tmp$xi = log(xi/(1-xi))
  } else {
    pDat.tmp$xi = xi
  }

  # some times glm will exit abnormally 
  # even though we set na.action="na.exclude"
  # because some subjects containing missing values
  # Hence, we drop these subjects before calling glm
  pDat2<-pDat.tmp
  rownames(pDat2)<-1:nrow(pDat2)
  designMat <- model.matrix(formula, pDat2)
  nm<-colnames(designMat)
  rn<-as.numeric(rownames(designMat))
  # remove possible dropped subjects from data frame
  pDat.tmp<-pDat.tmp[rn,,drop=FALSE]

  ans<-try(summary(glm(formula=formula, family=family,
    data=pDat.tmp, na.action="na.exclude")))
  aaa<-attr(ans,which="class")
  if(length(aaa)>1)
  { aaa<-aaa[1] }
  if (aaa == "try-error")
  {
    nn<-length(nm)
    pvalVec <- rep(NA, nn)
    coefVec <- rep(NA, nn)
    statVec <- rep(NA, nn)
    cat("try-error; set pvalVec=NA and stat=NA\n")
  } else {

    if(verbose)
    { print(ans) }

    # some times, some covariates do not appear in
    # the ans$coefficients probably because
    # variances of these covariates are zero.
    # We need to pad NA for these covariates
    # to make sure the output for each gene probe 
    # has the same length
    nm2<-rownames(ans$coefficients)
    ttpos<-which(is.na(match(nm, nm2))==FALSE)
    statVec<-rep(NA, length(nm))
    statVec[ttpos]<-as.numeric(ans$coefficients[, 3])
    coefVec<-rep(NA, length(nm))
    coefVec[ttpos]<-as.numeric(ans$coefficients[, 1])
    pvalVec<-rep(NA, length(nm))
    pvalVec[ttpos]<-as.numeric(ans$coefficients[, 4])

  }

  res<-c(pvalVec, statVec, coefVec)
  names(res)<-c(paste("pval",nm, sep="."), paste("stat",nm, sep="."),
    paste("coef",nm, sep="."))
  return(res)
}



# pos.var.interest -- which covariate in the right-hand-side
# of ~ in the 'formula' is of the interest
#   pos.var.interest = 0 means intercept is of the interest
glmWrapper<-function(
  es,
  formula = FEV1~xi+age+gender, 
  pos.var.interest = 1,
  family=gaussian,
  logit=FALSE, 
  pvalAdjMethod="fdr", 
  alpha = 0.05, 
  probeID.var = "ProbeID", 
  gene.var = "Symbol", 
  chr.var = "Chromosome", 
  applier=lapply,
  verbose=TRUE 
  )
{

  tt<-inputChecking(
    pvalAdjMethod=pvalAdjMethod, 
    es=es, 
    probeID.var=probeID.var,
    gene.var=gene.var, 
    chr.var=chr.var)

  dat<-tt$dat
  pDat<-tt$pDat
  fDat<-tt$fDat
  probeIDs=tt$probeIDs
  geneSymbols=tt$geneSymbols
  chr=tt$chr

  t4<-applier(1:nrow(dat), function(i) {
      glmFitOneProbe(xi=dat[i,], pDat=pDat, formula=formula,
        logit=logit, family=family, verbose=FALSE)
    }
  )

  resMat<-t(sapply(t4, function(x) {x}))
  ttnc<-ncol(resMat)
  ttnc2<-ttnc/3

  # the first part is the p-value matrix
  pvalMat.unsorted<-resMat[,1:ttnc2, drop=FALSE]
  rownames(pvalMat.unsorted)<-featureNames(es)
  # the second part is the stat matrix
  statMat.unsorted<-resMat[,c((ttnc2+1):(2*ttnc2)), drop=FALSE]
  rownames(statMat.unsorted)<-featureNames(es)
  # the  third part is the coef matrix
  coefMat.unsorted<-resMat[,-c(1:(2*ttnc2)), drop=FALSE]
  rownames(coefMat.unsorted)<-featureNames(es)

  # check if the covariate of interest is a factor
  # or interaction term with more than 2 levels
  # first get example design matrix  
  designMat<-getDesignMat.glm(xi=dat[1,], pDat=pDat, 
    formula=formula)

  tmp<-checkCovariate(
    formula=formula, 
    cn.designMat=colnames(designMat), 
    pos.var.interest=pos.var.interest,
    formulaType="both")

  var.interest<-tmp$var.interest
  colDesignMat<-tmp$colDesignMat

  pval<-pvalMat.unsorted[, colDesignMat]
  stats<-statMat.unsorted[, colDesignMat]
  coef<-coefMat.unsorted[, colDesignMat]
  len<-length(colDesignMat)
  if(len>1)
  {
    # take the minimum p-value and its test statistic 
    pval<-apply(pval, 1, min, na.rm=TRUE)
    stats<-apply(stats, 1, function(x) { 
      absx<-abs(x)
      pos<-which(absx == max(absx, na.rm=TRUE))
      return(x[pos[1]])
    })
    coef<-apply(coef, 1, function(x) { 
      absx<-abs(x)
      pos<-which(absx == max(absx, na.rm=TRUE))
      return(x[pos[1]])
    })

    if(verbose)
    {
      cat("\n************************\n")
      cat("Warning: the covariate of interest ", var.interest, " is a factor\n")
      cat("or interaction term with more than 2 levels!\n") 
      cat("Only the smallest p-value will be output!\n")
      cat("Better to run the function lkhWrapper!\n")
      cat("************************\n")
    }
  }

  res<-outputFunc2(
    pval=pval, 
    stats=stats, 
    coef=coef, 
    pvalAdjMethod=pvalAdjMethod,
    probeIDs=probeIDs, 
    geneSymbols=geneSymbols, 
    chr=chr, 
    pvalMat.unsorted=pvalMat.unsorted,
    statMat.unsorted=statMat.unsorted, 
    coefMat.unsorted=coefMat.unsorted, 
    dat=dat, 
    alpha=alpha,
    formula = formula,
    var.interest = var.interest,
    verbose=verbose)

  res$resMat=resMat

  invisible(res)
}

# pos.var.interest -- which covariate in the right-hand-side
# of ~ in the 'formula' is of the interest
#   pos.var.interest = 0 means intercept is of the interest
# likelihood ratio test
lkhrWrapper<-function(
  es,
  formulaReduced = FEV1~xi+gender, 
  formulaFull = FEV1~xi+age+gender, 
  family=gaussian,
  logit=FALSE, 
  pvalAdjMethod="fdr", 
  alpha = 0.05, 
  probeID.var = "ProbeID", 
  gene.var = "Symbol", 
  chr.var = "Chromosome", 
  applier=lapply,
  verbose=TRUE 
  )
{

  tt<-inputChecking(
    pvalAdjMethod=pvalAdjMethod, 
    es=es, 
    probeID.var=probeID.var,
    gene.var=gene.var, 
    chr.var=chr.var)

  dat<-tt$dat
  pDat<-tt$pDat
  fDat<-tt$fDat
  probeIDs=tt$probeIDs
  geneSymbols=tt$geneSymbols
  chr=tt$chr

  t4<-applier(1:nrow(dat), function(i) {
      lkhrFitOneProbe(xi=dat[i,], pDat=pDat, 
        formulaReduced=formulaReduced,
        formulaFull=formulaFull,
        logit=logit, family=family, verbose=FALSE)
    }
  )

  resMat<-t(sapply(t4, function(x) {x}))
  resFrame<-data.frame(
    probeIDs=probeIDs,
    geneSymbols=geneSymbols, 
    chr=chr, 
    Chisq=resMat[,1], 
    Df=resMat[,2], 
    pval=resMat[,3])
  resFrame$p.adj<-p.adjust(resFrame$pval, method="fdr")
  resFrame$pos<-1:nrow(resFrame)

  resFrame.s<-resFrame[order(resFrame$Chisq, decreasing = TRUE),]

  if(verbose)
  {
    cat("\n*********************************\n")
    nTop=min(c(20, nrow(resFrame.s)))
    cat("\nTop ", nTop, " tests>>>\n")
    print(resFrame.s[1:nTop, ])
    cat("\n")

    cat("\nformulaReduced>>\n")
    print(formulaReduced)
    cat("\nformulaFull>>\n")
    print(formulaFull)
    cat("\n")

    cat("\nNumber of tests>>>", nrow(resFrame.s), "\n")
    cat("\nNumber of arrays>>>", nrow(pDat), "\n")
    cat("\nNumber of tests with pvalue<0.05>>>", 
      sum(resFrame.s$pval<0.05, na.rm=TRUE), "\n")
    cat("\nNumber of tests with FDR adjusted pvalue<0.05>>>", 
      sum(resFrame.s$p.adj<0.05, na.rm=TRUE), "\n")

  }

  res<-list(frame=resFrame.s, frame.unsorted=resFrame)
  invisible(res)
}

# put the variable interested in the first place of formula after ~
lkhrFitOneProbe<-function(
  xi, 
  pDat, 
  formulaReduced=xi~ratio+gender, 
  formulaFull=xi~ratio+age+gender, 
  logit=FALSE, 
  family=gaussian,
  verbose=FALSE)
{
  pDat.tmp<-pDat
  if(logit)
  {
    pDat.tmp$xi = log(xi/(1-xi))
  } else {
    pDat.tmp$xi = xi
  }

  # some times glm will exit abnormally 
  # even though we set na.action="na.exclude"
  # because some subjects containing missing values
  # Hence, we drop these subjects before calling glm
  pDat2<-pDat.tmp
  rownames(pDat2)<-1:nrow(pDat2)
  designMatFull <- model.matrix(formulaFull, pDat2)
  nm<-colnames(designMatFull)
  rn<-as.numeric(rownames(designMatFull))
  # remove possible dropped subjects from data frame
  pDat.tmp<-pDat.tmp[rn,,drop=FALSE]

  ansReduced<-try((glm(formula=formulaReduced, family=family,
    data=pDat.tmp, na.action="na.exclude")))
  aaaReduced<-attr(ansReduced,which="class")

  if(length(aaaReduced)>1)
  { aaaReduced<-aaaReduced[1] }

  ansFull<-try((glm(formula=formulaFull, family=family,
    data=pDat.tmp, na.action="na.exclude")))
  aaaFull<-attr(ansFull,which="class")

  if(length(aaaFull)>1)
  { aaaFull<-aaaFull[1] }


  if (aaaReduced == "try-error" || aaaFull == "try-error")
  {
    cat("try-error; set pval=NA and stat=NA\n")
    res<-rep(NA, 3)
    names(res)<-c("Chisq", "Df", "pval")

  } else {

    if(verbose)
    { 
      cat("\nReduced model>>>\n")
      print(ansReduced) 

      cat("\nFull model>>>\n")
      print(ansFull) 
    }

    res.lr<-lrtest(ansReduced, ansFull)
    res<-c(res.lr$Chisq[2], res.lr$Df[2], res.lr$"Pr(>Chisq)"[2])
    names(res)<-c("Chisq", "Df", "pval")
    if(verbose)
    {
      cat("\nlikelihood ratio test>>>>\n")
      print(res.lr)
      cat("\n")
    }

  }

  #res<-c(pvalVec, statVec)
  #names(res)<-c(paste("pval",nm, sep="."), paste("stat",nm, sep="."))
  return(res)
}

outputFunc2<-function(pval, stats, coef, pvalAdjMethod,
  probeIDs, geneSymbols, chr, pvalMat.unsorted,
  statMat.unsorted, coefMat.unsorted, dat, alpha, formula, 
  var.interest,
  verbose)
{
  # quantiles of p-values for all covariates including intercept 
  pval.quantile<-apply(pvalMat.unsorted, 2, quantile, na.rm=TRUE)
  rownames(pval.quantile)<-c("min", "25%", "median", "75%", "max")
  colnames(pval.quantile)<-colnames(pvalMat.unsorted)

  # adjust p-value
  p.adj<-p.adjust(pval, method=pvalAdjMethod)

  # re-order genes by the ascending order of p-value
  # for the covariate of our interest
  nGenes<-length(pval)
  mat<-cbind(pval, stats, coef, 1:nGenes)
  mat2<-mat[order(mat[,1]),]
  pos<-as.numeric(mat2[,4])
        
  # create output dataframe
  frame<-data.frame(probeIDs=probeIDs[pos], geneSymbols=geneSymbols[pos],
    chr=chr[pos],
    stats=mat2[,2], coef=mat2[,3], pval=mat2[,1], p.adj=p.adj[pos], pos=pos)
  rownames(frame)<-NULL

  # sorted p-value matrix
  pvalMat<-pvalMat.unsorted[pos, ,drop=FALSE]
  # sorted moderate t-test statistic matrix
  statMat<-statMat.unsorted[pos, ,drop=FALSE]
  # sorted coef matrix
  coefMat<-coefMat.unsorted[pos, ,drop=FALSE]

  frame.unsorted<-data.frame(probeIDs=probeIDs, geneSymbols=geneSymbols,
    chr=chr,
    stats=mat[,2], coef=mat[,3], pval=mat[,1], p.adj=p.adj, pos=1:nGenes)
  rownames(frame.unsorted)<-NULL
  rownames(statMat.unsorted)<-NULL
  rownames(pvalMat.unsorted)<-NULL
  rownames(coefMat.unsorted)<-NULL
  rownames(statMat)<-NULL
  rownames(coefMat)<-NULL
  rownames(pvalMat)<-NULL

  # number of significant gene probes after p-value adjustment
  n.sig<-sum(p.adj<alpha, na.rm=TRUE)
  if(verbose)
  { 
    nPrint=min(nrow(frame), 20)
    if(nPrint)
    { 
      print(frame[1:nPrint,])
    }

    cat("\npvalue quantiles for intercept and covariates>>\n")
    print(pval.quantile)
    cat("\n")

    cat("formula>>\n"); print(formula); cat("\n");
    cat("covariate of interest is ", var.interest, "\n")
    cat("Number of tests=", nrow(frame), "\n")
    cat("Number of arrays=", ncol(dat), "\n")
    cat("Number of significant tests (raw p-value < ", alpha, ")=", sum(frame$pval<0.05, na.rm=TRUE), "\n")
    cat("Number of significant tests after p-value adjustments=", n.sig, "\n")
    cat("\n\n**********************************************\n")
  }

  # the positive value of stats is over-expressed
  pos1<-which(p.adj<alpha & stats>0)
  len1<-length(pos1)

  # the negative value of stats is under-expressed
  pos3<-which(p.adj<alpha & stats<0)
  len3<-length(pos3)

  nGenes<-nrow(dat)
  memGenes<-rep(2, nGenes)
  memGenes2<-rep(0, nGenes)

  # mixing proportion
  if(len1)
  {
    pi.1<-len1/nGenes
    memGenes[pos1]<-1
  } else {
    pi.1<-0
  }
  if(len3)
  {
    pi.3<-length(pos3)/nGenes
    memGenes[pos3]<-3
  } else {
    pi.3<-0
  }
  pi.2<-1-pi.1-pi.3

  if(len1!=0 || len3!=0)
  {
    memGenes2[memGenes!=2]<-1
  } else {
    cat("No genes are differentially expressed!\n")
  }

  dat1<-dat[memGenes==1,,drop=FALSE]
  dat2<-dat[memGenes==2,,drop=FALSE]
  dat3<-dat[memGenes==3,,drop=FALSE]

  mu1<-apply(dat1, 2, mean, na.rm=TRUE)
  mu2<-apply(dat2, 2, mean, na.rm=TRUE)
  mu3<-apply(dat3, 2, mean, na.rm=TRUE)

  res<-list(n.sig=n.sig, frame=frame, 
    pvalMat=pvalMat,
    pval.quantile=pval.quantile,
    frame.unsorted=frame.unsorted,
    statMat.unsorted=statMat.unsorted,
    coefMat.unsorted=coefMat.unsorted,
    pvalMat.unsorted=pvalMat.unsorted,
    memGenes=memGenes, memGenes2=memGenes2, mu1=mu1, mu2=mu2, mu3=mu3)

  invisible(res)

}

readbgx2 <- function(filename, path=".", sep="\t",
       quote="", header=TRUE, probeStart="[Probes]",
       controlStart="[Controls]", ...) 
{
  tmp = readLines(file.path(path, filename))
  pos = grep("^\\[", tmp)
  tmp.sub = tmp[pos]
  #skip = grep(probeStart, tmp)
  skip = pos[which(tmp.sub==probeStart)]
  #end = grep(controlStart, tmp)
  tmppos = which(tmp.sub==controlStart)
  n.tmp.sub = length(tmp.sub)
  end = pos[tmppos]

  # number of rows of probes
  if(header)
    nrows.p = end-skip-2
  else
    nrows.p = end-skip-1

  if(tmppos<n.tmp.sub)
  { 
    end2 = pos[n.tmp.sub] 
  } else {
    end2 = length(tmp)  
  }
  # number of rows of control probes
  if(header)
    nrows.c =  end2-end-2
  else
    nrows.c =  end2-end-1

  probeAnno = read.delim(file.path(path, filename), sep=sep, header=header, skip=skip, nrows=nrows.p, quote=quote, stringsAsFactors=FALSE, ...)
  controlAnno = read.delim(file.path(path, filename), sep=sep, header=header, skip=end, nrows=nrows.c, stringsAsFactors=FALSE, ...)


#  tmp = probeAnno[1:nrow(controlAnno),]
#  ind = match(colnames(controlAnno), colnames(probeAnno))
#  tmp[,-ind[!is.na(ind)]] = ""
#  tmp[,ind[!is.na(ind)]] = controlAnno[,!is.na(ind)]
#  Status = rep("gene", nrow(probeAnno)+nrow(controlAnno))
#  Status[(nrow(probeAnno)+1):(nrow(probeAnno)+nrow(controlAnno))] = as.character(controlAnno$Reporter_Group_Name)
#  anno = rbind(probeAnno, tmp)
#  anno = cbind(anno,Status)
#  anno

  res<-list(probeAnno=probeAnno, controlAnno=controlAnno)
  invisible(res)
}

readbgx <- function(filename, sep="\t",
       quote="", header=TRUE, probeStart="[Probes]",
       controlStart="[Controls]", ...) 
{
  tmp = readLines(filename)
  pos = grep("^\\[", tmp)
  tmp.sub = tmp[pos]
  #skip = grep(probeStart, tmp)
  skip = pos[which(tmp.sub==probeStart)]
  #end = grep(controlStart, tmp)
  tmppos = which(tmp.sub==controlStart)
  n.tmp.sub = length(tmp.sub)
  end = pos[tmppos]

  # number of rows of probes
  if(header)
    nrows.p = end-skip-2
  else
    nrows.p = end-skip-1

  if(tmppos<n.tmp.sub)
  { 
    end2 = pos[n.tmp.sub] 
  } else {
    end2 = length(tmp)  
  }
  # number of rows of control probes
  if(header)
    nrows.c =  end2-end-2
  else
    nrows.c =  end2-end-1

  probeAnno = read.delim(filename, sep=sep, header=header, skip=skip, nrows=nrows.p, quote=quote, stringsAsFactors=FALSE, ...)
  controlAnno = read.delim(filename, sep=sep, header=header, skip=end, nrows=nrows.c, stringsAsFactors=FALSE, ...)


#  tmp = probeAnno[1:nrow(controlAnno),]
#  ind = match(colnames(controlAnno), colnames(probeAnno))
#  tmp[,-ind[!is.na(ind)]] = ""
#  tmp[,ind[!is.na(ind)]] = controlAnno[,!is.na(ind)]
#  Status = rep("gene", nrow(probeAnno)+nrow(controlAnno))
#  Status[(nrow(probeAnno)+1):(nrow(probeAnno)+nrow(controlAnno))] = as.character(controlAnno$Reporter_Group_Name)
#  anno = rbind(probeAnno, tmp)
#  anno = cbind(anno,Status)
#  anno

  res<-list(probeAnno=probeAnno, controlAnno=controlAnno)
  invisible(res)
}

#########
## create an ExpressionSet object
#########

genExprSet<-function(ex, pDat, fDat=NULL, 
  annotation="lumiHumanAll.db")
{
  # check the consistency of the column names of 'dat',
  # column names of 'fDat', and row names of 'pDat'
  cn.dat<-colnames(ex)
  rn.pdat<-rownames(pDat)

  aa<-match(cn.dat, rn.pdat)
  if(length(cn.dat)!=length(rn.pdat))
  {
    cat("Warning: No. of columns of ex=", length(cn.dat), "\n")
    cat("not equalt to that of pDat =", length(rn.pdat), "\n")
    diffxy<-setdiff(cn.dat, rn.pdat)
    if(length(diffxy))
    {
      cat("The sample in ex, but not in pDat are>>\n")
      print(diffxy)
      cat("\n")
    }
    diffyx<-setdiff(rn.pdat, cn.dat)
    if(length(diffyx))
    {
      cat("The sample in pDat, but not in ex are>>\n")
      print(diffyx)
      cat("\n")
    }
  }
  
  if(!any(is.na(aa)==TRUE))
  {
    pDat2<-pDat[aa,,drop=FALSE]
    identical(rownames(pDat2), colnames(ex))
    pDat3<-as(pDat2, "data.frame")
    aa<-new("AnnotatedDataFrame", data=pDat3)

    exprs<-as(ex, "matrix")
    es.raw<-new("ExpressionSet",
      exprs=exprs,
      phenoData = aa,
      annotation = annotation)
  } else {
    stop("Column names of ex != row names of pDat!\n")
  } 
  
  if(!is.null(fDat))
  { cn.fdat<-colnames(fDat)
    if(identical(sort(rownames(ex)), sort(rownames(fDat))))
    { 
      cc<-match(rownames(ex), rownames(fDat))
      Biobase::fData(es.raw)=fDat[cc,,drop=FALSE]
    } else {
      stop("Row names of ex != row names of dat.control!\n")
    }
  
  }
  
  invisible(es.raw)
}

# intersection strategy
myCombine<-function(x, y, combineRule="intersection", featureID.es="Probe_Sequence", suffix="_2")
{
  combineRule = match.arg(combineRule, choices=c("union", "intersection"))
  if(combineRule=="intersection")
  {
    res<-myCombineIntersect(x, y, featureID.es=featureID.es, suffix=suffix)
  } else {
    res<-myCombineUnion(x, y, featureID.es=featureID.es, suffix=suffix)
  }
  return(res)
}

myCombineIntersect<-function(x, y, featureID.es="Probe_Sequence", suffix="_2")
{
        if(!identical(featureNames(x), as.character(fData(x)[, featureID.es])))
        {
          cat("Error: featureNames(x) not equal to fData(x)[, featureID.es]!\n")
          return(NULL)
        } 
        if (missing(x)) {
          cat("Error: x is missing!\n")
          return(NULL)
        }
        if (missing(y)) {
          cat("Error: y is missing!\n")
          return(NULL)
        }
        if (class(x) != class(y))
        {
                cat(paste("objects must be the same class, but are ",
                 class(x), ", ", class(y), sep=""))
                 return(NULL)
        }

        if (!identical(sort(featureNames(x)), sort(featureNames(y)))) 
        {
          cat('Two objects have different feature names.\n')
        }
        ## determine whether there are duplicated sample names
        sampleName.x <- sampleNames(x)
        sampleName.y <- sampleNames(y)
        int<-intersect(sampleName.x, sampleName.y)
        if (length(int)) {
                cat('Error: Two objects have some common sample names!\n')
                return(NULL)

        }

        # merge duplicated sequences
        x<-mergeDuplicates(x, featureID.es)
        y<-mergeDuplicates(y, featureID.es)

        featureName.x <- featureNames(x)
        featureName.y <- featureNames(y)
        featureName.com <- intersect(featureName.x, featureName.y)
        len.com<-length(featureName.com)
        if (len.com) {
                if(len.com < length(featureName.x) || len.com < length(featureName.y))
                {
                  warning('Two objects have different featureNames, only the common ones were used.')
                }
        } else {
                cat('Error: Two objects have totally different featureNames!\n')
                return(NULL)
        }
        #x <- x[which(featureName.x %in% featureName.com),]
        x<-x[match(featureName.com, featureName.x),]
        #y <- y[which(featureName.y %in% featureName.com),]
        y<-y[match(featureName.com, featureName.y),]
        
        ## make sure two objects have the sample order of features
        if(!identical(sort(featureNames(x)), sort(featureNames(y))))
        {
          cat('Error: sort(featureNames(x)) not equal to sort(featureNames(y))!\n')
          return(NULL)
        }
        pos<-match(featureNames(x), featureNames(y))
        y<-y[pos,]

        history.submitted <- as.character(Sys.time())
        dimm.x <- dim(x) 
        dimm.y <- dim(y)

        x.bak<-x
        # combine x and y and update x
        Biobase::phenoData(x) <- Biobase::combine(phenoData(x.bak),phenoData(y))
        Biobase::assayData(x) <- Biobase::combine(Biobase::assayData(x.bak), Biobase::assayData(y))

        # make sure the sampleNames(x) equal to rownames of phenoData(x)
        sn<-sampleNames(x)
        rn<-rownames(pData(x))
        if(!identical(sort(sn), sort(rn)))
        {
          cat("Error: sort(sampleNames(x)) not equal to sort(rownames(pData(x)))!\n")
          return(NULL)
        }
        if(!identical(sn, rn))
        {
          pos<-match(sn, rn)
          pDat<-pData(x)
          pDat<-pDat[pos,]
          rn<-rn[pos]
          rownames(pDat)<-rn
          Biobase::pData(x)<-pDat
        }

        chipver.x<-unique(as.character(x$Chip_Manifest))
        chipver.y<-unique(as.character(y$Chip_Manifest))
        if(!is.null(chipver.x) && !is.null(chipver.y) && length(chipver.x) > 0 && length(chipver.y) > 0 && !identical(chipver.x, chipver.y))
        {
          # combine feature data
          cat("Warning: chipver.x not equal to chipver.y!\n")
          fDat.x<-fData(x)
          fDat.y<-fData(y)
          cn.x<-colnames(fDat.x)
          cn.y<-colnames(fDat.y)
          pos.y<-which(colnames(fData(y))==featureID.es)
          cn.y<-paste(cn.y, suffix, sep="")
          colnames(fDat.y)<-cn.y
          colnames(fDat.y)[pos.y]<-featureID.es
          Biobase::fData(y)<-fDat.y
          #fData(x)$mysid<-as.character(fData(x)[, featureID.es])
          #fData(y)$mysid<-as.character(fData(y)[, featureID.es])
          Biobase::featureData(x) <- Biobase::combine(Biobase::featureData(x.bak), Biobase::featureData(y))

          # make sure the featureNames(x) equal to rownames of featureData(x)
          sn<-featureNames(x)
          rn<-rownames(fData(x))
          if(!identical(sort(sn), sort(rn)))
          {
            cat("Error: sort(featureNames(x)) not equal to sort(rownames(fData(x)))!\n")
            return(NULL)
          }
          if(!identical(sn, rn))
          {
            pos<-match(sn, rn)
            fDat<-fData(x)
            fDat<-fDat[pos,]
            rn<-rn[pos]
            rownames(fDat)<-rn
            Biobase::fData(x)<-fDat
          }
        } 
    
        Biobase::experimentData(x) <- Biobase::combine(Biobase::experimentData(x.bak), Biobase::experimentData(y))
        Biobase::protocolData(x) <- Biobase::combine(Biobase::protocolData(x.bak),Biobase::protocolData(y))

        ## combining the QC information
        if (length(x@QC) > 0 && length(y@QC) > 0) {
                if (!is.null(x@QC$BeadStudioSummary) && !is.null(y@QC$BeadStudioSummary)) {
                        if (ncol(x@QC$BeadStudioSummary) == ncol(y@QC$BeadStudioSummary) && ncol(x@QC$BeadStudioSummary) > 0) {
                                BeadStudioSummary <- rbind(x@QC$BeadStudioSummary, y@QC$BeadStudioSummary)
                                x@QC$BeadStudioSummary <- BeadStudioSummary
                        } else {
                                x@QC <- list()
                        }
                } else {
                        x@QC <- list()
                }
                if (!is.null(x@QC$sampleSummary) && !is.null(y@QC$sampleSummary)) {
                        if (nrow(x@QC$sampleSummary) == nrow(y@QC$sampleSummary) && nrow(x@QC$sampleSummary)>0) {
                                sampleSummary <- cbind(x@QC$sampleSummary, y@QC$sampleSummary)
                                x@QC$sampleSummary <- sampleSummary
                        } else {
                                x@QC <- list()
                        }
                } else {
                        x@QC <- list()
                }
                if (!is.null(x@QC)) {
                        history.x <- x@QC$history
                        if (is.null(history.x)) history.x <- data.frame(submitted=NA, finished=NA, command=NA, lumiVersion=NA)
                        if (is.null(history.x$lumiVersion)) history.x$lumiVersion <- rep(NA, nrow(history.x))
                        history.y <- y@QC$history
                        if (is.null(history.y)) history.y <- data.frame(submitted=NA, finished=NA, command=NA, lumiVersion=NA)
                        if (is.null(history.y$lumiVersion)) history.y$lumiVersion <- rep(NA, nrow(history.y))
                        x@QC$history <- rbind(history.x, history.y)
                }
        } else {
                x@QC <- list()
        }

        ## VST transformation parameters
        if (!is.null(attr(x, 'vstParameter')) && !is.null(attr(y, 'vstParameter'))) {
                vstParameter.x <- attr(x, 'vstParameter')
                vstParameter.y <- attr(y, 'vstParameter')
                if (is.null(nrow(vstParameter.x))) {
                        vstParameter.x <- matrix(vstParameter.x, nrow=1)
                }
                if (is.null(nrow(vstParameter.y))) {
                        vstParameter.y <- matrix(vstParameter.y, nrow=1)
                }
                if (nrow(vstParameter.x) != dimm.x[2] || nrow(vstParameter.y) != dimm.y[2]) {
                        attr(x, 'vstParameter') <- attr(x, 'transformFun') <- NULL
                } else {
                        attr(x, 'vstParameter') <- rbind(attr(x, 'vstParameter'), attr(y, 'vstParameter'))
                        attr(x, 'transformFun') <- c(attr(x, 'transformFun'), attr(y, 'transformFun'))
                }
        }

        ## controlData information
        if (nrow(x@controlData) > 0 && nrow(y@controlData) > 0) {
          control.x<-x@controlData
          control.y<-y@controlData

          ## determine whether there are duplicated sample names
          sampleName.x <- colnames(control.x)
          sampleName.y <- colnames(control.y)
          int<-intersect(sampleName.x, sampleName.y)
          if (length(int)) {
                  cat("Error: Two controlData objects have some duplicated sample names!\n") 
                  return(NULL)
          }
          featureName.x <- rownames(control.x)
          featureName.y <- rownames(control.y)
          featureName.com <- intersect(featureName.x, featureName.y)
          len.com<-length(featureName.com)
          if (len.com > 0) {
             warning('Two controlData objects have different rownames, only the common ones were used.')
             #control.x <- control.x[which(rownames(control.x) %in% featureName.com),] 
             control.x <- control.x[match(featureName.com, rownames(control.x)),] 
             #control.y <- control.y[which(rownames(control.y) %in% featureName.com),]
             control.y <- control.y[match(featureName.com, rownames(control.y)),]
             ## make sure two objects have the sample order of features
             if(identical(sort(rownames(control.x)), sort(rownames(control.y))))
             {
                pos<-match(rownames(control.x), rownames(control.y))
                control.y<-control.y[pos,]
     
                control.x <- Biobase::combine(control.x, control.y)
                if(!identical(colnames(control.x), sampleNames(x)))
                {
                  cat("Error: colnames(control.x) not equal to sampleNames(x)!\n")
                  return(NULL)
                }
                x@controlData<-control.x

             } else {
               cat('Warning: sort(rownames(control.x)) not equal to sort(rownames(control.y))!\n')
               #x@controlData<-NULL
               x@controlData<-data.frame()
               return(NULL)
             }

          } else {
             cat('Warning: Two controlData objects have totally different rownames!\n')
             #x@controlData<-NULL
             x@controlData<-data.frame()
          }
        } else {
          #x@controlData <- NULL
          x@controlData<-data.frame()
        }

        # history tracking
        history.finished <- as.character(Sys.time())
        history.command <- capture.output(print(match.call(combine)))
        x@history<- rbind(x.bak@history, y@history)
        if (is.null(x@history$lumiVersion)) x@history$lumiVersion <- rep(NA, nrow(x@history))
        lumiVersion <- packageDescription('lumi')$Version
        x@history<- rbind(x@history,
               data.frame(submitted=history.submitted, finished=history.finished, command=history.command, lumiVersion=lumiVersion))
        #featureNames(x)<-as.character(fData(x)$Probe_Sequence)
        return(x)
}

# union strategy
myCombineUnion<-function(x, y, featureID.es="Probe_Sequence", suffix="_2")
{
  if(!identical(featureNames(x), as.character(fData(x)[, featureID.es])))
  {
    cat("Error: featureNames(x) not equal to fData(x)[, featureID.es]!\n")
    return(NULL)
  } 
  if (missing(x)) {
    cat("Error: x is missing!\n")
    if(!missing(y))
    {
      return(y) 
    } 
    return(NULL)
  }
  if (missing(y)) {
    if(!missing(x))
    {
      return(x)
    } else {
      return(NULL)
    }
  }

  if (class(x) != class(y))
  {
          cat(paste("objects must be the same class, but are ",
           class(x), ", ", class(y), sep=""))
          return(NULL)
  }

  if (!identical(sort(featureNames(x)), sort(featureNames(y)))) 
  {
    cat('Warning: Two data sets have different row names.\n')
  }
  ## determine whether there are duplicated sample names
  sampleName.x <- sampleNames(x)
  sampleName.y <- sampleNames(y)

  int<-intersect(sampleName.x, sampleName.y)
  if (length(int)) {
          cat('Error: Two objects have some duplicated sample names!\n')
          return(NULL)
  }

  # merge duplicated sequences
  x<-mergeDuplicates(x, featureID.es)
  seq.x <- as.character(fData(x)[, featureID.es])

  y<-mergeDuplicates(y, featureID.es)
  seq.y <- as.character(fData(y)[, featureID.es])

  seq.com<-intersect(seq.x, seq.y)
  if(length(seq.com))
  {
    if(!identical(sort(seq.x), sort(seq.y)))
    {
      warning('Two data sets have different probe sequence. The union were used.')
    }
  } else {
    cat('Two data sets have totally different featureNames. The union were used\n')
  }

  history.submitted <- as.character(Sys.time())
  dimm.x <- dim(x) 
  dimm.y <- dim(y)


  ## combine pheno data
  phenoData.xy <- Biobase::combine(phenoData(x),phenoData(y))

  # merge feature data
  chipver.x<-unique(as.character(x$Chip_Manifest))
  chipver.y<-unique(as.character(y$Chip_Manifest))
  if (is.null(chipver.y) || is.null(chipver.x) || length(chipver.x) == 0 || length(chipver.y) == 0 || chipver.y %in% chipver.x)  
  {
    fDat.xy<-fData(x)
  } else { 
    # combine feature data
    cat("Warning: chipver.x not equal to chipver.y!\n")
    fDat.x<-fData(x)
    fDat.y<-fData(y)
    cn.x<-colnames(fDat.x)
    cn.y<-colnames(fDat.y)
    pos.y<-which(colnames(fData(y))==featureID.es)
    cn.y<-paste(cn.y, suffix, sep="")
    colnames(fDat.y)<-cn.y
    colnames(fDat.y)[pos.y]<-featureID.es
    Biobase::fData(y)<-fDat.y
    fDat.xy<-merge(x=fData(x), y=fData(y), by=featureID.es,
      all=TRUE, sort=FALSE, suffixes = c("",suffix))
  }

  eltVec.x<-Biobase::assayDataElementNames(x)
  eltVec.y<-Biobase::assayDataElementNames(y)

  elt.xy<-intersect(eltVec.x, eltVec.y)
  len.elt.xy<-length(elt.xy)
  if(len.elt.xy==0)
  {
    cat("No overlapping arrayDataElementNames between 'x' and 'y'!\n")
    return(NULL)
  }

  elt.xnoty<-setdiff(eltVec.x, eltVec.y)
  if(length(elt.xnoty))
  {
    cat("\nThe following assayDataElementNames are in 'x', but not in 'y'!\n")
    print(elt.xnoty)
    cat("\nThese elements will not be in the combined object!\n") 
  }

  elt.ynotx<-setdiff(eltVec.y, eltVec.x)
  if(length(elt.ynotx))
  {
    cat("\nThe following assayDataElementNames are in 'y', but not in 'x'!\n")
    print(elt.ynotx)
    cat("\nThese elements will not be in the combined object!\n") 
  }
  storage.mode.x <- Biobase::storageMode(x)
  if(storage.mode.x == "lockedEnvironment")
  {
    aData.x<-Biobase::copyEnv(x@assayData)
  } else {
    aData.x <- x@assayData
  }

  storage.mode.y <- Biobase::storageMode(y)
  if(storage.mode.y == "lockedEnvironment")
  {
    aData.y<-Biobase::copyEnv(y@assayData)
  } else {
    aData.y <- y@assayData
  }

  myassayData<-list()
  if(length(which(elt.xy %in% c("exprs", "se.exprs")))==2)
  {
    cmd <- 'xy <- new("LumiBatch"'
  } else if (length(which(elt.xy %in% c("exprs")))==1) {
    cmd <- 'xy <- new("ExpressionSet"'
  } else {
    cat("elt.xy does not contain 'exprs'!\n")
    return(NULL)
  }
 
  # merge each common element
  for(elt in elt.xy)
  {
    aD.x.elt<-as.data.frame(aData.x[[elt]])
    aD.y.elt<-as.data.frame(aData.y[[elt]])
    
    int.xy<-intersect(colnames(aD.x.elt), colnames(aD.y.elt))
    len.int.xy<-length(int.xy)
    if(len.int.xy)
    {
      cat("Error: the following samples are in both x and y>>\n");
      print(int.xy);
      cat("\n");
      return(NULL)
    }

    aD.x.elt$myid<-as.character(fData(x)[, featureID.es])
    aD.y.elt$myid<-as.character(fData(y)[, featureID.es])
  
    aD.xy.elt<-merge(x=aD.x.elt, y=aD.y.elt, by="myid", all=TRUE, sort=FALSE)

    # make sure the order of rows is the same as that of fDat.xy
    aa<-match(as.character(fDat.xy[, featureID.es]), as.character(aD.xy.elt$myid))
    if(any(is.na(aa)==TRUE))
    {
      cat("not all", featureID.es, " in fDat.xy are also in", elt, "\n")
      return(NULL)
    }
    aD.xy.elt<-aD.xy.elt[aa,]

    rn<-as.character(aD.xy.elt$myid)
    rownames(aD.xy.elt)<-rn

    if(!identical(as.character(fDat.xy[, featureID.es]), rn))
    {
      cat("After combining, aD.xy.elt$myid != fData(xy)[, ", featureID.es, "]!\n")
      return(NULL)
    }

    ttpos<-which(colnames(aD.xy.elt) == "myid")
    aD.xy.elt<-aD.xy.elt[,-ttpos, drop=FALSE]

    myassayData[[elt]]<-as.matrix(aD.xy.elt)
    cmd <- paste(cmd, ',', elt, '=myassayData[["', elt, '"]]', sep="")
  }

  ### combine pheno data
  #phenoData.xy <- Biobase::combine(phenoData(x),phenoData(y))

  pos<-match(colnames(myassayData[["exprs"]]), sampleNames(phenoData.xy))
  if(any(is.na(pos)==TRUE))
  {
    cat("Error: sampleNames(xy) != sampleNames(phenoData.xy)!\n")
    return(NULL)
  }
  if(dim(phenoData.xy)[2]==1)
  {
    phenoData.xy2<-phenoData.xy[pos]
  } else {
    phenoData.xy2<-phenoData.xy[pos,]
  }

  cmd <- paste(cmd, ', phenoData=phenoData.xy2)', sep="")

  #cmd <- paste(cmd, ')')
  eval(parse(text=cmd))

  ## add feature data
  rownames(fDat.xy)<-as.character(fDat.xy[, featureID.es])
  bb<-new("AnnotatedDataFrame", data=fDat.xy)
  Biobase::featureData(xy)<-bb
  #fData(xy)<-fDat.xy

  ## combine experimentData
  Biobase::experimentData(xy) <- Biobase::combine(Biobase::experimentData(x),Biobase::experimentData(y))

  ## combine protocolData
  Biobase::protocolData(xy) <- Biobase::combine(Biobase::protocolData(x),Biobase::protocolData(y))

  ## combining the QC information
  if (length(x@QC) > 0 && length(y@QC) > 0) {
          if (!is.null(x@QC$BeadStudioSummary) && !is.null(y@QC$BeadStudioSummary)) {
                  if (ncol(x@QC$BeadStudioSummary) == ncol(y@QC$BeadStudioSummary) && ncol(x@QC$BeadStudioSummary) > 0) {
                          BeadStudioSummary <- rbind(x@QC$BeadStudioSummary, y@QC$BeadStudioSummary)
                          xy@QC$BeadStudioSummary <- BeadStudioSummary
                  } else {
                          xy@QC <- list()
                  }
          } else {
                  xy@QC <- list()
          }
          if (!is.null(x@QC$sampleSummary) && !is.null(y@QC$sampleSummary)) {
                  if (nrow(x@QC$sampleSummary) == nrow(y@QC$sampleSummary)) {
                          sampleSummary <- cbind(x@QC$sampleSummary, y@QC$sampleSummary)
                          xy@QC$sampleSummary <- sampleSummary
                  } else {
                          xy@QC <- list()
                  }
          } else {
                  xy@QC <- list()
          }
          if (!is.null(x@QC)) {
                  history.x <- x@QC$history
                  if (is.null(history.x)) history.x <- data.frame(submitted=NA, finished=NA, command=NA, lumiVersion=NA)
                  if (is.null(history.x$lumiVersion)) history.x$lumiVersion <- rep(NA, nrow(history.x))
                  history.y <- y@QC$history
                  if (is.null(history.y)) history.y <- data.frame(submitted=NA, finished=NA, command=NA, lumiVersion=NA)
                  if (is.null(history.y$lumiVersion)) history.y$lumiVersion <- rep(NA, nrow(history.y))
                  xy@QC$history <- rbind(history.x, history.y)
          }
  } else {
          xy@QC <- list()
  }

  ## VST transformation parameters
  if (!is.null(attr(x, 'vstParameter')) && !is.null(attr(y, 'vstParameter'))) {
          vstParameter.x <- attr(x, 'vstParameter')
          vstParameter.y <- attr(y, 'vstParameter')
          if (is.null(nrow(vstParameter.x))) {
                  vstParameter.x <- matrix(vstParameter.x, nrow=1)
          }
          if (is.null(nrow(vstParameter.y))) {
                  vstParameter.y <- matrix(vstParameter.y, nrow=1)
          }
          if (nrow(vstParameter.x) != dimm.x[2] || nrow(vstParameter.y) != dimm.y[2]) {
                  attr(xy, 'vstParameter') <- attr(x, 'transformFun') <- NULL
          } else {
                  attr(xy, 'vstParameter') <- rbind(attr(x, 'vstParameter'), attr(y, 'vstParameter'))
                  attr(xy, 'transformFun') <- c(attr(x, 'transformFun'), attr(y, 'transformFun'))
          }
  }

  ## controlData information
  if (nrow(x@controlData) > 0 && nrow(y@controlData) > 0) {
    control.x<-x@controlData
    control.y<-y@controlData

    ## determine whether there are duplicated sample names
    sampleName.x <- colnames(control.x)
    sampleName.y <- colnames(control.y)
    int<-intersect(sampleName.x, sampleName.y)
    if (length(int)) {
            cat("Error: Two controlData objects have some duplicated sample names!\n") 
            return(NULL)
    }

    if(identical(rownames(control.x), rownames(control.y)))
    { 
      rn<-rownames(control.x)
      tt<-cbind(as.matrix(control.x), as.matrix(control.y)) 
      rownames(tt)<-rn
      xy@controlData<-as.data.frame(tt) 

      pos<-match(sampleNames(xy), colnames(xy@controlData))
      if(any(is.na(pos)==TRUE))
      {
        cat("Error: sampleNames(xy) != colnames(xy@controlData)!\n")
        return(NULL)
      }
      xy@controlData<-xy@controlData[,pos]

    } else if (length(intersect(colnames(control.x), colnames(control.y)))) {
      cat("Error: control.x and control.y have common samples!\n")
      return(NULL)

    } else {
      rn.x<-row.names(control.x)
      rn.y<-row.names(control.y)
      common<-intersect(rn.x, rn.y)
      if(length(common))
      {
        #control.x2<-control.x[which(rn.x %in% common),]
        control.x2<-control.x[match(common, rn.x),]
        #control.y2<-control.y[which(rn.y %in% common),]
        control.y2<-control.y[match(common, rn.y),]
        xy@controlData<-as.data.frame(cbind(control.x2, control.y2)) 

        pos<-match(sampleNames(xy), colnames(xy@controlData))
        if(any(is.na(pos)==TRUE))
        {
          cat("Error: sampleNames(xy) != colnames(xy@controlData)!\n")
          return(NULL)
        }
        xy@controlData<-xy@controlData[,pos]

      } else { 
        #xy@controlData <- NULL
        xy@controlData <- data.frame()
      }
    }
  } else {
    #xy@controlData <- NULL
    xy@controlData <- data.frame()
  }

  # history tracking
  history.finished <- as.character(Sys.time())
  history.command <- capture.output(print(match.call(combine)))
  xy@history<- rbind(x@history, y@history)
  if (is.null(xy@history$lumiVersion)) xy@history$lumiVersion <- rep(NA, nrow(x@history))
  lumiVersion <- packageDescription('lumi')$Version
  history<- rbind(xy@history,
         data.frame(submitted=history.submitted, finished=history.finished, command=history.command, lumiVersion=lumiVersion))
  xy@history<-history
  
  Biobase::featureNames(xy)<-as.character(fData(xy)$Probe_Sequence)
  return(xy)
}

# created on July 19, 2015
#   simulate data set with so that cases and controls
#     have different means and variances


# Phipson and Oshlack's (2014) simulation from null distribution
#
# for each CpG site, variance was first sampled from an
#   scaled inverse chi-squared distribution
#      sigma_i ~ scale-inv chi^2(d0, s0^2)
#  M value for each CpG was sampled from a normal distribution
#    with variance equal to the simulated variance
#

genSimData.BayesNormal=function(nCpGs, nCases, nControls,
  mu.n=-2, mu.c=2, d0=20, s02=0.64, s02.c=1.5, testPara="var", 
  outlierFlag = FALSE, eps=1.0e-3, applier=lapply) 
{
  tau2=s02
  v=d0
  # simulate variances for controls
  chi2=rchisq(n=nCpGs, df=v)
  sdVec = sqrt((v*tau2)/chi2)

  # simulate CpG from alternative hypothesis (un-equal variance)
  tau2.c=s02.c
  v=d0
  sdVec.c = sqrt((v*tau2.c)/chi2)

  m0=mu.n
  m1=mu.c

  ttLst=lapply(1:nCpGs, function(i) {
    x.c=rnorm(nCases, mean=mu.c, sd=sdVec.c[i])
    x.n=rnorm(nControls, mean=mu.n, sd=sdVec[i])

    v0=sdVec[i]
    v1=sdVec.c[i]
  
    if(testPara=="mean")
    {
       if(abs(m0-m1)<eps) 
       {
         memGenes=0
       } else {
         memGenes=1
       }
    } else if(testPara=="var") {
       if(abs(v0-v1)<eps) 
       {
         memGenes=0
       } else {
         memGenes=1
       }
    } else { # test for both mean difference and variance difference
       if(abs(m0-m1)<eps && abs(v0-v1)<eps) 
       {
         memGenes=0
       } else {
         memGenes=1
       }
    }
   
    return( c(memGenes, x.c, x.n) )
  })
  mat2=t(sapply(ttLst, function(x) {x}))
  memGenes=mat2[,1]
  mat=mat2[,-1]

  if(outlierFlag)
  {
    # add outlier
    datvec=c(mat)
    M.max=max(datvec, na.rm=TRUE)
  
    # randomly select one case to add outliers
    pos.outCase=sample(x=1:nCases, size=1, replace=FALSE)
    mat[, pos.outCase]=M.max
  }

  memSubj=c(rep(1, nCases), rep(0, nControls))

  nSubj=nCases+nControls
  subjID=paste("subj", 1:nSubj, sep="")
  probeID=paste("probe", 1:nCpGs, sep="")
  genes=paste("gene", 1:nCpGs, sep="")
  chr=rep(1, nCpGs)

  pDat=data.frame(
    arrayID=subjID,    
    memSubj=memSubj
  )
  rownames(pDat)=subjID

  fDat=data.frame(probe=probeID, gene=genes, chr=chr, memGenes=memGenes)
  rownames(fDat)=probeID

  rownames(mat)=probeID
  colnames(mat)=subjID

  # create ExpressionSet object
  aa<-new("AnnotatedDataFrame", data=pDat)
  #bb<-assayDataNew("lockedEnvironment", exprs=mat)
  #bb<-new("AssayData", exprs=mat)

  #es<-new("ExpressionSet",
  #    assayData=bb,
  #    phenoData = aa,
  #    annotation = "")

  es<-new("ExpressionSet",
      exprs=mat,
      phenoData = aa,
      annotation = "")

  Biobase::fData(es)=fDat

  invisible(es)

}

myShow<-function(object, showHistory=FALSE)
{
  if(showHistory)
  { cat('Summary of data information:\n')
    note <- Biobase::notes(object)
    n.names <- names(note)
    for (i in seq(note)) {
            if (!is.null(n.names)) cat('\t', paste(n.names[i], ':\n\t\t', sep=''))
            cat(note[[i]], sep='\n\t\t')
    }
    cat('\nMajor Operation History:\n')
    print(lumi::getHistory(object))
  }
  cat('\nObject Information:\n')
  aa<-as(object, "ExpressionSet")
  print(aa)

  if(showHistory)
  {
    if (!is.null(object@controlData)) {
          cat('Control Data: Available\n')
    } else {
        cat('Control Data: N/A\n')
    }
    cat("QC information: Please run mySummary(x) for details!\n")
  }
}

# make sure the first covariate in 'formula' is the variable of interest
# pos.var.interest indicates which covariate in right-hand-side
#   of "~" in 'formula' is the covariate of the interest
lmFitWrapper<-function(
  es, 
  formula=~as.factor(gender), 
  pos.var.interest = 1,
  pvalAdjMethod="fdr", 
  alpha=0.05, 
  probeID.var="ProbeID", 
  gene.var="Symbol", 
  chr.var="Chromosome", 
  verbose=TRUE)
{ 

  tt<-inputChecking(
    pvalAdjMethod=pvalAdjMethod, 
    es=es, 
    probeID.var=probeID.var,
    gene.var=gene.var, 
    chr.var=chr.var)

  dat<-tt$dat
  pDat<-tt$pDat
  fDat<-tt$fDat
  probeIDs=tt$probeIDs
  geneSymbols=tt$geneSymbols
  chr=tt$chr

  # some times designMat will loss some subjects
  # because these subjects containing missing values
  # Hence, we need to know which rows dropped
  pDat2<-pDat
  rownames(pDat2)<-1:nrow(pDat2)

  designMat <- model.matrix(formula, pDat2)
  rn<-as.numeric(rownames(designMat))
  # remove possible dropped subjects from expression data
  dat<-dat[,rn,drop=FALSE]
  rownames(designMat)<-colnames(dat)

  #####
  # gene differential analysis
  #####
  if(verbose)
  { 
    cat("dim(dat)>>\n"); print(dim(dat)); cat("\n");
    cat("Running lmFit...\n") 
  }
  fit = lmFit(dat, designMat)

  if(verbose)
  { cat("Running eBayes...\n") }
  ebFit = eBayes(fit)
  
  ####
  # prepare output
  ####
  if(verbose)
  { cat("Preparing output...\n") }

  # unsorted pvalue matrix
  pvalMat.unsorted<-ebFit$p.value
  if(is.null(dim(pvalMat.unsorted)))
  {
    pvalMat.unsorted<-matrix(pvalMat.unsorted, ncol=1)
    colnames(pvalMat.unsorted)<-"(Intercept)"
  }
  rownames(pvalMat.unsorted)<-featureNames(es)

  # unsorted moderate t-test statistic matrix
  statMat.unsorted <- ebFit$t
  if(is.null(dim(statMat.unsorted)))
  {
    statMat.unsorted<-matrix(statMat.unsorted, ncol=1)
    colnames(statMat.unsorted)<-"(Intercept)"
  }  

  rownames(statMat.unsorted)<-featureNames(es)
  

  # check if the covariate of interest is a factor
  # or interaction term with more than 2 levels
  tmp<-checkCovariate(
    formula=formula, 
    cn.designMat=colnames(designMat), 
    pos.var.interest=pos.var.interest,
    formulaType="right")

  var.interest<-tmp$var.interest
  colDesignMat<-tmp$colDesignMat

  pval<-pvalMat.unsorted[, colDesignMat]
  stats<-statMat.unsorted[, colDesignMat]
  len<-length(colDesignMat)
  if(len>1)
  {
    # take the minimum p-value and its test statistic 
    pval<-apply(pval, 1, min, na.rm=TRUE)
    stats<-apply(stats, 1, function(x) { 
      absx<-abs(x)
      pos<-which(absx == max(absx, na.rm=TRUE))
      return(x[pos[1]])
    })
    if(verbose)
    {
      cat("\n************************\n")
      cat("Warning: the covariate of interest ", var.interest, " is a factor\n")
      cat("or interaction term with more than 2 levels!\n") 
      cat("Only the smallest p-value will be output!\n")
      cat("Better to run the function lkhWrapper!\n")
      cat("************************\n")
    }
  }

  res<-outputFunc(
    pval=pval, 
    stats=stats, 
    pvalAdjMethod=pvalAdjMethod,
    probeIDs=probeIDs, 
    geneSymbols=geneSymbols, 
    chr=chr, 
    pvalMat.unsorted=pvalMat.unsorted,
    statMat.unsorted=statMat.unsorted, 
    dat=dat, 
    alpha=alpha,
    formula = formula,
    var.interest = var.interest,
    verbose=verbose)

  res$ebFit=ebFit 

  invisible(res)

}

outputFunc<-function(pval, stats, pvalAdjMethod,
  probeIDs, geneSymbols, chr, pvalMat.unsorted,
  statMat.unsorted, dat, alpha, formula, 
  var.interest,
  verbose)
{
  # quantiles of p-values for all covariates including intercept 
  pval.quantile<-apply(pvalMat.unsorted, 2, quantile, na.rm=TRUE)
  rownames(pval.quantile)<-c("min", "25%", "median", "75%", "max")
  colnames(pval.quantile)<-colnames(pvalMat.unsorted)

  # adjust p-value
  p.adj<-p.adjust(pval, method=pvalAdjMethod)

  # re-order genes by the ascending order of p-value
  # for the covariate of our interest
  nGenes<-length(pval)
  mat<-cbind(pval, stats, 1:nGenes)
  mat2<-mat[order(mat[,1]),]
  pos<-as.numeric(mat2[,3])
        
  # create output dataframe
  frame<-data.frame(probeIDs=probeIDs[pos], geneSymbols=geneSymbols[pos],
    chr=chr[pos],
    stats=mat2[,2], pval=mat2[,1], p.adj=p.adj[pos], pos=pos)
  rownames(frame)<-NULL

  # sorted p-value matrix
  pvalMat<-pvalMat.unsorted[pos, ,drop=FALSE]
  # sorted moderate t-test statistic matrix
  statMat<-statMat.unsorted[pos, ,drop=FALSE]

  frame.unsorted<-data.frame(probeIDs=probeIDs, geneSymbols=geneSymbols,
    chr=chr,
    stats=mat[,2], pval=mat[,1], p.adj=p.adj, pos=1:nGenes)
  rownames(frame.unsorted)<-NULL
  rownames(statMat.unsorted)<-NULL
  rownames(pvalMat.unsorted)<-NULL
  rownames(statMat)<-NULL
  rownames(pvalMat)<-NULL

  # number of significant gene probes after p-value adjustment
  n.sig<-sum(p.adj<alpha, na.rm=TRUE)
  if(verbose)
  { 
    nPrint=min(nrow(frame), 20)
    if(nPrint)
    { 
      print(frame[1:nPrint,])
    }

    cat("\npvalue quantiles for intercept and covariates>>\n")
    print(pval.quantile)
    cat("\n")

    cat("formula>>\n"); print(formula); cat("\n");
    cat("covariate of interest is ", var.interest, "\n")
    cat("Number of tests=", nrow(frame), "\n")
    cat("Number of arrays=", ncol(dat), "\n")
    cat("Number of significant tests (raw p-value < ", alpha, ")=", sum(frame$pval<0.05, na.rm=TRUE), "\n")
    cat("Number of significant tests after p-value adjustments=", n.sig, "\n")
    cat("\n\n**********************************************\n")
  }

  # the positive value of stats is over-expressed
  pos1<-which(p.adj<alpha & stats>0)
  len1<-length(pos1)

  # the negative value of stats is under-expressed
  pos3<-which(p.adj<alpha & stats<0)
  len3<-length(pos3)

  nGenes<-nrow(dat)
  memGenes<-rep(2, nGenes)
  memGenes2<-rep(0, nGenes)

  # mixing proportion
  if(len1)
  {
    pi.1<-len1/nGenes
    memGenes[pos1]<-1
  } else {
    pi.1<-0
  }
  if(len3)
  {
    pi.3<-length(pos3)/nGenes
    memGenes[pos3]<-3
  } else {
    pi.3<-0
  }
  pi.2<-1-pi.1-pi.3

  if(len1!=0 || len3!=0)
  {
    memGenes2[memGenes!=2]<-1
  } else {
    cat("No genes are differentially expressed!\n")
  }

  dat1<-dat[memGenes==1,,drop=FALSE]
  dat2<-dat[memGenes==2,,drop=FALSE]
  dat3<-dat[memGenes==3,,drop=FALSE]

  mu1<-apply(dat1, 2, mean, na.rm=TRUE)
  mu2<-apply(dat2, 2, mean, na.rm=TRUE)
  mu3<-apply(dat3, 2, mean, na.rm=TRUE)

  res<-list(n.sig=n.sig, frame=frame, 
    pvalMat=pvalMat,
    pval.quantile=pval.quantile,
    frame.unsorted=frame.unsorted,
    statMat.unsorted=statMat.unsorted,
    pvalMat.unsorted=pvalMat.unsorted,
    memGenes=memGenes, memGenes2=memGenes2, mu1=mu1, mu2=mu2, mu3=mu3)

  invisible(res)

}

###########
# created on June 10, 2010
#  (1) read in data
#
###########

########################################
# subset an ExpressionSet
extractSamples<-function(es,
  GCflag = TRUE,
  GCIDsymbols=c("128115", "Hela", "Brain"), 
  hybName = "Hybridization_Name", 
  verbose=TRUE)
{
  tmp<-extractIDs3(pDat=pData(es), mySet=GCIDsymbols, 
		   hybName=hybName,  
		   verbose=verbose)
  if(is.null(tmp))
  {
    pos<-numeric(0)
  } else {
    pos<-tmp$pos
  }

  if(GCflag)
  {
    if(length(pos))
    {
      es2<-es[, pos]
    } else {
      cat("In function 'extractSamples', no GC arrays in the ExpressionSet! NULL will be returned\n")
      return(NULL)
    }
  } else {
    if(length(pos))
    {
      es2<-es[, -pos]
    } else {
      es2<-es
    }
  }
  return(es2)
}
# obtain Subject ID for all arrays
# and for GC arrays.
# The first part of 'sampleIDs' must be Subject ID
# The first part of 'sampleIDs' and other parts of 'sampleIDs'
#  must be separated by '_'
extractIDs<-function(sampleIDs, 
  mySet=c("128115", "Hela", "Brain"), verbose=TRUE)

{
  hn<-as.character(sampleIDs)
  if(is.null(hn))
  {
    cat("The function argument 'sampleIDs' is empty!\n")
    return(NULL)
  }
  IDs<-sapply(hn, function(x) {
      x<-as.character(x)
      tt<-strsplit(x, split="_")
      res<-tt[[1]][1]
      return(res)
    }
  )
  rm(hn)

  sampleIDs.sub<-numeric(0) 
  pos<-numeric(0)
  if(length(mySet))
  { pos<-which(toupper(IDs) %in% toupper(mySet))
    n.pos<-length(pos)
    if(n.pos)
    {
      sampleIDs.sub<-sampleIDs[pos]
    }   
  } else {
    cat("The function argument 'mySet' is empty!\n")
    return(NULL)
  } 
  res<-list(pos=pos, sampleIDs.sub=sampleIDs.sub, IDs=IDs)
  return(res)
}

extractIDs3<-function(pDat, 
  mySet=c("128115", "Hela", "Brain"), 
  hybName = "Hybridization_Name", 
  verbose = TRUE)

{
  sm<-as.character(pDat[, c(hybName)])

  res<-extractIDs(sampleIDs=sm, mySet=mySet, verbose=FALSE)
  ttpos2<-res$pos

  pos<-unique(ttpos2)

  if(length(pos))
  {
    sampleIDs.sub<-sm[pos]
  } else {
    sampleIDs.sub<-NULL
  }

  hn<-as.character(sm)
  IDs<-sapply(hn, function(x) {
      x<-as.character(x)
      tt<-strsplit(x, split="_")
      res<-tt[[1]][1]
      return(res)
    }
  )
  rm(hn)

  res<-list(pos=pos, sampleIDs.sub=sampleIDs.sub, IDs=IDs)
  return(res)
}



########################################

# chipNames -- a vector of chip names 
# chipDir -- directory of arrays
# metaFile -- file name for meta file
#             meta file should be comma delimited with header line
#             and na.strings="NA"
# metaDir -- directory of meta file
# pDat -- a pheno data frame (rows are subjects and columns are variables)
#         (must contain columns: Hybridization_Name)
# mFileName -- file name including full directory path of manifest file
#         containing manifest data (rows are probes and columns are subjects) 
#          (must contain columns: Array_Address_Id
#          Symbol, Chromosome, and ILMN_Gene)
# GConly -- logical. Indicates if only Genetic Control Samples will be output.
#
# outObjFilePrefix - output object file name without file extension
#
#manifestDir="/proj/reilms/reilm00/GX/Manifests/",
readData<-function(
  path, 
  pDat, 
  pattern="SampleProbeProfile.txt",
  QCpattern="QCProbeProfile.txt",
  GCid = c("128115", "Hela", "Brain"),
  GConly = FALSE, 
  manifestDir="Manifests/",
  nuIDFlag = FALSE,
  combineRule = c("union", "intersection"),
  hybName = "Hybridization_Name",
  chipManifest = "Chip_Manifest",
  probeID = "ProbeID",
  arrayAddressID = "Array_Address_Id", 
  probeSeq = "Probe_Sequence",
  reporterGroupName = "Reporter_Group_Name",
  saveFlag = TRUE, 
  outObjFileDir=NULL,
  outObjFilePrefix="es",
  outObjFilePrefixQC="esQC",
  verbose=TRUE
  )
{
  mywd = getwd()

  # read sample probe profile
  cat("\n*** read sample probe profile>>>\n")
  es.raw<-readData.default(
    path=path, 
    pDat=pDat, 
    pattern=pattern,
    sampleProbeFlag = TRUE,
    GCid = GCid, 
    GConly = GConly, 
    manifestDir=manifestDir,
    nuIDFlag = nuIDFlag,
    combineRule = combineRule,
    hybName = hybName,
    chipManifest = chipManifest,
    probeID = probeID,
    arrayAddressID = arrayAddressID, 
    probeSeq = probeSeq,
    saveFlag = FALSE,
    outObjFileDir=outObjFileDir,
    outObjFilePrefix=outObjFilePrefix,
    verbose=verbose
    )

  # read QC probe profile
  cat("\n*** read QC probe profile>>>\n")
  esQC.raw<-readData.default(
    path=path, 
    pDat=pDat, 
    pattern=QCpattern,
    sampleProbeFlag = FALSE,
    GCid = GCid, 
    GConly = GConly, 
    manifestDir=manifestDir,
    nuIDFlag = nuIDFlag,
    combineRule = combineRule,
    hybName = hybName,
    chipManifest = chipManifest,
    probeID = probeID,
    arrayAddressID = arrayAddressID, 
    probeSeq = probeSeq,
    saveFlag = FALSE,
    outObjFileDir=outObjFileDir,
    outObjFilePrefix=outObjFilePrefixQC,
    verbose=verbose
    )

  sn<-sampleNames(es.raw)
  sn.QC<-sampleNames(esQC.raw)

  pos<-match(sn, sn.QC)
  #if(length(sn) != length(sn.QC) || any(is.na(pos)==TRUE))
  if(!identical(sort(sn), sort(sn.QC)))
  {
    sn.diff<-setdiff(sn, sn.QC)
    snQC.diff<-setdiff(sn.QC, sn)
    if(length(sn.diff))
    {
      cat("\n*************************\n")
      cat("The following arrays which are in sample probe profile file\n")
      cat("but are not in QC probe profile file!\n")
      print(sn.diff) 
      cat("\n")
    }
    if(length(snQC.diff))
    {
      cat("\n*************************\n")
      cat("The following arrays which are in QC probe profile file\n")
      cat("but are not in sample probe profile file!\n")
      print(snQC.diff) 
      cat("\n")
    }

    setwd(mywd)
    stop("array names in sample probe files do not match those in QC probe files")
  } 
  esQC.raw<-esQC.raw[,pos]

  ########
  # added controlData slot to es.raw, and esQC.raw.
  # without controlData slot, we can not do bgAdjust.
  ########
  cat("\n**** adding controlData slot>>\n")
  dat.QC<-exprs(esQC.raw)
  rn<-rownames(dat.QC)
  mat.QC<-as.matrix(dat.QC)

  fDat.QC<-fData(esQC.raw)
  if(!identical(rn, as.character(fDat.QC[, c(probeSeq)])))
  {
    setwd(mywd)
    stop(paste("rownames(dat.QC) != fDat.QC$", probeSeq, sep=""))
  }
  rownames(mat.QC)<-as.character(fDat.QC[, c(reporterGroupName)])
  control<-as.data.frame(mat.QC)
  
  es.raw@controlData<-control
  esQC.raw@controlData<-control

  if(saveFlag)
  {
    if(verbose)
    { cat("\n****************************\n") 
      cat("\nSaving raw data>>>>>>>\n")
    }
  
    if(!is.null(outObjFileDir))
    { 
      setwd(outObjFileDir)
    } else {
      outObjFileDir = getwd()
    }
    outFile.u<-paste(outObjFilePrefix, ".raw.rda", sep="")
    outFileQC.u<-paste(outObjFilePrefixQC, ".raw.rda", sep="")
    if(verbose)
    { cat("output file dir is>>", outObjFileDir, "\n")
      cat("output file is>>", outFile.u, "\n")
      cat("output QC file is>>", outFileQC.u, "\n")
    }
    
    save(es.raw, file=outFile.u)
    save(esQC.raw, file=outFileQC.u)
  
  }
  setwd(mywd)

  res<-list(es.raw=es.raw, esQC.raw=esQC.raw)
  invisible(res)
}

# pDat must contain a column 'Hybridization_Name'
# to uniquely define each array
readData.default<-function(
  path, 
  pDat, 
  pattern="SampleProbeProfile.txt",
  sampleProbeFlag = TRUE,
  GCid = c("128115", "Hela", "Brain"),
  GConly = FALSE, 
  manifestDir="Manifests/",
  nuIDFlag = FALSE,
  combineRule = c("union", "intersection"),
  hybName = "Hybridization_Name",
  chipManifest = "Chip_Manifest",
  probeID = "ProbeID",
  arrayAddressID = "Array_Address_Id", 
  probeSeq = "Probe_Sequence",
  saveFlag = TRUE,
  outObjFileDir=NULL,
  outObjFilePrefix="esGC",
  verbose=TRUE
  )
{
  combineRule = match.arg(arg=combineRule, 
    choices=c("union", "intersection"))

  if(is.null(pDat))
  {
    stop("pDat is NULL!\n")
  }

  # check if the directory specified by
  # 'path' exists
  mywd = getwd()
  setwd(path)
  setwd(mywd)

  # check if the directory specified by
  # 'manifestDir' exists
  setwd(manifestDir)
  setwd(mywd)

  # check if the directory specified by
  # 'outObjFileDir' exists
  if(!is.null(outObjFileDir))
  { 
    setwd(outObjFileDir)
    setwd(mywd)
  } else {
    outObjFileDir <- getwd()
  }

  flag<-requireNamespace("lumi")
  if(!flag)
  { 
    setwd(mywd)
    stop("library 'lumi' is required to do vsn normalization!\n") 
  }
  
  hn<-as.character(pDat[, c(hybName)])
  if(is.null(hn))
  {
    setwd(mywd)
    stop(paste("phenotype data 'pDat' should contain the column titled ", hybName, sep=""))
  }
  if(length(unique(hn)) != length(hn))
  {
    setwd(mywd)
    stop(paste("The value of ", hybName, " must be unique!", sep=""))
  }
  tmpres<-extractIDs3(pDat=pDat, mySet=GCid, 
		      hybName=hybName,  
		      verbose=verbose)
  pos<-tmpres$pos
  n.pos<-length(pos)
  if(verbose)
  {
    cat("\n\n************************\n")
    cat("No. of arrays in pDat=", nrow(pDat), "\n")
    cat("No. of GC arrays in pDat=", n.pos, "\n")
    cat("\n\n************************\n")
  }
  if(GConly)
  {
    if(n.pos)
    {
      pDat<-pDat[pos, ,drop=FALSE] 
    } else {
      setwd(mywd)
      stop("No Genetic Controls samples in the pDat data set!\n")
    }
  }

  setwd(path)

  targs = list.files(path, pattern=pattern, 
    recursive=TRUE, full.names=TRUE)

  nFiles<-length(targs)
  if(verbose)
  {
    cat("\n************\n")
    cat("Number of", pattern, "  files = ", nFiles, "\n")
    cat("targs>>>\n"); print(targs); cat("\n");
    cat("\n************\n")
    if(nFiles==0)
    {
      setwd(mywd)
      stop("No files with naming containing the phrase ", pattern, " are found!\n")
    }

    cat("\n**************************\n")
    cat("Reading ", pattern, " files>>>>\n")
  }
  count <- 0
  for (i in 1:nFiles) 
  {
    if(verbose)
    {
      cat("\n ******* reading files .....\n")
      cat("\ni=", i, " targs[i]>>", targs[i], "\n")
    }
    ########
    # read SampleProbeProfile
    ########
    tmp = lumiR(targs[i], QC=FALSE)

    sn<-sampleNames(tmp)

    # since lumiR will automatically added suffix to duplicated arrays
    # so the following condition should be always be FALSE.
    # If not, then there must be something wrong. We stop the program then
    # to check what's wrong.
    tt<-table(sn)
    posi<-which(tt>1)
    n.posi<-length(posi)
    if(n.posi)
    {
      sn.sub<-names(tt[posi])
      tmpframe<-data.frame(sampleName=sn.sub, fileName=rep(targs[i], n.posi))
      cat("\n************************\n")
      cat("length(unique(sampleNames(tmp))) =", length(unique(sn)) , "< length((sampleNames(tmp))) =", length((sn)) , "\n")
      cat("The following sample ids have duplicates\n")
      print(tmpframe)
      cat("\n************************\n")
      setwd(mywd) 
      stop("sampleNames in a LumiBatch object should be unique!")

    }

    noGC = FALSE

    if(GConly)
    {
      tmpres<-extractIDs(sampleIDs=sampleNames(tmp), mySet=GCid, verbose=verbose)
      pos<-tmpres$pos
      if(length(pos)==0)
      { 
        noGC <- TRUE
      } else {
        tmp<-tmp[,pos]
      } 
    }

    if(!noGC || (!GConly)) # contains GC samples
    {
      count <- count + 1
      if(verbose)
      { cat("dim(tmp)>>\n"); print(dim(tmp)); cat("\n"); 
        if(count > 1)
        {
          cat("\nCombining LumiBatch objects>>>\n")
        }
      }

      # get probe ids
      probeName.i<-as.numeric(as.character(featureNames(tmp)))
  
      # some arrays have different orders of rows
      # so we have to sorted rows for each array
      # sort probe IDs
      tmpmat.i<-cbind(probeName.i, 1:length(probeName.i))
      tmpmat.i2<-tmpmat.i[order(tmpmat.i[,1]),]
      rm(tmpmat.i)
     
      # sort the rows of mat.i by probe IDs
      # the reason to do this is to avoid
      # the cases in which some chips have different orders
      # to put probe IDs (i.e. row names are different by orders)
      x.lumi.i<-tmp[tmpmat.i2[,2],]
      rm(tmp)
      rm(tmpmat.i2)

      # add feature data  
      # match the samples in expression file with those in pData file
      # so that we can know which chip version they from
      # Hence, we can read in feature data file and extract 
      # sequence info for merging purpose
      sampleIDs.i<-sampleNames(x.lumi.i)
      aa<-match(sampleIDs.i, as.character(pDat[, c(hybName)]))
      tmppos<-which(is.na(aa)==FALSE)
      if(length(tmppos))
      { 
        chipMani<-as.character(pDat[, c(chipManifest)])
        chipver<-as.character(chipMani[aa[tmppos]])
        if(any(is.na(chipver)==TRUE))
        {
          setwd(mywd)
          #stop("There are empty chip version in pDat!")
          cat("\nWarning: There are empty chip version in pDat!")
        }
        if(length(table(chipver))!=1)
        { setwd(mywd) 
          print(table(chipver, useNA="ifany"))
          #stop("The arrays in the same SampleProbeProfile are from different chip version!\n")
          cat("\nWarning: The arrays in the same SampleProbeProfile are from different chip version!\n")
        }
        setwd(manifestDir)
        manifestFileVec = list.files(manifestDir, pattern=unique(chipver), 
          recursive=TRUE, full.names=TRUE)
        setwd(mywd)
        if(length(manifestFileVec)!=1)
        { cat("chip version>>\n"); print(chipver); cat("\n"); 
          setwd(mywd)
          #stop("There is no manifest file match the chip version!\n")
          cat("\nWarning: There is no manifest file match the chip version!\n")
        }
      
        manifestFile.i<-manifestFileVec[1] 
        if(count ==1 )
        { manifestFile = manifestFile.i }
        if(count==1 || !identical(manifestFile, manifestFile.i))
        {
          # read feature data file 
          tmp.bgx<-readbgx(filename=manifestFile.i, sep="\t",
            quote="", header=TRUE, probeStart="[Probes]",
            controlStart="[Controls]") 
          if(sampleProbeFlag)
          { 
            probeAnno.i<-tmp.bgx$probeAnno
          } else {
            probeAnno.i<-tmp.bgx$controlAnno
          }
        } 
        if(verbose)
        { cat("Adding manfiest data>>>>\n") }
        tt<-addfDat(x.lumi.i, probeAnno.i, 
          featureID.es=probeID, featureID.fDat=arrayAddressID,
          probeSeq = probeSeq, 
          verbose=verbose)
        if(!is.null(tt))
        {
          x.lumi.i<-tt
        } else {
          setwd(mywd)
          stop("Error occurs in function 'addfDat'!")
        }
      } else {
        setwd(mywd)
        cat("\n********************\n")
        cat("\nSamples in the expression files>>>\n")
        print(sampleIDs.i)
        cat("\n********************\n")
        stop("All samples in expression sets are not in pDat!\n")
      }
      setwd(mywd) 


      # use Probe_Sequence as featureNames
      # but Probe_Sequence might not be unique
      # that is, some Probe_Sequence correspond to multiple ProbeIDs
      # merge duplicates and replace feature names
      #  by featureID.es.
      tt<-mergeDuplicates(x.lumi.i, featureID.es=probeSeq)
      if(!is.null(tt))
      {
        x.lumi.i<-tt
      } else {
        setwd(mywd)
        stop("Error occurred in function 'mergeDuplicates'!")
      }

      manifestFile <- manifestFile.i
      if(count>1)
      { 
        tti<-myCombine(x=x.lumi, y=x.lumi.i, combineRule=combineRule, suffix=paste("_", i, sep=""))
        if(is.null(tti))
        {
          setwd(mywd)
          stop("Error in myCombine!\n")
        }
        x.lumi<-tti
      } else {
        x.lumi <- x.lumi.i
      }
      rm(x.lumi.i)
    } else if(GConly && noGC) {
      if(verbose)
      { cat("\n***********\n")
        setwd(mywd)
        stop("GConly=TRUE, but no GC samples!\n")
        cat("\n***********\n")
      }
    }
  }
  setwd(mywd)
  if(count==0)
  {
    setwd(mywd)
    stop("No required expression data avaiable!\n")
  }

  if(verbose)
  { cat("\n****************************\n") 
    cat("merging expression data with phenotype data>>>\n")
  }

  newname.mRNA=as.character(sampleNames(x.lumi))
  subj.pDat<-as.character(pDat[, c(hybName)])

  tt<-match(as.character(newname.mRNA), as.character(subj.pDat))
  pos<-which(is.na(tt)==FALSE)
  if(length(pos)==0)
  {
    setwd(mywd)
    stop("subjects in pDat do not match those in expression data!\n")
  }
  if(length(pos)<length(newname.mRNA))
  {
    if(verbose)
    { cat("\n*********\n")
      cat("\nWarnings: some subjects in expression data do not match those in pDat!\n")
    }
    pos.na<-which(is.na(tt)==TRUE)
    if(verbose)
    {
      cat("These subjects are>>\n")
      print(newname.mRNA[pos.na])
      cat("\n")
      cat("These arrays will be dropped!\n")
      cat("\n*********\n")
    }
  }
  x.lumi<-x.lumi[,pos]
  newname.mRNA<-sampleNames(x.lumi)
  pDat<-pDat[tt[pos],]
  subj.pDat<-as.character(pDat[, c(hybName)])

  flag<-identical(subj.pDat, newname.mRNA)
  if(!flag)
  { 
    setwd(mywd)
    stop("subjIDs in SampleProbe are different from those in phenoData!\n") 
  }

  rownames(pDat)=as.character(pDat[,c(hybName)])
  Biobase::sampleNames(x.lumi)=as.character(pDat[,c(hybName)])

  Biobase::pData(x.lumi)<-pDat
  es<-x.lumi
  rm(x.lumi)
  rm(pDat)

  pDat<-pData(es)

  # chip version
  if(verbose)
  { cat("\n************\n")
    cat("Frequencies of Chip versions>>\n")
    print(table(as.character(pDat[, c(chipManifest)]), useNA="ifany"))
    cat("\n")
    cat("\n************\n")
  }

#  # sort the arrays according
#  #   Batch_Run_Date
#  #   chip barcode (Chip_Barcode)
#  #   array position (Chip_Address)
#  if(verbose)
#  { cat("\n****************************\n") 
#    cat("\n Sort arrays according to Batch_Run_Date, Chip_Barcode, and Chip_Address>>>\n")
#  }
#  es.raw<-sortExpressionSet(es)

  es.raw<-es
  rm(es)

  # get nuIDs
  if(nuIDFlag)
  {
    fDat<-fData(es.raw)
    nuIDs<-seq2id(as.character(fDat[, c(probeSeq)]))
    fDat$nuIDs<-nuIDs
    Biobase::fData(es.raw)<-fDat
    #featureNames(es.raw)<-nuIDs
  }

  if(verbose)
  { cat("dim(es.raw)>>\n"); print(dim(es.raw)); cat("\n"); }

  if(verbose)
  { cat("\n**************************\n")
    cat("Dimension of raw LumiBatch>>>>\n")
    print(dim(es.raw))
    cat("\n")
  }
  if(saveFlag)
  { 

    if(verbose)
    { cat("\n****************************\n") 
      cat("\nSaving raw data>>>>>>>\n")
    }

    if(!is.null(outObjFileDir))
    { 
      setwd(outObjFileDir)
    } else {
      outObjFileDir = getwd()
    }
    outFile.u<-paste(outObjFilePrefix, ".raw.rda", sep="")
    if(verbose)
    { cat("output file dir is>>", outObjFileDir, "\n")
      cat("output file is>>", outFile.u, "\n")
    }
  
    save(es.raw, file=outFile.u)

  }
  setwd(mywd)

  invisible(es.raw)
}

# 
# fixed a bug on Jan 18, 2013
# fDat must have column: Array_Address_Id
# fDat must match the version of chip creating es 
addfDat<-function(es, fDat, featureID.es="ProbeID",
  featureID.fDat="Array_Address_Id", probeSeq = "Probe_Sequence", 
  verbose=TRUE)
{
  if(is.null(fDat[, c(featureID.fDat)]))
  {
    cat("Error: fDat does not have column titled", featureID.fDat, "!\n")
    return(NULL) 
  }
  if(!identical(featureNames(es), fData(es)[, c(featureID.es)]))
  {
    cat("Error: featureNames(es) not equal to ", featureID.es, "!\n") 
    return(NULL)
  }
  if(verbose)
  { cat("\n****************************\n") 
    cat("Adding feature data >>>>\n")
  }
  # update feature data
  ff<-featureNames(es)
  ff.fDat<-as.character(fDat[, c(featureID.fDat)])

  aa<-intersect(ff, ff.fDat) 
  if(length(aa))
  {
    fDat.es<-Biobase::fData(es)
    # check if there are any overlapping column names
    # except featureID.es and featureD.fDat
    int<-intersect(colnames(fDat.es), colnames(fDat))
    len<-length(int)
    if(len)
    {
      int2<-setdiff(int, c(featureID.es, featureID.fDat))
      if(length(int2))
      {
        fDat<-fDat[, -which(colnames(fDat) %in% int2), drop=FALSE]
      }
    }
    #pos.sel<-match(ff, ff.fDat)
    #fDat2<-fDat[pos.sel[which(is.na(pos.sel)==FALSE)],]
    bb2<-merge(x=fDat.es, y=fDat, by.x=featureID.es, 
        by.y=featureID.fDat, all.x=TRUE, sort=FALSE)

    rm(fDat.es)
    #rm(fDat)

    # update the feature data of 'es'
    pos<-match(ff, as.character(bb2[, c(featureID.es)]))
    bb3<-bb2[pos,]
    #ff2<-ff[pos]
    rm(bb2)

    if(!identical(as.character(bb3[, c(featureID.es)]), ff))
    {
      cat("Error: bb3[, ", featureID.es, "] != ff!\n")
      return(NULL)
    }
    
    #rownames(bb3)<-ff2
    rownames(bb3)<-ff
    Biobase::fData(es)<-bb3

    pos.del<-which(is.na(as.character(bb3[, c(probeSeq)]))==TRUE)
    if(length(pos.del))
    {
      cat("Warning: the following probes have missing", probeSeq, " and will be deleted>>>\n")
      print(fData(es)[pos.del,])
      cat("\n")
      es<-es[-pos.del,]
    }
    invisible(es)
  
  } else {
    cat("Error: No overlapping between featureNames(es) and ", featureID.fDat,"!\n")
    return(NULL)
  }
}



# Sort arrays according to Batch_Run_Date, Chip_Barcode, and Chip_Address
sortExpressionSet<-function(es, 
  varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
  timeFormat = c("%m/%d/%Y", NA, NA)
)
{
  pDat<-pData(es)
  cn<-colnames(pDat)
 
  len<-length(varSort)
  if(len!=length(timeFormat))
  { stop("varSort should have the same length as timeFormt!") }

  pos.nonNA<-which(is.na(timeFormat)==FALSE)
  len.t<-length(pos.nonNA)

  if(len.t)
  {
    for(i in 1:len.t)
    {
      ttpos<-which(cn==varSort[pos.nonNA[i]])
      tt<-attributes(pDat[, ttpos])$class[1]
      tt2<-substr(tt, start=1, stop=4)
      tt3<-as.character(pDat[, ttpos])
      if(!is.null(tt) && tt2=="POSI")
      {
  
      } else {
        # %Y not %y
        # %Y Year with century
        # %y Year without century (00-99)
        tt4<-strptime(tt3, format=timeFormat[pos.nonNA[i]])
        pDat[, ttpos]<-as.character(tt4)
      }
    }  
  }  

  pDat$pos<-1:nrow(pDat)

  if(len>1)
  { 
    pDat2<-pDat[do.call(order, pDat[, c(varSort)]),]
  } else {
    pDat2<-pDat[order(pDat[, c(varSort)]),]
  }

  pos.s<-as.numeric(as.character(pDat2$pos))
  es<-es[,pos.s]
  rm(pDat2)
  invisible(es)
}


# merge duplicates and replace feature names
#  by featureID.es.
# copy and revised from function lumi::lumiR
# and from method Biobase::setReplaceMethod
# (1) To simplify the process, we use sample average for duplicated probes
# for 'exprs', 'se.exprs', 'detection', etc.
# 'lumiR' uses more complicated formula to merge duplicated probes
#  for 'se.exprs', 'detection', etc.  
# (2) 'lumiR' uses 'probeID' as id. But some time, a Probe_Sequence 
#     can have 2 different probeIDs
mergeDuplicates<-function(x.lumi.i, featureID.es="Probe_Sequence")
{
  try(id<-as.character(fData(x.lumi.i)[, featureID.es]), silent=TRUE)
  if(length(id)==0)
  {
    cat("Error:", featureID.es, " is not in fData(x.lumi.i)!\n")
    return(NULL)
  }
  dupId <- unique(id[duplicated(id)])

  obj<-x.lumi.i
  if (length(dupId) > 0) {
      cat("Duplicated Probe_Sequence found and were merged!\n")

      storage.mode <- Biobase::storageMode(obj)
      switch(storage.mode,
             "lockedEnvironment" = {
                 aData <- Biobase::copyEnv(obj@assayData)

                 eltVec<-Biobase::assayDataElementNames(obj)
                 for(elt in eltVec)
                 {
                    rmInd <- NULL
                    for (dupId.i in dupId) {
                      selInd.i <- which(id == dupId.i)
                      aData[[elt]][selInd.i[1], ] <- colMeans(aData[[elt]][selInd.i, , drop = FALSE], na.rm=TRUE)
                      rmInd <- c(rmInd, selInd.i[-1])
                    }
                    if(length(rmInd))
                    { 
                      aData[[elt]]<-aData[[elt]][-rmInd,, drop=FALSE] 
                    }
                 }
               #  Biobase:::assayDataEnvLock(aData)
                 obj@assayData <- aData
             },
             "environment" = {
                 aData <- obj@assayData
                 eltVec<-Biobase::assayDataElementNames(obj)
                 for(elt in eltVec)
                 {
                    rmInd <- NULL
                    for (dupId.i in dupId) {
                      selInd.i <- which(id == dupId.i)
                      aData[[elt]][selInd.i[1], ] <- colMeans(aData[[elt]][selInd.i, , drop = FALSE], na.rm=TRUE)
                      rmInd <- c(rmInd, selInd.i[-1])
                    }
                    if(length(rmInd))
                    {
                      aData[[elt]]<-aData[[elt]][-rmInd,, drop=FALSE]
                    }
                 }
                 obj@assayData <- aData
             }
      )
      #obj
      if (!is.null(fData(obj)) && length(rmInd)) 
      {
        Biobase::fData(obj)<-fData(obj)[-rmInd,,drop=FALSE]
      }
  }
  Biobase::featureNames(obj)<-as.character(fData(obj)[, c(featureID.es)])

  invisible(obj)
}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{iCheck}
%\VignetteKeywords{Illumina, expression, QC}
%\VignetteDepends{iCheck, Biobase, gplots, preprocessCore, lumi, affy, MASS, scatterplot3d, GeneSelectMMD, randomForest, rgl}
%\VignettePackage{iCheck}

\documentclass[a4paper]{article}

\usepackage{amsmath,pstricks}
\usepackage{hyperref}
\usepackage[authoryear,round]{natbib}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\textit{#1}}}

\SweaveOpts{keep.source=TRUE}

\author{Weiliang Qiu$^\ddagger$\footnote{stwxq (at) channing.harvard.edu}, 
Brandon Guo$^\ddagger$\footnote{brandowonder (at) gmail.com},
Christopher Anderson$^\ddagger$\footnote{christopheranderson84 (a) gmail.com},
Barbara Klanderman$^\ddagger$\footnote{BKLANDERMAN (at) partners.org},\cr
Vincent Carey$^\ddagger$\footnote{stvjc (at) channing.harvard.edu}, 
Benjamin Raby$^\ddagger$\footnote{rebar (at) channing.harvard.edu}}

\begin{document}
\SweaveOpts{concordance=TRUE}

\setkeys{Gin}{width=1\textwidth}

\title{iCheck: A package checking data quality of Illumina expression data}
\maketitle
\begin{center}$^\ddagger$Channing Division of Network Medicine \\ Brigham and Women's Hospital / Harvard Medical School \\ 181 Longwood Avenue, Boston, MA, 02115, USA
\end{center}

\tableofcontents
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Overview of iCheck}

The \texttt{iCheck} package provides QC pipeline and data analysis tools 
for high-dimensional Illumina mRNA expression data.
It provides several visualization tools to help identify gene probes with outlying expression 
levels, arrays with low quality, batches caused technical factors, batches caused 
by biological factors, and gender mis-match checking, etc.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

We first generate a simulated data set to illustrate the usage of iCheck functions.
<<echo=TRUE, eval=TRUE,print=FALSE>>=
  library(iCheck)

  if (!interactive())
  {
    options(rgl.useNULL = TRUE)
  }

  # generate sample probe data 
  set.seed(1234567)
  es.sim = genSimData.BayesNormal(nCpGs = 110, 
    nCases = 20, nControls = 20,
    mu.n = -2, mu.c = 2,
    d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
    outlierFlag = FALSE, 
    eps = 1.0e-3, applier = lapply) 
  print(es.sim)

  # create replicates
  dat=exprs(es.sim)
  dat[,1]=dat[,2]
  dat[,3]=dat[,4]
  

  exprs(es.sim)=dat
  es.sim$arrayID=as.character(es.sim$arrayID)
  es.sim$arrayID[1]=es.sim$arrayID[2]
  es.sim$arrayID[3]=es.sim$arrayID[4]
  es.sim$arrayID[5:8]="Hela"

  # since simulated data set does not have 'Pass_Fail',
  #  'Tissue_Descr', 'Batch_Run_Date', 'Chip_Barcode',
  #  'Chip_Address', 'Hybridization_Name', 'Subject_ID', 'gender'
  # we generate them now to illustrate the R functions in the package 

  es.sim$Hybridization_Name = paste(es.sim$arrayID, 1:ncol(es.sim), sep="_")
  # assume the first 4 arrays are genetic control samples
  es.sim$Subject_ID = es.sim$arrayID

  es.sim$Pass_Fail = rep("pass", ncol(es.sim))

  # produce genetic control GC samples
  es.sim$Tissue_Descr=rep("CD4", ncol(es.sim))
  # assume the first 4 arrays are genetic control samples
  es.sim$Tissue_Descr[5:8]="Human Hela Cell"

  es.sim$Batch_Run_Date = 1:ncol(es.sim)
  es.sim$Chip_Barcode = 1:ncol(es.sim)
  es.sim$Chip_Address = 1:ncol(es.sim)

  es.sim$gender=rep(1, ncol(es.sim))
  set.seed(12345)
  pos=sample(x=1:ncol(es.sim), size=ceiling(ncol(es.sim)/2), replace=FALSE) 
  es.sim$gender[pos]=0


  # generate sample probe data 
  es.raw = es.sim[-c(1:10),]
  print(es.raw)
  
  # generate QC probe data 
  es.QC = es.sim[c(1:10),]

  # since simulated data set does not have 'Reporter_Group_Name'
  #  we created it now to illustrate the usage of 'plotQCCurves'.
  fDat=fData(es.QC)
  fDat$Reporter_Group_Name=rep("biotin", 10)
  fDat$Reporter_Group_Name[3:4]="cy3_hyb"
  fDat$Reporter_Group_Name[5:6]="housekeeping"
  fDat$Reporter_Group_Name[7:8]="low_stringency_hyb"
  fData(es.QC)=fDat

  print(es.QC)
  
@

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Exclude failed arrays}
The meta data variable \verb+Pass_Fail+ indicates if
an array is technically failed. We first should exclude
these arrays.

We first check the values of the variable \verb+Pass_Fail+:
<<echo=TRUE, eval=TRUE,print=FALSE>>=
print(table(es.raw$Pass_Fail, useNA="ifany"))
@

If there exist failed arrays, then we exclude them:

<<echo=TRUE, eval=TRUE,print=FALSE>>=
pos<-which(es.raw$Pass_Fail != "pass")
if(length(pos))
{
  es.raw<-es.raw[, -pos]
  es.QC<-es.QC[, -pos]
}
@


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Check QC probes}
The function \verb+plotQCCurves+ shows plot of quantiles
across arrays for each type of QC probes.
We expect the trajectories of quantiles across arrays are horizontal lines.

To get a better view, the arrays will be sorted based on variables
specified in the function argument \verb+varSort+.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

     plotQCCurves(
         esQC=es.QC,
         probes = c("biotin"), #"cy3_hyb", "housekeeping"),
           #"low_stringency_hyb"),
         labelVariable = "subjID",
         hybName = "Hybridization_Name",
         reporterGroupName = "Reporter_Group_Name",
         requireLog2 = FALSE,
         projectName = "test",
         plotOutPutFlag = FALSE,
         cex = 1,
         ylim = NULL,
         xlab = "",
         ylab = "log2(intensity)",
         lwd = 3,
         mar = c(10, 4, 4, 2) + 0.1,
         las = 2,
         cex.axis = 1,
         sortFlag = TRUE,
         varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat = c("%m/%d/%Y", NA, NA)
       )  
@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Check squared correlations among genetic control (GC) arrays}

Next, we draw heatmap of the squared correlations among GC arrays.
We expect the squared correlations among GC arrays are high ($>0.90$).

The function argument \verb+labelVariable+ indicates
which meta variable will be used to label the arrays in the 
heatmap.

If we draw heatmap for replicated arrays, we can set
the function arguments \verb+sortFlag=TRUE+,

{\scriptsize
\begin{verbatim}
varSort=c("Subject_ID", "Hybridization_Name", 
  "Batch_Run_Date", "Chip_Barcode", "Chip_Address")

and

timeFormat=c(NA, NA, "%m/%d/%Y", NA, NA)

\end{verbatim}
}
so that arrays from the same subjects will be grouped together
in the heatmap.

Note that although the meta variable \verb+Batch_Run_Date+ records
time, it is vector of string character in R. The function 
\verb+R2PlotFunc+ will automatically convert it to time variable
if we set the value of the argument \verb+timeFormat+ corresponding
to the variable \verb+Batch_Run_Date+ as a time format like
\verb+"%m/%d/%Y"+. Details about the time format, please see
the R function \verb+strptime+.

The followings show example R code to draw  heatmap of
GC arrays.
<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

     R2PlotFunc(
         es=es.raw,
         hybName = "Hybridization_Name",
         arrayType = "GC",
         GCid = c("128115", "Hela", "Brain"),
         probs = seq(0, 1, 0.25),
         col = gplots::greenred(75),
         labelVariable = "subjID",
         outFileName = "test_R2_raw.pdf",
         title = "Raw Data R^2 Plot",
         requireLog2 = FALSE,
         plotOutPutFlag = FALSE,
         las = 2,
         keysize = 1,
         margins = c(10, 10),
         sortFlag = TRUE,
         varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat=c("%m/%d/%Y", NA, NA)
       )  
@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Exclude GC arrays}

We next exclude GC arrays and will focus on sample arrays to check
data quality.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=FALSE>>=
print(table(es.raw$Tissue_Descr, useNA="ifany"))

# for different data sets, the label for GC arrays might
# be different.
pos.del<-which(es.raw$Tissue_Descr == "Human Hela Cell")
cat("No. of GC arrays=", length(pos.del), "\n")

if(length(pos.del))
{
  es.raw<-es.raw[,-pos.del]
  es.QC<-es.QC[,-pos.del]
  print(dims(es.raw))
  print(dims(es.QC))
}
@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Check squared correlations among replicated arrays}
Check squared correlations among replicated arrays (excluding GC arrays).
We expect within subject correlations will be high.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

     R2PlotFunc(
         es=es.raw,
         arrayType = c("replicates"),
         GCid = c("128115", "Hela", "Brain"),
         probs = seq(0, 1, 0.25),
         col = gplots::greenred(75),
         labelVariable = "subjID",
         outFileName = "test_R2_raw.pdf",
         title = "Raw Data R^2 Plot",
         requireLog2 = FALSE,
         plotOutPutFlag = FALSE,
         las = 2,
         keysize = 1,
         margins = c(10, 10),
         sortFlag = TRUE,
         varSort=c("Subject_ID", "Hybridization_Name", "Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat=c(NA, NA, "%m/%d/%Y", NA, NA)
       )  

@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Obtain plot of estimated density for each array}
% detect bad arrays

We next draw plot of estimated density for each array.
We expect the estimated densities of all arrays to be similar.
However, for real data, some patterns of the estimated densities
might appear indicating the existence of some batch effects.

Note that by default, the function argument \verb+requireLog2 = TRUE+.
Since the distributions of simulated data are from normal distribution,
we don't need to do log2 transformation here.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=
    densityPlots(
      es = es.raw, 
      requireLog2 = FALSE,
      myxlab = "expression level", 
      datExtrFunc = exprs, 
      fileFlag = FALSE, 
      fileFormat = "ps", 
      fileName = "densityPlots_sim.ps")

@



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Obtain plot of quantiles across arrays}
% detect bad arrays and/or outlying expression levels

We next draw plot of quantiles across sample arrays.
We expect the trajectories of quantiles be horizontal.
However, for real data, some patterns of the trajectories
might appear indicating the existence of some batch effects.

Some times, the quantile plots can show that 
some probes have some outlying expression levels.
In this case, we can delete those gene probes.

Note that by default, the function argument \verb+requireLog2 = TRUE+.
Hence, we need to take log2 transformation to identify which 
gene probes containing outlying expression levels.

By default, we will sort the arrays by the ascending order of
the median absolute deviation (MAD) to have a better view
of the trajectories of quantiles.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=
     quantilePlot(
         dat=exprs(es.raw),
         fileName,
         probs = c(0, 0.05, 0.25, 0.5, 0.75, 0.95, 1),
         plotOutPutFlag = FALSE,
         requireLog2 = FALSE,
         sortFlag = TRUE,
         cex = 1,
         ylim = NULL,
         xlab = "",
         ylab = "log2(intensity)",
         lwd = 3,
         main = "Trajectory plot of quantiles\n(sample arrays)",
         mar = c(15, 4, 4, 2) + 0.1,
         las = 2,
         cex.axis = 1
         )
@


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Exclude gene probes with outlying expression levels}
if quantile plots show some outlying expression levels, we
can use the following R code to identify the gene probes
with outlying expression levels.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=FALSE>>=
# note we need to take log2 transformation
# if requireLog2 = TRUE.
requireLog2 = FALSE
if(requireLog2)
{  
  minVec<-apply(log2(exprs(es.raw)), 1, min, na.rm=TRUE)
  # suppose the cutoff is 0.5
  print(sum(minVec< 0.5))
  pos.del<-which(minVec<0.5)

  cat("Number of gene probes with outlying expression levels>>",
  length(pos.del), "\n")
  if(length(pos.del))
  {
    es.raw<-es.raw[-pos.del,]
  }
}

@


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Obtain plot of the ratio ($p_{95}/p_{05}$) of 95-th percentile to 5-th percentile across arrays}
% detect bad arrays

We next draw the plot of the ratio of p95 over p05 across arrays,
where p95 (p05) is the 95-th (5-th) percentile of a array.
If an array with the ratio $p95/p05$ is less than $6$, then we regard
this array as a bad array and should delete it before further analysis.

Note that we should set \verb+requireLog2 = FALSE+.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

     plotSamplep95p05(
         es=es.raw,
         labelVariable = "memSubj",
         requireLog2 = FALSE,
         projectName = "test",
         plotOutPutFlag = FALSE,
         cex = 1,
         ylim = NULL,
         xlab = "",
         ylab = "",
         lwd = 1.5,
         mar = c(10, 4, 4, 2) + 0.1,
         las = 2,
         cex.axis=1.5,
         title = "Trajectory of p95/p05",
         cex.legend = 1.5,
         cex.lab = 1.5,
         legendPosition = "topright",
         cut1 = 10,
         cut2 = 6,
         sortFlag = TRUE,
         varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"),
         timeFormat = c("%m/%d/%Y", NA, NA),
         verbose = FALSE)
@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Exclude arrays with $p_{95}/p_{05}\leq 6$}
If there exist arrays with $p95/p05<6$, we then need to 
exclude these arrays from further data analysis. The followings
are  example R code:

<<echo=TRUE, eval=TRUE,print=FALSE>>=
p95<-quantile(exprs(es.raw), prob=0.95)
p05<-quantile(exprs(es.raw), prob=0.05)

r<-p95/p05
pos.del<-which(r<6)
print(pos.del)

if(length(pos.del))
{
  es.raw<-es.raw[,-pos.del]
  es.QC<-es.QC[,-pos.del]
}

@




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Obtain Plot of principal components}
% check batch effects 

We next draw pca plots to double check batch effects
or treatment effects indicated by dendrogram.

The first step is to obtain principal components using
the function \verb+getPCAFunc+.
For large data set, this function might be very slow.

<<echo=TRUE, eval=TRUE,print=FALSE>>=

     pcaObj<-getPCAFunc(es=es.raw,
                labelVariable = "subjID",
                requireLog2 = FALSE,
                corFlag = FALSE
              
               
     )

@

We then plot the first 2 or 3 principal components and label
the data points by meta variables of interests, such as
tissue type, study center, batch id, etc..

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

     pca2DPlot(pcaObj=pcaObj,
               plot.dim = c(1,2),
               labelVariable = "memSubj",
               outFileName = "test_pca_raw.pdf",
               title = "Scatter plot of pcas (memSubj)",
               plotOutPutFlag = FALSE,
               mar = c(5, 4, 4, 2) + 0.1,
               lwd = 1.5,
               equalRange = TRUE,
               xlab = NULL,
               ylab = NULL,
               xlim = NULL,
               ylim = NULL,
               cex.legend = 1.5,
               cex = 1.5,
               cex.lab = 1.5,
               cex.axis = 1.5,
               legendPosition = "topright"
             
               )
@




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Perform background correction, data transformation and normalization}

<<echo=TRUE, eval=TRUE,print=FALSE>>=
tt <- es.raw
es.q<-lumiN(tt, method="quantile")
@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Obtain Plot of principal components for pre-processed data}
% check batch effects 

After pre-processing data, we do  principal component analysis again.

Note that we should set 
         \verb+requireLog2 = FALSE+.


<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=
     pcaObj<-getPCAFunc(es=es.q,
                labelVariable = "subjID",
                requireLog2 = FALSE,
                corFlag = FALSE
                
     )


     pca2DPlot(pcaObj=pcaObj,
               plot.dim = c(1,2),
               labelVariable = "memSubj",
               outFileName = "test_pca_raw.pdf",
               title = "Scatter plot of pcas (memSubj)\n(log2 transformed and quantile normalized)",
               plotOutPutFlag = FALSE,
               mar = c(5, 4, 4, 2) + 0.1,
               lwd = 1.5,
               equalRange = TRUE,
               xlab = NULL,
               ylab = NULL,
               xlim = NULL,
               ylim = NULL,
               cex.legend = 1.5,
               cex = 1.5,
               cex.lab = 1.5,
               cex.axis = 1.5,
               legendPosition = "topright"
               )

@


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Incorporate phenotype data}
In addition meta data, we usually have phenotype data to
describe subjects. We can now add them in.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Data analysis}

\subsection{lmFitWrapper and lmFitPaired}
\verb+iCheck+ provide 2 limma wrapper functions
\verb+lmFitPaired+ (for paired data) and 
\verb+lmFitWrapper+ (for unpaired data).

Note that the function argument
\verb+pos.var.interest = 1+ requests the results 
(test statistic and p-value) for the first covariate
will be print out.

If \verb+pos.var.interest = 0+, then the results 
(test statistic and p-value) for the intercept
will be print out.

The outcome variable must be gene probes. Can not be phenotype variables.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=FALSE>>=

res.limma=lmFitWrapper(
  es=es.q, 
  formula=~as.factor(memSubj), 
  pos.var.interest = 1,
  pvalAdjMethod="fdr", 
  alpha=0.05, 
  probeID.var="probe", 
  gene.var="gene", 
  chr.var="chr", 
  verbose=TRUE)

@


%%%%%%%%%%%%%%%%%%
\subsection{glmWrapper}
outcome variable can be phenotype variables. The function argument
\verb+family+ indicates if logistic regression (\verb+family=binomial+) used
or general linear regression (\verb+family=gaussian+) used.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=FALSE>>=

res.glm=glmWrapper(
  es=es.q,
  formula = xi~as.factor(memSubj), 
  pos.var.interest = 1,
  family=gaussian,
  logit=FALSE, 
  pvalAdjMethod="fdr", 
  alpha = 0.05, 
  probeID.var = "probe", 
  gene.var = "gene", 
  chr.var = "chr", 
  applier=lapply,
  verbose=TRUE 
  )

@


\subsection{lkhrWrapper}

Likelihood ratio test wrapper. Compare 2 glm models. One is reduced model. The other is full model.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=FALSE>>=

res.lkh=lkhrWrapper(
  es=es.q,
  formulaReduced = xi~as.factor(memSubj), 
  formulaFull = xi~as.factor(memSubj)+gender, 
  family=gaussian,
  logit=FALSE, 
  pvalAdjMethod="fdr", 
  alpha = 0.05, 
  probeID.var = "probe", 
  gene.var = "gene", 
  chr.var = "chr", 
  applier=lapply,
  verbose=TRUE 
  )

@


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Result Visualization}
Once we get analysis results, we need to check if the results
are reasonable or not (e.g,were results affected by outliers?).

If the phenotype variable of interest is a binary type variable,
then we can draw parallel boxplots of expression level versus
the phenotype for each of top results.
\texttt{iCheck} provides
function \verb+boxPlots+ to do such a task.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

    boxPlots(
      resFrame = res.limma$frame, 
      es = es.sim, 
      col.resFrame = c("probeIDs", "stats", "pval", "p.adj"), 
      var.pheno = "memSubj", 
      var.probe = "probe", 
      var.gene = "gene", 
      var.chr = "chr", 
      nTop = 20, 
      myylab = "expression level", 
      datExtrFunc = exprs, 
      fileFlag = FALSE, 
      fileFormat = "ps", 
      fileName = "boxPlots_sim.ps")

@


If the phenotype variable of interest is a continous type variable,
then we can draw scatter plot of expression level versus
the phenotype for each of top results. \texttt{iCheck} provides
function \verb+scatterPlots+ to do such a task.

<<echo=TRUE, eval=TRUE,print=FALSE,fig=TRUE>>=

    # regard memSubj as continuos for illustration purpose
    scatterPlots(
      resFrame = res.limma$frame, 
      es = es.sim, 
      col.resFrame = c("probeIDs", "stats", "pval", "p.adj"), 
      var.pheno = "memSubj", 
      var.probe = "probe", 
      var.gene = "gene", 
      var.chr = "chr", 
      nTop = 20, 
      myylab = "expression level", 
      datExtrFunc = exprs, 
      fileFlag = FALSE, 
      fileFormat = "ps", 
      fileName = "scatterPlots_sim.ps")

@



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\section{Session Info}
Finally, we need to print out the session info so that
later we can know which versions the packages are from.

<<sessionInfo, results=tex, print=TRUE>>=
toLatex(sessionInfo())
@ 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\section{Citation}
%\section{Acknowledgments}

%\section{References}

%\bibliographystyle{plainnat}
%\bibliography{iCheck}


\end{document}

\name{getPCAFunc}
\alias{getPCAFunc}
\title{
Get principal components of arrays
}
\description{
Get principal components of arrays.
}
\usage{
getPCAFunc(es, 
           labelVariable = "subjID", 
            hybName = "Hybridization_Name",
           requireLog2 = TRUE,
           corFlag = FALSE
)
}
\arguments{
  \item{es}{
An \code{ExpressionSet} object
}
  \item{labelVariable}{
A character string.
The name of a phenotype data variable use to
label the arrays in the boxplots. By default, 
\code{labelVariable = "subjID"} which is equivalent
to \code{labelVariable = "Hybridization_Name"}.
}
 \item{hybName}{
character string. indicating the phenotype variable \code{Hybridization_Name}.
}
  \item{requireLog2}{
logical. \code{requiredLog2=TRUE} indicates probe expression levels
will be log2 transformed. Otherwise, no transformation will be performed.
}
  \item{corFlag}{
logical. Indicating if correlation matrix (\code{corFlag=TRUE}) or covariance (\code{corFlag=FALSE}) is used to obtain 
principal components.
}

}
\value{
A list with 3 elements:
  \item{es.s }{An \code{ExpressionSet} object with the arrays sorted according
to Batch_Run_Date, Chip_Barcode, and Chip_Address
 }
  \item{pcs }{An object returned by the function \code{prcomp} of the R
package \code{stats}. It contans the following components. \code{sdev} (the square roots of the eigenvalues 
of the covariance/correlation matrix); \code{rotation} (a matrix whose columns contain the eigenvectors);
  \code{x} (a matrix whose columns contain principal components); \code{center} (the centering used or \code{FALSE});
\code{scale} (the scale used or \code{FALSE})}
  \item{requireLog2 }{logical. The same value as the input \code{requireLog2}.}
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

    pca.obj = getPCAFunc(es = es.sim, 
               labelVariable = "subjID", 
               hybName = "memSubj",
               requireLog2 = FALSE,
               corFlag = FALSE
    )
}
\keyword{ methods }

\name{LumiBatch2Table}
\alias{LumiBatch2Table}
\title{
Output slots (exprs, pData, fData) of an LumiBatch object into 3 text files
}
\description{
Output slots (exprs, pData, fData) of an LumiBatch object into 3 text files.
}
\usage{
LumiBatch2Table(
  es, 
  probeID.var="ProbeID",
  gene.var="Symbol",
  chr.var="Chromosome",
  sep = ",", 
  quote = FALSE,
  filePrefix = "test", 
  fileExt = "csv")
}
\arguments{
  \item{es}{
An LumiBatch object
}
  \item{probeID.var}{
character string. Name of the variable indicating probe ID in feature
data set.
}
  \item{gene.var}{
character string. Name of the variable indicating gene symbol in feature
data set.
}
  \item{chr.var}{
character string. Name of the variable indicating chromosome number in feature
data set.
}
  \item{sep}{
Field delimiter for the output text files
}
  \item{quote}{
  logical. Indicating if any character or factor. See also \code{\link{write.table}}.  
  }
  \item{filePrefix}{
Prefix of the names of the output files.
}
  \item{fileExt}{
File extension of the names of the output files.
}
}
\details{
Suppose \code{filePrefix="test"} and \code{fileExt=".csv"}.
Then, the file names of the 3 output files are:
\dQuote{test_exprs.csv}, \dQuote{test_pDat.csv}, 
and \dQuote{test_fDat.csv}, respectively.
}
\value{
None.
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

   LumiBatch2Table(
    es = es.sim, 
    probeID.var="probe",
    gene.var="gene",
    chr.var="chr",
    sep = ",", 
    quote = FALSE,
    filePrefix = "test", 
    fileExt = "csv")

}
\keyword{ methods }

\name{quantilePlot}
\alias{quantilePlot}
\title{
Plot trajectories of quantiles across arrays
}
\description{
Plot trajectories of quantiles across arrays.
}
\usage{
quantilePlot(
    dat, 
    fileName, 
    probs = c(0, 0.05, 0.25, 0.5, 0.75, 0.95, 1), 
    plotOutPutFlag = FALSE, 
    requireLog2 = FALSE, 
    sortFlag = TRUE,
    cex = 1, 
    ylim = NULL, 
    xlab = "", 
    ylab = "intensity", 
    lwd = 3, 
    main = "Trajectory plot of quantiles", 
    mar = c(15, 4, 4, 2) + 0.1, 
    las = 2, 
    cex.axis = 1)
}
\arguments{
  \item{dat}{
Expression data. Rows are gene probes; columns are arrays.
}
  \item{fileName}{
File name of output figure.
}
  \item{probs}{
quantiles (any real values between the interval \eqn{[0, 1]}).
}
  \item{plotOutPutFlag}{
logical. \code{plotOutPutFlag=TRUE} indicates the plots will be output
to pdf format files. Otherwise, the plots will not be output
to external files.
}
  \item{requireLog2}{
logical. \code{requiredLog2=TRUE} indicates probe expression levels
will be log2 transformed. Otherwise, no transformation will be performed.
}
  \item{sortFlag}{
logical. \code{sortFlag=TRUE} indicates arrays will be sorted by 
the ascending order of MAD (median absolute deviation)
}
  \item{cex}{
 numerical value giving the amount by which plotting text
          and symbols should be magnified relative to the default.
see \code{\link{par}}.
}
  \item{ylim}{
Range of y axis.
}
  \item{xlab}{
Label of x axis.
}
  \item{ylab}{
Label of y axis.
}
  \item{lwd}{
The line width, a _positive_ number, defaulting to '1'.
see \code{\link{par}}.
}
  \item{main}{
Charater string. main title of the plot.
}
  \item{mar}{
A numerical vector of the form 'c(bottom, left, top, right)'
          which gives the number of lines of margin to be specified on
          the four sides of the plot.  The default is 'c(5, 4, 4, 2) +
          0.1'. see \code{\link{par}}.
}
  \item{las}{
 'las' numeric in {0,1,2,3}; the style of axis labels.
          0 - always parallel to the axis,
          1 - always horizontal,
          2 - always perpendicular to the axis,
          or 3 - always vertical.

see \code{\link{par}}.
}
  \item{cex.axis}{
The magnification to be used for axis annotation relative to the current
setting of cex.

see \code{\link{par}}.
}
}
\value{
The quantile matrix with row quantiles and column array. 
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)


   png(file="qplot.png")

     quantilePlot(
       dat = exprs(es.sim), 
       probs = c(0, 0.05, 0.25, 0.5, 0.75, 0.95, 1), 
       plotOutPutFlag = FALSE, 
       requireLog2 = FALSE, 
       sortFlag = TRUE)

   dev.off()
  
}
\keyword{ methods }

\name{genExprSet}
\alias{genExprSet}
\title{
Generate an ExpressionSet object
}
\description{
Generate a simple ExpressionSet object.
}
\usage{
genExprSet(
  ex, 
  pDat, 
  fDat = NULL, 
  annotation = "lumiHumanAll.db")
}
\arguments{
  \item{ex}{
A matrix of expression levels. Rows are gene probes
and columns are arrays. 
}
  \item{pDat}{
A data frame describing arrays. Rows are arrays and columns are variables
describing arrays. The row names of \code{pDat} must be the
same as the column of \code{ex}.
}
  \item{fDat}{
A data frame describing gene probes. Rows are gene probes and columns
are variables describing gene probes. The rownames of \code{fDat}
must be the same as that of \code{ex}.
}
  \item{annotation}{
character string. Indicating the annotation library 
(e.g. \code{lumiHumanAll.db} for the gene probes.
}
}
\value{
an ExpressionSet object.
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>

}
\keyword{ methods }

\name{lmFitPaired}
\alias{lmFitPaired}
\title{
A wrapper function for the function 'lmFit' of the R Bioconductor package
'limma' for paired data
}
\description{
A wrapper function for the function 'lmFit' of the R Bioconductor package
'limma' for paired data.
}
\usage{
lmFitPaired(
    esDiff, 
    formula = ~1, 
    pos.var.interest = 0,
    pvalAdjMethod = "fdr", 
    alpha = 0.05, 
    probeID.var="ProbeID", 
    gene.var = "Symbol", 
    chr.var = "Chromosome", 
    verbose = TRUE)
}
\arguments{
  \item{esDiff}{
An LumiBatch object containing log2 difference between cases and controls.
\code{fData(esDiff)} should
contains information about probe ID, chromosome number and gene symbol.
}
  \item{formula}{
An object of class \code{formula}. The intercept measures the 
effect of treatment. Other covariates measure the effects of 
their interaction and treatment. 
The p-values for the intercept will be output.
No left handside of \code{~} should be specified since the response variable
will be the expression level. 
}
  \item{pos.var.interest}{
integer. Indicates which covariate on the right-hand-side of \code{~}
in \code{formula} is the covariate of the interest. By default, it is
the intercept \code{pos.var.interest=0}. 
} 
  \item{pvalAdjMethod}{
One of p-value adjustment methods provided by
the R function \code{p.adjust} in R package \code{stats}:
\dQuote{holm}, \dQuote{hochberg}, \dQuote{hommel}, 
\dQuote{bonferroni}, \dQuote{BH}, \dQuote{BY}, \dQuote{fdr}, 
\dQuote{none}.
}
  \item{alpha}{
Significance level. A test is claimed to be significant
if the adjusted p-value \eqn{<} \code{alpha}.
}
  \item{probeID.var}{
character string. Name of the variable indicating probe ID in feature
data set.
}

  \item{gene.var}{
character string. Name of the variable indicating gene symbol in feature
data set.
}
  \item{chr.var}{
character string. Name of the variable indicating chromosome number in feature
data set.
}
  \item{verbose}{
logical. Determine if intermediate output need to be suppressed. By default
\code{verbose=TRUE},
intermediate output will be printed.
}
}
\details{
This is a wrapper function of R Bioconductor functions
\code{lmFit} and \code{eBayes} for paired data 
to make it easier to input design and 
output list of significant results.
}
\value{
A list with the following elements:
\item{n.sig }{Number of significant tests after p-value adjustment.}

\item{frame }{A data frame containing test results sorted according
to the ascending order of unadjusted p-values for the intercept. 
The data frame contains
7 columns: \code{probeIDs}, 
\code{geneSymbols} (gene symbols of the genes where the probes come from),
\code{chr} (numbers of chromosomes where the probes locate),
\code{stats} (moderated t-statistics for the intercept), 
\code{pval} (p-values of the tests for the intercept),
\code{p.adj} (adjusted p-values), \code{pos} (row numbers of the probes in 
the expression data matrix).}

\item{statMat}{A matrix containing test statistics for all covariates
and for all probes. Rows are probes and columns are covariates.
The rows are ordered according
to the ascending order of unadjusted p-values for the intercept.
}

\item{pvalMat}{A matrix containing pvalues for all covariates
and for all probes. Rows are probes and columns are covariates.
The rows are ordered according
to the ascending order of unadjusted p-values for the intercept.
}

\item{pval.quantile}{
Quantiles (minimum, 25%, median, 75%, and maximum) of p-values
for all covariates including intercept provided in the
input argument \code{formula}.

}

\item{frame.unsorted }{A data frame containing test results. 
The data frame contains
7 columns: \code{probeIDs}, 
\code{geneSymbols} (gene symbols of the genes where the probes come from),
\code{chr} (numbers of chromosomes where the probes locate),
\code{stats} (moderated t-statistics for the intercept), 
\code{pval} (p-values of the tests for the intercept),
\code{p.adj} (adjusted p-values), \code{pos} (row numbers of the probes in 
the expression data matrix).}

\item{statMat.unsorted}{A matrix containing test statistics for all covariates
and for all probes. Rows are probes and columns are covariates.
}

\item{pvalMat.unsorted}{A matrix containing pvalues for all covariates
and for all probes. Rows are probes and columns are covariates.
}

\item{memGenes}{A numeric vector indicating the cluster membership 
of probes (unsorted). 
\code{memGenes[i]=1} if the \eqn{i}-th probe is significant (adjusted pvalue \eqn{<} \code{alpha}) with 
positive moderated t-statistic; 
\code{memGenes[i]=2} if the \eqn{i}-th probe is nonsignificant ; 
\code{memGenes[i]=3} if the \eqn{i}-th probe is significant with 
negative moderated t-statistic; 
}
\item{memGenes2}{
A numeric vector indicating the cluster membership 
of probes (unsorted). 
\code{memGenes2[i]=1} if the \eqn{i}-th probe is significant (adjusted pvalue \eqn{<} \code{alpha}). 
\code{memGenes2[i]=0} if the \eqn{i}-th probe is nonsignificant. 
}
\item{mu1}{
Mean expression levels for arrays for probe cluster 1 
(average taking across all probes with \code{memGenes} value equal to 1.
}
\item{mu2}{
Mean expression levels for arrays for probe cluster 2 
(average taking across all probes with \code{memGenes} value equal to 2.
}
\item{mu3}{
Mean expression levels for arrays for probe cluster 3 
(average taking across all probes with \code{memGenes} value equal to 3.
}

\item{ebFit}{object returned by R Bioconductor function \code{eBayes}.
}

}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

  # although the generated data is not from 
  # paired design, we use it to illusrate the
  # usage of the function lmFitPaired 


res.limma = lmFitPaired(
  es = es.sim, 
  formula = ~as.factor(memSubj), 
  pos.var.interest = 0, # the intercept is what we are interested
  pvalAdjMethod = "fdr", 
  alpha = 0.05, 
  probeID.var = "probe", 
  gene.var = "gene", 
  chr.var = "chr", 
  verbose = TRUE)
}
\keyword{ methods }

\name{sortExpressionSet}
\alias{sortExpressionSet}
\title{
Sort the order of samples for an ExpressionSet object
}
\description{
Sort the order of samples for an ExpressionSet object.
}
\usage{
sortExpressionSet(
    es, 
    varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
    timeFormat = c("\%m/\%d/\%Y", NA, NA)
)
}
\arguments{
  \item{es}{
An ExpressionSet.
}
  \item{varSort}{
A vector of phenotype variable names to be used to sort the samples
of \code{es}.
}
  \item{timeFormat}{
A vector of time format for the possible time variables in \code{varSort}.
The length of \code{timeFormat} should be the same as that
of \code{varSort}. For non-time variable, the corresponding time format
should be set to be equal to \code{NA}. Please refer to function  
\code{\link{strptime}} of the \code{base} package.
}
}
\value{
An ExpressionSet object with samples sorted based on the variables
indicated in \code{varSort}.
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

  es.sim$Batch_Run_Date = 1:ncol(es.sim)
  es.sim$Chip_Barcode = 1:ncol(es.sim)
  es.sim$Chip_Address = 1:ncol(es.sim)
  

  es.sim2 = sortExpressionSet(
    es = es.sim, 
    varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
    timeFormat = c("\%m/\%d/\%Y", NA, NA)
  )
  
}
\keyword{ methods }

\name{genSimData.BayesNormal}
\alias{genSimData.BayesNormal}
\title{
Generating simulated data set from conditional normal distributions
}
\description{
Generating simulated data set from conditional normal distributions.
}
\usage{
genSimData.BayesNormal(
  nCpGs, 
  nCases, 
  nControls,
  mu.n = -2,
  mu.c = 2,
  d0 = 20, 
  s02 = 0.64,
  s02.c = 1.5,
  testPara = "var", 
  outlierFlag = FALSE,
  eps = 0.001, 
  applier = lapply)
}
\arguments{
  \item{nCpGs}{
integer. Number of genes.
}
  \item{nCases}{
integer. Number of cases.
}
  \item{nControls}{
integer. Number of controls.
}
  \item{mu.n}{
numeric. mean of the conditional normal distribution for controls. See details.
}
  \item{mu.c}{
numeric. mean of the conditional normal distribution for cases. See details.
}
  \item{d0}{
integer. degree of freedom for scale-inverse chi squared distribution.
See details.
}
  \item{s02}{
numeric. scaling parameter for scale-inverse chi squared distribution
for controls. See details.
}
  \item{s02.c}{
numeric. scaling parameter for scale-inverse chi squared distribution
for cases. See details.
}
  \item{testPara}{
character string. indicating if the test is for testing equal mean,
equal variance, or both.
}
  \item{outlierFlag}{
logical. indicating if outliers would be generated. If \code{outlierFlag=TRUE},
then we followed Phipson and Oshlack's (2014) simulation studies to 
generate one outlier for each CpG site by replacing the DNA methylation 
level of one diseased subject by the maximum of the DNA methylation levels 
of all CpG sites.
}
  \item{eps}{
numeric. if \eqn{|mean0-mean1|<eps} then we regard \eqn{mean0=mean1}.
Similarly, 
if \eqn{|var0-var1|<eps} then we regard \eqn{var0=var1}.
\eqn{mean0} and \eqn{var0} are the mean and variance of
the chi squared distribution for controls.
\eqn{mean1} and \eqn{var1} are the mean and variance of
the chi squared distribution for cases.
}
  \item{applier}{
function name to do \code{apply} operation.
}
}
\details{
Based on Phipson and Oshlack's (2014) simulation algorithm.
 For each CpG site, variance of the DNA methylation was first sampled from an
   scaled inverse chi-squared distribution with degree of freedom 
\eqn{d_0} and scaling parameter \eqn{s_0^2}:
      \eqn{\sigma^2_i ~ scale-inv \chi^2(d_0, s_0^2)}.
  M value for each CpG was then sampled from a normal distribution
    with mean \eqn{\mu_n} and variance equal to the simulated variance 
\eqn{\sigma^2_i}.
For cases, the variance was first generated from
      \eqn{\sigma^2_{i,c} ~ scale-inv \chi^2(d_0, s_{0,c}^2)}.
  M value for each CpG was then sampled from a normal distribution
    with mean \eqn{\mu_c} and variance equal to the simulated variance 
\eqn{\sigma^2_{i,c}}.
}
\value{
An ExpressionSet object. The phenotype data of the ExpressionSet object
contains 2 columns: \code{arrayID} (array id) and {memSubj} (subject
membership, i.e., case (\code{memSubj=1}) or control (\code{memSubj=0})).
The feature data of the ExpressionSet object contains 4 elements:
\code{probe} (probe id), \code{gene} (psuedo gene symbol), \code{chr}
(psuedo chromosome number), and \code{memGenes}
(indicating if a gene is differentially expressed (when \code{testPara="mean"})
or indicating if a gene is differentially variable (when \code{testPara="var"}) ).

}
\references{
    Phipson B, Oshlack A. 
    DiffVar: A new method for detecting differential variability with application to methylation in cancer and aging. 
    \emph{Genome Biol} 2014; 15:465
}
\author{
	Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

}
\keyword{ method }

\name{glmWrapper}
\alias{glmWrapper}
\title{
Perform glm test for all gene probes
}
\description{
Perform glm test for all gene probes.
}
\usage{
glmWrapper(es, 
           formula = FEV1 ~ xi + age + gender, 
           pos.var.interest = 1,
           family = gaussian, 
           logit = FALSE, 
           pvalAdjMethod = "fdr", 
           alpha = 0.05, 
           probeID.var = "ProbeID", 
           gene.var = "Symbol", 
           chr.var = "Chromosome", 
           applier = lapply,
           verbose = TRUE) 
}
\arguments{
  \item{es}{
An LumiBatch object.
\code{fData(es)} should
contains information about probe ID, chromosome number and gene symbol.
}
  \item{formula}{
An object of class \code{formula}. 
The left handside of \code{~} is the response variable. 
Gene probe must be represented by the variable \code{xi}.
For example, \code{xi~age+gender} (gene probe is the response variable);
Or \code{FEV1~xi+age+gender} (gene probe is the predictor).
}
  \item{pos.var.interest}{ integer. Indicates which covariate
in the right-hand-size of \code{~} of \code{formula} is of
the interest.
pos.var.interest \eqn{= 0} means the intercept is of the interest.
If the covariate of the interest is an factor or interaction term 
with more than 2 levels, the smallest p-value will represent
the pvalue for the covariate of the interest.  
}
  \item{family}{
By default is gaussian. refer to \code{\link{glm}}.
}
  \item{logit}{
logical. Indicate if the gene probes will be logit transformed.
For example, for DNA methylation data, one might want to logit transformation
for the beta-value (\eqn{methylated/(methylated+unmethylated)}).
}
  \item{pvalAdjMethod}{
One of p-value adjustment methods provided by
the R function \code{p.adjust} in R package \code{stats}:
\dQuote{holm}, \dQuote{hochberg}, \dQuote{hommel}, 
\dQuote{bonferroni}, \dQuote{BH}, \dQuote{BY}, \dQuote{fdr}, 
\dQuote{none}.
}
  \item{alpha}{
Significance level. A test is claimed to be significant
if the adjusted p-value \eqn{<} \code{alpha}.
}

  \item{probeID.var}{
character string. Name of the variable indicating probe ID in feature
data set.
}

  \item{gene.var}{
character string. Name of the variable indicating gene symbol in feature
data set.
}
  \item{chr.var}{
character string. Name of the variable indicating chromosome number in feature
data set.
}
  \item{applier}{
By default, it is lapply. If the library multicore is available,
can use mclapply to replace lappy.
}
  \item{verbose}{
logical. Determine if intermediate output need to be suppressed. By default
\code{verbose=TRUE},
intermediate output will be printed.
}

}
\details{
This function applies R function \code{glm}
for each gene probe.
}
\value{
A list with the following elements:
\item{n.sig }{Number of significant tests after p-value adjustment.}

\item{frame }{A data frame containing test results sorted according
to the ascending order of unadjusted p-values for the covariate 
of the interest. The data frame contains
7 columns: \code{probeIDs}, \code{geneSymbols} (gene symbols of the genes where the probes come from),
\code{chr} (numbers of chromosomes where the probes locate),
\code{stats} (z-value), \code{pval} (p-values of the tests for the covariate
of the interest),
\code{p.adj} (adjusted p-values), \code{pos} (row numbers of the probes in 
the expression data matrix).}

\item{statMat}{A matrix containing test statistics for all covariates
and for all probes. Rows are probes and columns are covariates.
The rows are ordered according
to the ascending order of unadjusted p-values for the 
covariate of the interest.
}

\item{pvalMat}{A matrix containing pvalues for all covariates
and for all probes. Rows are probes and columns are covariates.
The rows are ordered according
to the ascending order of unadjusted p-values for the covariate
of the interest.
}

\item{pval.quantile}{
Quantiles (minimum, 25%, median, 75%, and maximum) of p-values
for each covariate including intercept provided in the
input argument \code{formula}.

}

\item{frame.unsorted }{A data frame containing test results. 
The data frame contains
7 columns: \code{probeIDs}, \code{geneSymbols} 
(gene symbols of the genes where the probes come from),
\code{chr} (numbers of chromosomes where the probes locate),
\code{stats} (z-value for the covariate of the interest), 
\code{pval} (p-values of the tests for the covariate of the interest),
\code{p.adj} (adjusted p-values), \code{pos} (row numbers of the probes in 
the expression data matrix).}

\item{statMat.unsorted}{A matrix containing test statistics for all covariates
and for all probes. Rows are probes and columns are covariates.
}

\item{pvalMat.unsorted}{A matrix containing pvalues for all covariates
and for all probes. Rows are probes and columns are covariates.
}

\item{memGenes}{A numeric vector indicating the cluster membership 
of probes (unsorted). 
\code{memGenes[i]=1} if the \eqn{i}-th probe is significant (adjusted pvalue \eqn{<} \code{alpha}) with 
positive z-value for the covariate of the interest; 
\code{memGenes[i]=2} if the \eqn{i}-th probe is nonsignificant ; 
\code{memGenes[i]=3} if the \eqn{i}-th probe is significant with 
negative z-value for the covariate of the interest; 
}
\item{memGenes2}{
A numeric vector indicating the cluster membership 
of probes (unsorted). 
\code{memGenes2[i]=1} if the \eqn{i}-th probe is significant (adjusted pvalue \eqn{<} \code{alpha}). 
\code{memGenes2[i]=0} if the \eqn{i}-th probe is nonsignificant. 
}
\item{mu1}{
Mean expression levels for arrays for probe cluster 1 
(average taking across all probes with \code{memGenes} value equal to 1.
}
\item{mu2}{
Mean expression levels for arrays for probe cluster 2 
(average taking across all probes with \code{memGenes} value equal to 2.
}
\item{mu3}{
Mean expression levels for arrays for probe cluster 3 
(average taking across all probes with \code{memGenes} value equal to 3.
}

\item{resMat}{A matrix with \eqn{2p} columns, where \eqn{p} 
is the number of covariates (including intercept; for a nominal variable
with 3 levels say, there were 2 dummy covariates). 
The first \eqn{p} columns are p-values. The remaining \eqn{p}
columns are test statistics.
}
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\note{
If the covariate of the interest is a factor or interaction term
with more than 2 levels, then the p-value of the likelihood ratio test
might be more appropriate than the smallest p-value for 
the covariate of the interest.
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

   res.glm = glmWrapper(
  es = es.sim, 
  formula = xi~as.factor(memSubj), 
  pos.var.interest = 1,
  family = gaussian, 
  logit = FALSE, 
  pvalAdjMethod = "fdr", 
  alpha = 0.05, 
  probeID.var = "probe", 
  gene.var = "gene", 
  chr.var = "chr", 
  applier = lapply,
  verbose = TRUE) 


}
\keyword{ methods }

\name{boxPlots}
\alias{boxPlots}
\title{
Draw parallel plots for top results in whole-genome-wide analysis
}
\description{
Draw scatter plots for top results in whole-genome-wide analysis to
test for the association of probes to a continuous-type phenotype
variable.
}
\usage{
boxPlots(
  resFrame, 
  es, 
  col.resFrame = c("probeIDs", "stats", "pval", "p.adj"), 
  var.pheno = "sex", 
  var.probe = "TargetID", 
  var.gene = "Symbol", 
  var.chr = "Chr", 
  nTop = 20, 
  myylab = "expression level", 
  datExtrFunc = exprs, 
  fileFlag = FALSE, 
  fileFormat = "ps", 
  fileName = "boxPlots.ps")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{resFrame}{
A data frame stores testing results, which must contain columns
that indicate probe id, test statistic, p-value and optionally 
adjusted p-value.
}
  \item{es}{
An \code{ExpressionSet} object that used to run the 
whole genome-wide tests.
}
  \item{col.resFrame}{
A vector of characters indicating column names of \code{resFrame}
corresponding to probe id, test statistic, p-value and optionally
adjusted p-value.
}
  \item{var.pheno}{
character. the name of continuous-type phenotype variable that is used to
test the association of this variable to probes.
}
  \item{var.probe}{
character. the name of feature variable indicating probe id.
}
  \item{var.gene}{
character. the name of feature variable indicating gene symbol.
}
  \item{var.chr}{
character. the name of feature variable indicating chromosome number.
}
  \item{nTop}{
integer. indicating how many top tests will be used to draw
the scatter plot.
}
  \item{myylab}{
character. indicating y-axis label.
}
  \item{datExtrFunc}{
name of the function  to extract genomic data. For
an \code{ExpressionSet} object, you should set
\code{datExtrFunc=exprs}; for a \code{MethyLumiSet} object,
you should set \code{datExtrFunc=betas}.
}
  \item{fileFlag}{
logic. indicating if plot should be saved to an external figure file.
}
  \item{fileFormat}{
character. indicating the figure file type. Possible values are \dQuote{ps}, \dQuote{pdf},
or \dQuote{jpeg}. All other values will produce \dQuote{png} file.
}
  \item{fileName}{
character. indicating figure file name (file extension should be specified). For example,
you set \code{fileFormat="pdf"}, then you can set \code{fileName="test.pdf"}, but not
\code{fileName="test"}.
}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
Value \code{0} will be returned if no error occurs.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>

}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
  # generate simulated data set from conditional normal distribution
  set.seed(1234567)
  es.sim = genSimData.BayesNormal(nCpGs = 100, 
    nCases = 20, nControls = 20,
    mu.n = -2, mu.c = 2,
    d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
    outlierFlag = FALSE, 
    eps = 1.0e-3, applier = lapply) 
  print(es.sim)

  res.limma = lmFitWrapper(
    es = es.sim, 
    formula = ~as.factor(memSubj), 
    pos.var.interest = 1,
    pvalAdjMethod = "fdr", 
    alpha = 0.05, 
    probeID.var = "probe", 
    gene.var = "gene", 
    chr.var = "chr", 
    verbose = TRUE)

  boxPlots(
    resFrame=res.limma$frame, 
    es=es.sim, 
    col.resFrame = c("probeIDs", "stats", "pval"), 
    var.pheno = "memSubj", 
    var.probe = "probe", 
    var.gene = "gene", 
    var.chr = "chr", 
    nTop = 20, 
    myylab = "expression level", 
    datExtrFunc = exprs, 
    fileFlag = FALSE, 
    fileFormat = "ps", 
    fileName = "boxPlots.ps")

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ method }% use one of  RShowDoc("KEYWORDS")

\name{densityPlots}
\alias{densityPlots}
\title{
Draw estimated density plots for all arrays
}
\description{
Draw estimated density plots for all arrays.
}
\usage{
densityPlots(
  es, 
  requireLog2 = TRUE, 
  myxlab = "expression level", 
  mymain = "density plots", 
  datExtrFunc = exprs, 
  fileFlag = FALSE, 
  fileFormat = "ps", 
  fileName = "densityPlots.ps")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{es}{
An \code{ExpressionSet} object that used to run the 
whole genome-wide tests.
}
  \item{requireLog2}{
logic. indicating if log2 transformation is required before estimating densities.
}
  \item{myxlab}{
character. indicating x-axis label.
}
  \item{mymain}{
character. indicating title of the plot.
}
  \item{datExtrFunc}{
name of the function  to extract genomic data. For
an \code{ExpressionSet} object, you should set
\code{datExtrFunc=exprs}; for a \code{MethyLumiSet} object,
you should set \code{datExtrFunc=betas}.
}
  \item{fileFlag}{
logic. indicating if plot should be saved to an external figure file.
}
  \item{fileFormat}{
character. indicating the figure file type. Possible values are \dQuote{ps}, \dQuote{pdf},
or \dQuote{jpeg}. All other values will produce \dQuote{png} file.
}
  \item{fileName}{
character. indicating figure file name (file extension should be specified). For example,
you set \code{fileFormat="pdf"}, then you can set \code{fileName="test.pdf"}, but not
\code{fileName="test"}.
}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
A list object, the \eqn{i}-th element is the object returned by
function \code{density} for the \eqn{i}-th array.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
  # generate simulated data set from conditional normal distribution
  set.seed(1234567)
  es.sim = genSimData.BayesNormal(nCpGs = 100, 
    nCases = 20, nControls = 20,
    mu.n = -2, mu.c = 2,
    d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
    outlierFlag = FALSE, 
    eps = 1.0e-3, applier = lapply) 
  print(es.sim)

  densityPlots(
    es = es.sim, 
    requireLog2 = FALSE, 
    myxlab = "expression level", 
    mymain = "density plots", 
    datExtrFunc = exprs, 
    fileFlag = FALSE, 
    fileFormat = "ps", 
    fileName = "densityPlots.ps")
  
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ method }% use one of  RShowDoc("KEYWORDS")

\name{R2PlotFunc}
\alias{R2PlotFunc}
\title{
Draw heatmap of square of correlations among arrays
}
\description{
Draw heatmap of square of correlations among arrays.
}
\usage{
R2PlotFunc(
    es, 
    hybName = "Hybridization_Name",
    arrayType = c("all", "replicates", "GC"), 
    GCid = c("128115", "Hela", "Brain"),
    probs = seq(0, 1, 0.25), 
    col = gplots::greenred(75), 
    labelVariable = "subjID", 
    outFileName = "test_R2_raw.pdf", 
    title = "Raw Data R^2 Plot", 
    requireLog2 = FALSE, 
    plotOutPutFlag = FALSE, 
    las = 2, 
    keysize = 1, 
    margins = c(10, 10), 
    sortFlag = TRUE,
    varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
    timeFormat=c("\%m/\%d/\%Y", NA, NA),
    ...)
}
\arguments{
  \item{es}{
ExpressionSet object of QC probe profiles.
}
  \item{hybName}{
character string. indicating the phenotype variable \code{Hybridization_Name}.
}
  \item{arrayType}{
A character string indicating if the correlations
are calculated based on all arrays, arrays with replicates,
or genetic control arrays. 
}
  \item{GCid}{
A vector of character string. symbols for genetic control samples. The symbols
can be more than one.
}
  \item{probs}{
A vector of probabilities specify the quantiles of correlations
to be output.
}
  \item{col}{
colors used for the image. see the function \code{\link{heatmap.2}}
in R package \code{gplots}.
}
  \item{labelVariable}{
A character string indicating how to label the arrays.
}
  \item{outFileName}{
A character string.
The name of output file.
}
  \item{title}{
Title of the plot.
}
  \item{requireLog2}{
logical. \code{requiredLog2=TRUE} indicates probe expression levels
will be log2 transformed. Otherwise, no transformation will be performed.
}
  \item{plotOutPutFlag}{
logical. \code{plotOutPutFlag=TRUE} indicates the plots will be output
to pdf format files. Otherwise, the plots will not be output
to external files.
}
  \item{las}{
 'las' numeric in {0,1,2,3}; the style of axis labels.
          0 - always parallel to the axis,
          1 - always horizontal,
          2 - always perpendicular to the axis,
          or 3 - always vertical.

see \code{\link{par}}.
}
  \item{keysize}{
numeric value indicating the size of the key.
see the function \code{\link{heatmap.2}}
in R package \code{gplots}.
}
  \item{margins}{
numeric vector of length 2 containing the margins.
see the function \code{\link{heatmap.2}}
in R package \code{gplots}.
}
  \item{sortFlag}{
logical. Indicates if arrays need to be sorted according to 
\code{Batch_Run_Date}, \code{Chip_Barcode}, and \code{Chip_Address}.

}
  \item{varSort}{
A vector of phenotype variable names to be used to sort the samples
of \code{es}.
}
  \item{timeFormat}{
A vector of time format for the possible time variables in \code{varSort}.
The length of \code{timeFormat} should be the same as that
of \code{varSort}. For non-time variable, the corresponding time format
should be set to be equal to \code{NA}. The details of the time format
for time variable can be found in the R function \code{\link{strptime}}.
}
  \item{\dots}{
Arguments to be passed to \code{\link{heatmap.2}}.
}
}
\value{
A list with 3 elments. The first element \code{R2Mat} is 
the matrix of squared correlation.
The second element \code{R2vec} is the vector of 
the upper triangle of the matrix
of squared correlation (diagnoal elements are excluded).
The third element \code{R2vec.within.req} is the vector of 
within-replicate \eqn{R^2},
that is, any element in \code{R2vec.within.req} is the squared correlation
coefficient between two arrays/replicates for a subject.
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

    es.sim$Batch_Run_Date = 1:ncol(es.sim)
    es.sim$Chip_Barcode = 1:ncol(es.sim)
    es.sim$Chip_Address = 1:ncol(es.sim)
  
    # draw heatmap for the first 5 subjects
    png(file="r2plot.png")
    R2PlotFunc(
      es = es.sim[, 1:5], 
      hybName = "memSubj",
      arrayType = c("all", "replicates", "GC"), 
      GCid = c("128115", "Hela", "Brain"),
      probs = seq(0, 1, 0.25), 
      col = gplots::greenred(75), 
      labelVariable = "subjID", 
      outFileName = "test_R2_raw.pdf", 
      title = "Raw Data R^2 Plot", 
      requireLog2 = FALSE, 
      plotOutPutFlag = FALSE, 
      las = 2, 
      keysize = 1, 
      margins = c(10, 10), 
      sortFlag = TRUE,
      varSort=c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
      timeFormat=c("\%m/\%d/\%Y", NA, NA))
    dev.off()
        
}
\keyword{ methods  }

\name{plotQCCurves}
\alias{plotQCCurves}
\title{
Plot trajectories of specific QC probes (e.g., biotin, cy3_hyb, housekeeping
gene probes, low stringency probes, etc.) across arrays
}
\description{
Plot trajectories of specific QC probes (e.g., biotin, cy3_hyb, housekeeping
gene probes, low stringency probes, etc.) across arrays
}
\usage{
plotQCCurves(
    esQC, 
    probes = c("biotin", "cy3_hyb", "housekeeping", 
      "low_stringency_hyb", "signal", "p95p05"), 
    labelVariable = "subjID",
    hybName = "Hybridization_Name",
    reporterGroupName = "Reporter_Group_Name",
    requireLog2 = TRUE, 
    projectName = "test", 
    plotOutPutFlag = FALSE, 
    cex = 1, 
    ylim = NULL, 
    xlab = "", 
    ylab = "intensity", 
    lwd = 3, 
    mar = c(10, 4, 4, 2) + 0.1,
    las = 2,
    cex.axis = 1,
    sortFlag = TRUE,
    varSort = c("Batch_Run_Date", "Chip_Barcode", "Chip_Address"), 
    timeFormat = c("\%m/\%d/\%Y", NA, NA),
    ...)
}
\arguments{
  \item{esQC}{
ExpressionSet object of QC probe profiles. \code{fData(esQC)} should
contains the variable \code{Reporter_Group_Name}. 
}
  \item{probes}{
A character vectors of QC probe names. By default, it includes
the following probe names \dQuote{biotin}, \dQuote{cy3_hyb}, 
  \dQuote{housekeeping}, \dQuote{low_stringency_hyb}, 
  \dQuote{signal}, \dQuote{p95p05}. For \dQuote{signal},
trajectories of 5th, 25th, 50th, 75th, and 95th percentiles of
the expression levels of all QC probes will be ploted. 
For \dQuote{p95p05}, the trajectory of the ratio of 95th percentile
to 5th percentile of the expression levels of all QC probes will be ploted.
}
  \item{labelVariable}{
A character string.
The name of a phenotype data variable use to
label the arrays in the boxplots. By default, 
\code{labelVariable = "subjID"} which is equivalent
to \code{labelVariable = "Hybridization_Name"}.
}
\item{hybName}{
character string. indicating the phenotype variable \code{Hybridization_Name}.
}
\item{reporterGroupName}{
character string. indicating feature variable \code{Reporter_Group_Name} (QC probe's name).
}
  \item{requireLog2}{
logical. \code{requiredLog2=TRUE} indicates probe expression levels
will be log2 transformed. Otherwise, no transformation will be performed.
}
  \item{projectName}{
A character string. Name of the project. The plots will be saved  as pdf format files,
the names of which have the format
\code{projectName_probeName_traj_plot.pdf}.
}
  \item{plotOutPutFlag}{
logical. \code{plotOutPutFlag=TRUE} indicates the plots will be output
to pdf format files. Otherwise, the plots will not be output
to external files.
}
  \item{cex}{
 numerical value giving the amount by which plotting text
          and symbols should be magnified relative to the default.
see \code{\link{par}}.
}
  \item{ylim}{
Range of y axis.
}
  \item{xlab}{
Label of x axis.
}
  \item{ylab}{
Label of y axis.
}
  \item{lwd}{
The line width, a _positive_ number, defaulting to '1'.
see \code{\link{par}}.
}
  \item{mar}{
A numerical vector of the form 'c(bottom, left, top, right)'
          which gives the number of lines of margin to be specified on
          the four sides of the plot.  The default is 'c(5, 4, 4, 2) +
          0.1'. see \code{\link{par}}.
}
  \item{las}{
 'las' numeric in {0,1,2,3}; the style of axis labels.
          0 - always parallel to the axis,
          1 - always horizontal,
          2 - always perpendicular to the axis,
          or 3 - always vertical.

see \code{\link{par}}.
}
  \item{cex.axis}{
The magnification to be used for axis annotation relative to the current
setting of cex.

see \code{\link{par}}.
}
  \item{sortFlag}{
logical. Indicates if arrays need to be sorted according to 
\code{Batch_Run_Date}, \code{Chip_Barcode}, and \code{Chip_Address}.

}
  \item{varSort}{
A vector of phenotype variable names to be used to sort the samples
of \code{es}.
}
  \item{timeFormat}{
A vector of time format for the possible time variables in \code{varSort}.
The length of \code{timeFormat} should be the same as that
of \code{varSort}. For non-time variable, the corresponding time format
should be set to be equal to \code{NA}.
}

  \item{\dots}{
Arguments to be passed to \code{\link{plot}}.
}
}
\value{
no return value.
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    esQC.sim = genSimData.BayesNormal(nCpGs = 10, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 

    print(esQC.sim)

    fDat = fData(esQC.sim)
    esQC.sim$Hybridization_Name = sampleNames(esQC.sim)
    fDat$Reporter_Group_Name = c( rep("biotin", 5),
      rep("housekeeping", 5))
    fData(esQC.sim)=fDat

    # plot trajectories of the QC probes
    plotQCCurves(
      esQC = esQC.sim, 
      probes = c("biotin", "housekeeping"), 
      labelVariable = "subjID",
      hybName = "Hybridization_Name",
      reporterGroupName = "Reporter_Group_Name",
      requireLog2 = FALSE, 
      plotOutPutFlag = FALSE, 
      sortFlag = FALSE)

}

\keyword{ methods }

\name{pca3DPlot}
\alias{pca3DPlot}
\title{
Scatter plot of 3 specified principal components
}
\description{
Scatter plot of 3 specified principal components.
}
\usage{
pca3DPlot(pcaObj, 
          plot.dim = c(1,2, 3),
          labelVariable = "subjID", 
           hybName = "Hybridization_Name",
          outFileName = "test_pca_raw.pdf", 
          title = "Scatter plot of pcas", 
          plotOutPutFlag = FALSE, 
          mar = c(5, 4, 4, 2) + 0.1, 
          lwd = 1.5, 
          equalRange = TRUE, 
          xlab = NULL, 
          ylab = NULL, 
          zlab = NULL, 
          xlim = NULL, 
          ylim = NULL, 
          zlim = NULL, 
          cex.legend = 1.5, 
          cex = 1.5, 
          cex.lab = 1.5, 
          cex.axis = 1.5, 
          legendPosition = "topright", 
          ...)
}
\arguments{
  \item{pcaObj}{
An object returned by the function \code{pca} of the R package
\code{pcaMethods}.
}
  \item{plot.dim}{A vector of 3 positive-integer-value integer specifying
which 3 pcas will be plot.
}
  \item{labelVariable}{
The name of a column of the phenotype data matrix. The elements
of the column will replace the column names of the expression data matrix.   
}
 \item{hybName}{
character string. indicating the phenotype variable \code{Hybridization_Name}.
}
  \item{outFileName}{
Name of the figure file to be created.
}
  \item{title}{
Title of the scatter plot.
}
  \item{plotOutPutFlag}{
logical. \code{plotOutPutFlag=TRUE} indicates the plots will be output
to pdf format files. Otherwise, the plots will not be output
to external files.
}
  \item{mar}{
A numerical vector of the form 'c(bottom, left, top, right)'
          which gives the number of lines of margin to be specified on
          the four sides of the plot.  The default is 'c(5, 4, 4, 2) +
          0.1'. see \code{\link{par}}.
}
  \item{lwd}{
The line width, a _positive_ number, defaulting to '1'.
see \code{\link{par}}.
}
  \item{equalRange}{
logical. Indicating if the x-axis and y-axis have the same range.
}
  \item{xlab}{
Label of x axis.
}
  \item{ylab}{
Label of y axis.
}
  \item{zlab}{
Label of z axis.
}
  \item{xlim}{
Range of x axis.
}
  \item{ylim}{
Range of y axis.
}
  \item{zlim}{
Range of z axis.
}
  \item{cex.legend}{
Font size for legend.
}
  \item{cex}{
 numerical value giving the amount by which plotting text
          and symbols should be magnified relative to the default.
see \code{\link{par}}.
}
  \item{cex.lab}{
The magnification to be used for x and y labels relative to the current
setting of cex.
}
  \item{cex.axis}{
The magnification to be used for axis annotation relative to the current
setting of cex.

see \code{\link{par}}.
}
  \item{legendPosition}{
Position of legend.
Possible values are \dQuote{bottomright}, \dQuote{bottom}, 
\dQuote{bottomleft}, \dQuote{left}, \dQuote{topleft},
\dQuote{top}, \dQuote{topright}, \dQuote{right} and \dQuote{center}.
}
  \item{\dots}{
Arguments to be passed to \code{\link{plot}}.
}
}
\value{
A matrix of PCA scores. Each column corresponds to a principal component.
}
\author{
Weiliang Qiu <stwxq@channing.harvard.edu>,
        Brandon Guo <brandowonder@gmail.com>,
        Christopher Anderson <christopheranderson84@gmail.com>,
        Barbara Klanderman <BKLANDERMAN@partners.org>,
        Vincent Carey <stvjc@channing.harvard.edu>,
        Benjamin Raby <rebar@channing.harvard.edu>
}
\examples{
    # generate simulated data set from conditional normal distribution
    set.seed(1234567)
    es.sim = genSimData.BayesNormal(nCpGs = 100, 
      nCases = 20, nControls = 20,
      mu.n = -2, mu.c = 2,
      d0 = 20, s02 = 0.64, s02.c = 1.5, testPara = "var",
      outlierFlag = FALSE, 
      eps = 1.0e-3, applier = lapply) 
    print(es.sim)

    pca.obj = getPCAFunc(es = es.sim, 
                     labelVariable = "subjID", 
                     hybName = "memSubj",
                     requireLog2 = FALSE,
                     corFlag = FALSE
)


pca3DPlot(pcaObj = pca.obj, 
          plot.dim = c(1,2,3),
          labelVariable = "subjID", 
          hybName = "memSubj",
          plotOutPutFlag = FALSE, 
          cex.legend = 0.5, 
          legendPosition = "topright") 
    

}
\keyword{ methods }
